commit bcdbc8cba800137377048c2a5db7fe6d5996f48b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 28 11:05:32 2022 +0200

    release: bump version to 1.26.4

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 8b90b560ff00fc16104e2ab9f8d601f8714f4116
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 28 11:05:07 2022 +0200

    NEWS: update for 1.26.4

 NEWS | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit 2767e859a38281c0e4e4991173045d8d8c9b9280
Author: Bjørn Mork <bjorn@mork.no>
Date:   Sun Mar 27 21:24:15 2022 +0200

    libmbim-glib,net-port-manager: use unaligned netlink attribute length

    Removes the warning

    [  120.780599] netlink: 'ModemManager': attribute type 1 has an
    invalid length.

    caused by using an incorrect aligned length of 8 for the 16 bit
    IFLA_VLAN_ID
    attribute instead of the expected 6.

    Fixes: b2b4b0698351 ("libmbim-glib,device: new link add/delete
    operations")
    Signed-off-by: Bjørn Mork <bjorn@mork.no>
    (cherry picked from commit 43d4022b059ca7199977300a897148eb921cbede)

 src/libmbim-glib/mbim-net-port-manager.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4a3e44727b7ccf7def8ed4f55f7eb94d50f6e461
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:52:54 2022 +0100

    libmbim-glib,doc: include MBIM proxy control service in docs

    There's no reason why this service should be considered fully private;
    the service may be used by other applications wanting to interact with
    the MBIM device but which don't want to use libmbim-glib.

    (cherry picked from commit ed37ceacda9b0523c0759f5ddf3ca6b9e4f29e4f)

 docs/reference/libmbim-glib/Makefile.am           |  1 +
 docs/reference/libmbim-glib/libmbim-glib-docs.xml |  5 +++
 src/libmbim-glib/generated/meson.build            | 50
 +++++++++++------------
 3 files changed, 30 insertions(+), 26 deletions(-)

commit 9e52d30eba29f0b40c3394729de21954efb49284
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:52:36 2022 +0100

    mbim-codegen: add section doc for each service

    (cherry picked from commit b59eef8f0f7b6709bbf55233223648a97e941b88)

 build-aux/mbim-codegen/mbim-codegen |  1 +
 build-aux/mbim-codegen/utils.py     | 21 ++++++++++++++++++++-
 2 files changed, 21 insertions(+), 1 deletion(-)

commit b1405e77c68545d1849ddea63faa83b684d79049
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:33:10 2022 +0100

    libmbim-glib,utils: add missing short description in section

    (cherry picked from commit 056df120dcdbd1ff042a21c3626fc77d782f0776)

 src/libmbim-glib/mbim-utils.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit d08cbcfe160f6cafa54d9e50a3975e6cb5b97f9a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:30:42 2022 +0100

    libmbim-glib,compat: add missing MbimLteAttachStatus doc

    (cherry picked from commit c70d602cd4dbe2e874eb6efd036bf7e523976052)

 src/libmbim-glib/mbim-compat.h | 2 ++
 1 file changed, 2 insertions(+)

commit 22c3ebcbde1ef2ba41b26639be626d397c8a8aac
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:29:26 2022 +0100

    libmbim-glib,device: add missing mbim_device_list_links() doc

    (cherry picked from commit 06beb4e38846a4d4c3ac6913d9321c0dd562fbff)

 src/libmbim-glib/mbim-device.h | 3 +++
 1 file changed, 3 insertions(+)

commit 3df107b092e4e301da4c3abbcab7f48e5f2482d2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:27:54 2022 +0100

    libmbim-glib,device: fix MbimDevice 'device-in-session' property doc

    (cherry picked from commit 048f5ac41ac432e44626d2fec5884ca3345a3839)

 src/libmbim-glib/mbim-device.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3b78f3541ef2d0c4f4a3ca62b41dedc09c9055d9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 22:25:53 2022 +0100

    libmbim-glib,version: add missing MBIM_CHECK_VERSION() documentation

    (cherry picked from commit ea34d57596f23875846d6a1f5d49c795ac0df21a)

 src/libmbim-glib/mbim-version.h.in | 2 ++
 1 file changed, 2 insertions(+)

commit 438bc5327451540e5e64402ff4abee503a3f66c4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 16:06:35 2022 +0100

    libmbim-glib,device: fix wrong reference to QmiDevice

    (cherry picked from commit 3b77dd8c7ac20711bb2ef25ef8f66358cf6586c3)

 src/libmbim-glib/mbim-device.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fe1bd2036ab50b0820b2284dc8c483cd1e741130
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 14 16:01:26 2022 +0100

    build,meson: fix 'export_packages' in GIR setup

    The 'export_packages' field in the generate_gir() command should
    include the name of the pkg-config package being exported, not the
    name of the library file.

    Without this change, building GIR files depending on the one we
    provide here would fail as the corresponding .pc file isn't found.

    (cherry picked from commit f7d516cb03e2af7b432edcc0f21c9ff0ed179a51)

 src/libmbim-glib/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7b2287ad35559a41992c4782e75aff3ec8bcd1b6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jan 10 11:12:59 2022 +0100

    docs: add missing reference to the private
    proxy_control_version_notification_parse()

    (cherry picked from commit 1738e76042a405a91e03de3e00d6dbadbd8e8d8d)

 docs/reference/libmbim-glib/libmbim-glib-common.sections | 1 +
 1 file changed, 1 insertion(+)

commit d40450dbe922c3a82cb89a0a5b6de47943d838c5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jan 6 22:33:09 2022 +0100

    mbim-codegen,struct: add dummy description for each struct type

    (cherry picked from commit 248ed9033e1b3c7c91df057496d74f9f301f1020)

 build-aux/mbim-codegen/Struct.py | 2 ++
 1 file changed, 2 insertions(+)

commit afd71c3deed9bc457b8ad3ee672ab3e7f4940371
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jan 6 21:00:20 2022 +0100

    libmbim-glib,compat: deprecate the MbimLteAttachStatus type

    We introduce a new MbimLteAttachStatusDeprecated symbol that isn't
    really deprecated, which we use in our own APIs, and we typedef
    MbimLteAttachStatus to it.

    The only method in which we couldn't use MbimLteAttachStatusDeprecated
    was the autoptr cleanup setup, so we just explicitly request to ignore
    deprecation warnings on that one in both gcc and clang.

    (cherry picked from commit f474d51162f1af5f1f9ffabf943f03f7a4d02046)

 .../libmbim-glib/libmbim-glib-common.sections      |  1 +
 src/libmbim-glib/mbim-compat.c                     | 10 ++++----
 src/libmbim-glib/mbim-compat.h                     | 27
 ++++++++++++++++++----
 3 files changed, 29 insertions(+), 9 deletions(-)

commit 49104d7bab1e60ba2423fe54dee6901e9efa51ad
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 9 14:21:18 2022 +0100

    ci: enable gtk-doc in build-release

    (cherry picked from commit f7a2c42a11aff2e16f316cb2f09f835d6dfd1e39)

 .gitlab-ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8c9af651d5555e513fe5ba70798dfc4d10c24b63
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 9 13:58:16 2022 +0100

    build: force building doc on normal builds

    Not just during install, as it would fail.

    See
    https://gitlab.freedesktop.org/mobile-broadband/libmbim/-/issues/19

    (cherry picked from commit e8352f9c5ed99924e43630c435fc4fd55df2ac28)

 docs/reference/libmbim-glib/meson.build | 1 +
 1 file changed, 1 insertion(+)

commit fb6b3e6f645fb84fa6b2704f227b3da0c0e8acaa
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 8 12:57:23 2021 +0100

    build: post-release version bump to 1.26.3

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 55d51a8a76921b478a75b79a8695b37d989e4868
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 8 11:07:55 2021 +0100

    release: bump version to 1.26.2

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 3fe14ffba7974d7b12b2881d6771aae2c0695a9d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 8 11:06:50 2021 +0100

    NEWS: update for 1.26.2

 NEWS | 28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)

commit b917d93708d1d5fed1959507853c77a2bd8b1c83
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Nov 5 10:06:56 2021 +0100

    build: Make feature options boolean

    The introspection and man support are set as `feature` but this may
    cause confusion.

    They have been made `boolean`.

    In order to always build man documentation, `help2man` is also
    installed in the CI builds.

    (cherry picked from commit 823372ac71fec186e95339179fa01816896bf2f4)

 .gitlab-ci.yml       | 10 +++++-----
 docs/man/meson.build |  2 ++
 meson.build          | 18 +++++++++---------
 meson_options.txt    |  4 ++--
 4 files changed, 18 insertions(+), 16 deletions(-)

commit 5fe9d1ebcc7e0c260a8f7b0bb3c1eaf72b2c28d0
Author: Nicolas Cavallari <nicolas.cavallari@green-communications.fr>
Date:   Thu Oct 14 12:25:46 2021 +0200

    meson.build: add an option to not build man pages.

    When cross-compiling, the compiled binaries cannot be run on the build
    machine, unless one defines a helper (e.g. qemu) in the meson
    configuration, which is most of the time undesirable.

    If help2man is installed on the build machine, then the build
    would fail
    because of this, so add an option to disable generating the man pages.

    With later versions of meson, it will be possible to automatically
    detect this condition.

    (cherry picked from commit 792af73ea90e9689703ab526dd444fdb1c2f8e40)

 meson.build       | 8 +++++++-
 meson_options.txt | 1 +
 2 files changed, 8 insertions(+), 1 deletion(-)

commit 20f05ebaf3fc1b71cb69a026a989f9d392ab7ed6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 2 23:33:19 2021 +0100

    docs: add API index for 1.26.2

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 4 ++++
 1 file changed, 4 insertions(+)

commit 7a6f8ad2b01c6cf752e512bac7ed6fed21914999
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 2 23:32:30 2021 +0100

    libmbim-glib,quectel: 'radio state' command available since 1.26.2

 data/mbim-service-quectel.json | 2 +-
 src/libmbim-glib/mbim-cid.h    | 4 ++--
 src/libmbim-glib/mbim-enums.h  | 4 ++--
 src/libmbim-glib/mbim-uuid.h   | 4 ++--
 4 files changed, 7 insertions(+), 7 deletions(-)

commit bcac7ac1fb8325989800c032b5a81bfa2947dbea
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Sep 19 14:44:12 2021 +0200

    mbimcli: new '--quectel-query-radio-state' and
    '--quectel-set-radio-state' operations

    The '--quectel-set-radio-state' operation is limited to allow only one
    value for now: 'on' (0x00000001), which is the one we've seen used
    when reviewing traffic from Lenovo's FCC unlock tool.

    (cherry picked from commit 038efc74690d90deb7bc61c887a2f2a067745bfb)

 src/mbimcli/Makefile.am       |   1 +
 src/mbimcli/mbimcli-quectel.c | 195
 ++++++++++++++++++++++++++++++++++++++++++
 src/mbimcli/mbimcli.c         |  10 ++-
 src/mbimcli/mbimcli.h         |   4 +
 src/mbimcli/meson.build       |   1 +
 5 files changed, 210 insertions(+), 1 deletion(-)

commit 7c18ffe19cf7ee32cb63f373a194377e22a351af
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Sep 19 14:33:48 2021 +0200

    libmbim-glib: new 'Quectel' service

    For now defining a single command with the FCC unlock operation.

    Based on the 'mbim2sar.so' library shipped with
    https://snapcraft.io/lenovo-wwan-dpr

    See
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/402#note_1064882

    (cherry picked from commit f6043e003762a0ae24df5068ec68f14923c4a761)

 data/Makefile.am                                      |  1 +
 data/mbim-service-quectel.json                        | 19
 +++++++++++++++++++
 docs/reference/libmbim-glib/Makefile.am               |  5 +++--
 .../libmbim-glib/libmbim-glib-common.sections         | 11 +++++++++++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml     |  5 +++++
 src/libmbim-glib/generated/Makefile.am                | 12 ++++++++++++
 src/libmbim-glib/generated/meson.build                |  1 +
 src/libmbim-glib/libmbim-glib.h                       |  1 +
 src/libmbim-glib/mbim-cid.c                           | 14 ++++++++++++++
 src/libmbim-glib/mbim-cid.h                           | 14 ++++++++++++++
 src/libmbim-glib/mbim-enums.h                         | 19
 +++++++++++++++++++
 src/libmbim-glib/mbim-message.c                       |  4 ++++
 src/libmbim-glib/mbim-uuid.c                          | 13 +++++++++++++
 src/libmbim-glib/mbim-uuid.h                          | 13 +++++++++++++
 src/libmbim-glib/test/test-uuid.c                     |  8 ++++++++
 src/mbimcli/mbimcli.c                                 |  1 +
 16 files changed, 139 insertions(+), 2 deletions(-)

commit 611263e68f5ce754763a96f9f4c8d888e886536f
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Tue Oct 26 10:36:09 2021 +0200

    build: Fix double quotes in rules file

    `MBIM_USERNAME` is quoted twice in the
    `76-mbim-proxy-device-ownership.rules` rules file. This is because
    the definition is used in two files.

    The first one is `config.h` file, that is used in source code files
    and needs to be explicitly quoted. The second one is the rules file,
    mentioned above that already has quotes in the template file.

    The explicit quotes have been removed in the rules file generation.

    Fixes #21

    (cherry picked from commit f6fbc6c2df7cf1e83f06062bb157acbf9ec9ffd8)

 src/mbim-proxy/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cd7108e46148869c50ea63e800d63bd85f7202fa
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Sep 13 12:17:07 2021 +0200

    ci,meson: add uninstall check in the release task

    (cherry picked from 73137ab786eb7f0cb090296e0c7b0b2fe27aa595)

 .gitlab-ci.yml | 1 +
 1 file changed, 1 insertion(+)

commit 11d7f47f760ad504e6ab4c19139424b3d04c1cb9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Sep 13 12:16:20 2021 +0200

    ci,meson: add tests without introspection support

    (cherry picked from 9e0a74de2811a94c9bc68f86d831ce62ed634c65)

 .gitlab-ci.yml | 42 +++++++++++++++++++++++++++++++++++-------
 1 file changed, 35 insertions(+), 7 deletions(-)

commit 684c4b06cd032e5ac7ff1eca5d352de49a4d98f4
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:20:37 2021 +0200

    build: Use the install_mode option

    Since meson 0.47, `install_mode` option can be used to set a given
    set of rights to any target.

    This feature has been used to set `qmi-network` rights instead of
    using a post install script.

    [0]
    https://mesonbuild.com/Release-notes-for-0-47-0.html#install_mode-keyword-argument-extended-to-all-installable-targets

    (cherry picked from commit 35abb03daddc000cc8a3b35b9338dcdcf211273f)

 meson_post_install.py | 3 ---
 utils/meson.build     | 1 +
 2 files changed, 1 insertion(+), 3 deletions(-)

commit d70c808704da8b3d7571612c9b015b28a8c1f3c1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Sep 13 11:50:08 2021 +0200

    Revert "build: Use the install_mode option"

    This reverts commit d783112c6a6e8f8c27b6c603c06ca3efb2089b33.

    We shouldn't remove the 'meson_post_install.py' script because the
    bash-completion setup still needs it, given that in the stable branch
    we didn't rename the completion file.

 meson.build           |  6 ++++++
 meson_post_install.py | 20 ++++++++++++++++++++
 utils/meson.build     |  1 -
 3 files changed, 26 insertions(+), 1 deletion(-)

commit 5e5b2aa3b3a9606f2a54d9da38e671030fde73d2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Sep 13 09:53:22 2021 +0200

    libmbim-glib,mbimcli: remove execution bit from mode in source files

    (cherry picked from commit 5da217ac7a334364ad48bd357c02f302f2c70a1f)

 src/libmbim-glib/mbim-enums.h                     | 0
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c | 0
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 3b9562ac88ddb8cd134dae6cbab4c315ca854a18
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 01:09:45 2021 +0200

    build: Add explicit content files to documentation

    Although not totally necessary due to its implementation, some files
    built by meson are included as content files.

    They have been explicitly added for the sake of correctness.

    (cherry picked from commit 231ade71dd0e3fb88ab7c8ffca6097400902d8f7)

 docs/reference/libmbim-glib/meson.build | 1 +
 1 file changed, 1 insertion(+)

commit 8eeaac7cd2f451ccecfc5e0c5ee387e0207c5913
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:27:26 2021 +0200

    build: Remove unnecessary MALLOC_PERTURB_ variable set

    meson's test function already sets the `MALLOC_PERTURB_` environment
    variable[0], so there is no need to set it.

    [0] https://mesonbuild.com/Reference-manual.html#test

    (cherry picked from commit 433108b71220efd9a5abd3a7a1781879e3f68282)

 src/libmbim-glib/test/meson.build | 3 ---
 1 file changed, 3 deletions(-)

commit a5b842324d67a969d0009ef9dca5c306d1485d28
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:26:05 2021 +0200

    build: Add version script linker flag when available

    The version script linker flag is used even if it is not available.

    This has been changed to check first for its availability.

    (cherry picked from commit 531374db0054610bef0cab532a2d26540f573630)

 src/libmbim-glib/meson.build | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit d0bfbbe4f1ec5dbfc23c376c55ac5a799dc54323
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:21:57 2021 +0200

    build: Use install_dir instead of subdir

    `install_header` allows the use of the `subdir` parameter that
    points to the subdirectory in the `includedir` directory.

    However, to maintain consistency, this has been changed to use the
    `install_dir` parameter.

    (cherry picked from commit 86a5dc797f8813b77c6f45cf90aed3fd03bbe78b)

 src/libmbim-glib/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d783112c6a6e8f8c27b6c603c06ca3efb2089b33
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:20:37 2021 +0200

    build: Use the install_mode option

    Since meson 0.47, `install_mode` option can be used to set a given
    set of rights to any target.

    This feature has been used to set `qmi-network` rights instead of
    using a post install script.

    [0]
    https://mesonbuild.com/Release-notes-for-0-47-0.html#install_mode-keyword-argument-extended-to-all-installable-targets

    (cherry picked from commit 35abb03daddc000cc8a3b35b9338dcdcf211273f)

 meson.build           |  6 ------
 meson_post_install.py | 20 --------------------
 utils/meson.build     |  1 +
 3 files changed, 1 insertion(+), 26 deletions(-)

commit 8a51de916ee4347ce070e28602ed9d15f21b84bd
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:17:49 2021 +0200

    build: Use strings for include_directories

    Since meson 0.50, `include_directories` also include strings[0].
    This feature is used to improve slightly build files.

    [0]
    https://mesonbuild.com/Release-notes-for-0-50-0.html#include_directories-accepts-a-string

    (cherry picked from commit 02b027be43b85d54adc0cd6e123641bb576f1d21)

 src/common/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 513bb5955ef4497e8fef11ef86e4a4693af651a3
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:14:51 2021 +0200

    build: Use the if_found feature

    meson is able to process or discard a directory based on a
    dependency object based on if it is found or not[0].

    The `man` directory depends on the `help2man` program so it has been
    changed to take advantage of this feature.

    [0]
    https://mesonbuild.com/Release-notes-for-0-44-0.html#added-if_found-to-subdir

    (cherry picked from commit 28674e61b5f2e846340b27f2a5a3d0a5ffbe8c21)

 meson.build | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 52170deb51eb7f8c7be90842690b27000e4def0e
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:13:40 2021 +0200

    build: Make use of dictionaries

    meson gained the dictionaries as builtin objects[0] that can be
    modified with the addition operator[1] and can be useful when
    setting configuration or even environment values[2].

    The individual object creation has been replaced by dictionaries
    when possible.

    [0]
    http://mesonbuild.com/Release-notes-for-0-47-0.html#new-builtin-object-type-dictionary
    [1]
    https://mesonbuild.com/Release-notes-for-0-48-0.html#dictionary-addition
    [2]
    https://mesonbuild.com/Release-notes-for-0-52-0.html#support-taking-environment-values-from-a-dictionary

    (cherry picked from commit 9607e0472d22459949c092cb6ddcba665789d501)

 docs/reference/libmbim-glib/xml/meson.build | 17 +++++++++--------
 meson.build                                 | 11 ++++++-----
 src/libmbim-glib/test/meson.build           | 13 +++++++------
 3 files changed, 22 insertions(+), 19 deletions(-)

commit e454c129d4d1f7c528b3bb9068a09bcb068db2b0
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sat Sep 11 00:06:50 2021 +0200

    build: Make use of features build option for introspection

    Since meson 0.47, there is support for features build options[0] that
    can be enabled automatically if the system has the required support.

    This feature has been used for introspection support.

    [0]
    https://mesonbuild.com/Release-notes-for-0-47-0.html#new-type-of-build-option-for-features

    (cherry picked from commit 6b4a303eb9484916b00da5d7b76810b4c9a381d9)

 meson.build       | 5 +----
 meson_options.txt | 2 +-
 2 files changed, 2 insertions(+), 5 deletions(-)

commit 2748ce4b1f870bf60ddb1a11006a2a6cc0734bc3
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Sep 10 15:19:51 2021 +0200

    build: Removed duplicated variable

    (cherry picked from commit 38deb2f29d82391221a966138ffe5e2c366f08e0)

 meson.build | 2 --
 1 file changed, 2 deletions(-)

commit a10a2cc11f0d89dc62abbe53d290035ab456da8a
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Sep 10 15:14:13 2021 +0200

    build: Use / instead of join_paths

    Since meson 0.49, the `/` character can be used to join paths[0], so
    all the instances of `join_paths` have been replaced.

    [0]
    http://mesonbuild.com/Release-notes-for-0-49-0.html#joining-paths-with-

    (cherry picked from commit 69c72d36394e43ee3b64584e12ad9e313fc43756)

 docs/man/meson.build                    |  2 +-
 docs/reference/libmbim-glib/meson.build |  6 +++---
 meson.build                             | 10 +++++-----
 src/libmbim-glib/generated/meson.build  | 16 ++++++++--------
 src/libmbim-glib/meson.build            |  4 ++--
 src/mbim-proxy/meson.build              |  2 +-
 6 files changed, 20 insertions(+), 20 deletions(-)

commit e6c2a23ca574d740098c0ca1d4a66ce1b989bb4b
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Sep 10 15:02:37 2021 +0200

    build: Create a variable for the project name

    A new variable called `mbim_name` has been created to avoid the call
    to a function inside the meson object.

    (cherry picked from commit 2e6edfc1ef58003fba2bc771dc7f82e6421566c4)

 docs/reference/libmbim-glib/xml/meson.build | 10 +++++-----
 meson.build                                 |  3 ++-
 2 files changed, 7 insertions(+), 6 deletions(-)

commit 6bb7624456d60f1c5bef060e12f953ae8e3f6ac8
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Sep 10 14:57:01 2021 +0200

    build: Make use of the summary function

    Since meson 0.53, it has added a new function to summarize the build
    configuration[0].

    The summary has been changed to make use of it.

    meson version has been bumped to 0.53.

    [0]
    https://mesonbuild.com/Release-notes-for-0-53-0.html#add-a-new-summary-function

    (cherry picked from commit 28dc34931780e206342be576f3f6745428b6dc08)

 meson.build | 31 +++++++++++++++++--------------
 1 file changed, 17 insertions(+), 14 deletions(-)

commit 6df593b048de5862261746697b07c4e6856a2ad7
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Sep 10 14:41:25 2021 +0200

    build: Use the newer python module

    Since 0.48 version of meson, there is a new generic `python` module
    and the previous `python3` module has been deprecated[0].

    The use of the `python3` module has been replaced by this new
    `python` module.

    meson version has been bumped to 0.48.

    CI has also been updated to have this meson version available.

    [0]
    https://mesonbuild.com/Release-notes-for-0-48-0.html#python3-module-is-deprecated

    (cherry picked from commit f5a06ffef8b7fa103555331eef748a5f8bb48ce5)

 .gitlab-ci.yml | 4 ++--
 meson.build    | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit b2984a3543b21213fbed80c6f7b96d89d30c28a6
Author: goapunk <goapunk@riseup.net>
Date:   Fri Aug 13 13:54:51 2021 +0200

    build: use python3 everywhere

    (cherry picked from commit a64d93a799683c5b1381690d22e99281dddaa794)

 build-aux/mbim-codegen/mbim-codegen                | 2 +-
 examples/simple-tester-python/simple-tester-python | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 2fd08b8cd43e36e780c8bdc2dde4e51eb8aa4663
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Aug 4 13:06:55 2021 +0200

    build: Improve symbols resolution

    The `libmbim-glib-generated` library is now fully built in
    `libmbim-glib-core` so it holds all the necessary symbols.

    (cherry picked from commit 2cc7444cad59fcadd017905235d876367478ec9b)

 src/libmbim-glib/generated/meson.build | 3 +--
 src/libmbim-glib/meson.build           | 4 +++-
 2 files changed, 4 insertions(+), 3 deletions(-)

commit de4c908f32b4715ec96aff8108ec18dea7a48524
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 2 10:43:53 2021 +0200

    meson: make meson_post_install.py executable

    (cherry picked from commit 6c1fe9c3a115041db0ceefe4255bd3b00ec26bfd)

 meson_post_install.py | 0
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 1ab9fc84520b20afa73fcd01d9759d1ef6a8f6ad
Author: Yegor Yefremov <yegorslists@googlemail.com>
Date:   Mon Aug 2 07:08:51 2021 +0200

    meson: add missing SPDX identifiers and copyright information

    (cherry picked from commit e84c6e90970d67d180bb362d5f03732fd4dce728)

 meson_options.txt     | 3 +++
 meson_post_install.py | 3 +++
 2 files changed, 6 insertions(+)

commit e9f995f8c3caa0cbc6c72a1f7d11c8f2364dd094
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sun Aug 1 22:31:14 2021 +0200

    meson: Fix static build

    Replace shared_library by library to fix static build failure with
    toolchains that don't support dynamic library.

    Fixes:
    http://autobuild.buildroot.org/results/8553211d87a2c41d8b47b51bbb193736fce49714
    Refs: !83
    Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
    (cherry picked from commit d8e1aeda7f83c7657291ef3673bdb7ae0c6cf89e)

 src/libmbim-glib/meson.build | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 02313dbe22fe0fbbedf3bd6e9c177f6d1dcf4dff
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Sun Aug 1 21:06:03 2021 +0200

    meson: Fix tests names

    In tests execution, the test name is using only the first character
    instead of the full test name.

    (cherry picked from commit e858c69d8231bb75ec952ca0eb70ad70280ca348)

 src/libmbim-glib/test/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a872f5f63c56eb29d6598a508cb6d568d34e19a7
Author: Yegor Yefremov <yegorslists@googlemail.com>
Date:   Thu Jul 29 07:10:00 2021 +0200

    meson: list both licenses

    As this project is covered by two licenses, list both GPL-2.0-or-later
    and LGPL-2.1-or-later in the corresponding project field.

    (cherry picked from commit 4b94d7c87152b295e12ec2c2ac251f1cc0da63e7)

 meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4b6db4b1a3500ac73784cbe8ca26fe0d0b981cbf
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 12:10:48 2021 +0200

    build: post-release version bump to 1.26.1

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 717067603d82c14452e70fa24cacb60ac7688685
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 11:13:56 2021 +0200

    release: bump version to 1.26.0

 configure.ac | 8 ++++----
 meson.build  | 6 +++---
 2 files changed, 7 insertions(+), 7 deletions(-)

commit f9fc06b832accde92d353fde8b783f156d4998a2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 11:13:48 2021 +0200

    NEWS: update for 1.26.0

 NEWS | 95
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 95 insertions(+)

commit cc2bf193442855d1ca1f9f3d031366c5205c40de
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 11:21:50 2021 +0200

    RELEASING: update with full explanation

 RELEASING | 45 +++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 43 insertions(+), 2 deletions(-)

commit d67e369f95f142a170a6c525c3d1140d1f18e33f
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Mon Jul 26 10:22:41 2021 +0200

    build,meson: make bash-completion file install optional

    `mbimcli` provides a bash-completion file. To install this file
    `bash-completion`'s pkg-file is checked to set the proper
    installation directory.

    This has been made optional.

 meson.build             | 14 ++++++++++++--
 meson_options.txt       |  2 ++
 meson_post_install.py   |  9 ++++++---
 src/mbimcli/meson.build | 10 ++++++----
 4 files changed, 26 insertions(+), 9 deletions(-)

commit 53a35e1e6fc76b010751d2b134d48f9d44ce8cd3
Author: Yegor Yefremov <yegorslists@googlemail.com>
Date:   Sat Jul 24 23:09:33 2021 +0200

    meson: fix SPDX license identifier

    There is no such license as GPL-2 in the SPDX nomenclature. As
    the project is licensed under GNU General Public License v2.0
    or later, use the related identifier GPL-2.0-or-later.

 docs/man/meson.build                        | 2 +-
 docs/reference/libmbim-glib/meson.build     | 2 +-
 docs/reference/libmbim-glib/xml/meson.build | 2 +-
 meson.build                                 | 2 +-
 src/common/meson.build                      | 2 +-
 src/common/test/meson.build                 | 2 +-
 src/libmbim-glib/generated/meson.build      | 2 +-
 src/libmbim-glib/meson.build                | 2 +-
 src/libmbim-glib/test/meson.build           | 2 +-
 src/mbim-proxy/meson.build                  | 2 +-
 src/mbimcli/meson.build                     | 2 +-
 src/meson.build                             | 2 +-
 utils/meson.build                           | 2 +-
 13 files changed, 13 insertions(+), 13 deletions(-)

commit 4e2e3c2fda597c7fa4d4ff74b5d41ace032d4b24
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 12:28:03 2021 +0200

    ci: remove autoconf-archive from template

 .gitlab-ci.yml | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit 411a14d71df463b46e9b330ceb06f07ace65ad34
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 21 16:07:58 2021 +0200

    build: import used AX_ macros from autoconf-archive

    This allows us to build from git without build-depending on
    autoconf-archive, which is not always available as a package.

 m4/ax_append_compile_flags.m4   |  46 ++++++++
 m4/ax_append_flag.m4            |  50 +++++++++
 m4/ax_append_link_flags.m4      |  44 ++++++++
 m4/ax_check_compile_flag.m4     |  53 ++++++++++
 m4/ax_check_link_flag.m4        |  53 ++++++++++
 m4/ax_code_coverage.m4          | 229
 ++++++++++++++++++++++++++++++++++++++++
 m4/ax_compiler_flags.m4         | 158 +++++++++++++++++++++++++++
 m4/ax_compiler_flags_cflags.m4  | 161 ++++++++++++++++++++++++++++
 m4/ax_compiler_flags_gir.m4     |  60 +++++++++++
 m4/ax_compiler_flags_ldflags.m4 | 111 +++++++++++++++++++
 m4/ax_is_release.m4             |  80 ++++++++++++++
 m4/ax_require_defined.m4        |  37 +++++++
 12 files changed, 1082 insertions(+)

commit ec4e06be1c128cb6f2fd7ab3fc6efd1ffb75d108
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 21 09:17:53 2021 +0200

    build: update introspection.m4

    In sync with gobject-introspection 1.68.0

 m4/introspection.m4 | 59
 ++++++++++++++++++++++++++++++++++++++++++++++-------
 1 file changed, 52 insertions(+), 7 deletions(-)

commit 007c6a44459e4b6b476fc947ce6fa4e729ae7fff
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 21 16:13:42 2021 +0200

    docs: QDU is defined by Qualcomm

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

commit 4f0fb6937dc90b9923388ef9be7d71f072193976
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 14 15:12:02 2021 +0200

    build: version bump to flag existence of new API (DSSA MS extensions)

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 9c3805b9f31123bcd9d8082d69de54bdea441efd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 14 15:11:04 2021 +0200

    data,ms-basic-connect-extensions: remove trailing whitespaces

 data/mbim-service-ms-basic-connect-extensions.json | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 40d5e0e7a4ac9a6fbd2f60b0cdd785785a7d2e4b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 21:46:25 2021 +0200

    libmbim-glib,net-port-manager: automatic session id allocation starts
    at 1

 src/libmbim-glib/mbim-net-port-manager.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 058d68fa920a1c45af2868fb3bfc914318ff8ff1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 16:03:20 2021 +0200

    libmbim-glib,net-port-manager: log the VLAN id requested via netlink

 src/libmbim-glib/mbim-net-port-manager.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit c1aef5ca1f03ca108fb279de1a1d68ac021745c8
Author: King.Sun <king.sun@fibocom.com>
Date:   Wed Jun 2 12:22:56 2021 +0800

    ms-basic-connect-extensions: add 'device caps'

    We query the device capabilities and we can see
    the following information

    mbimcli -d /dev/cdc-wdm0 -p --ms-query-device-caps
    [/dev/cdc-wdm0] Device capabilities retrieved:
                  Device type: 'x'
               Cellular class: 'x'
                  voice class: 'x'
                    SIM class: 'x'
                   Data class: 'x, x, x, x'
                     SMS caps: 'x, x'
                    CTRL caps: 'x'
                 Max sessions: 'x'
            Custom data class: 'x'
                    Device ID: 'x'
                Firmware info: 'x'
                Hardware info: 'x'
               Executor Index: 'x'

 data/mbim-service-ms-basic-connect-extensions.json |  47 ++++++++-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  | 113
 +++++++++++++++++++++
 2 files changed, 159 insertions(+), 1 deletion(-)

commit 95a5d2f5829df9e1e7c8cda511d17fefb06dd32a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jun 1 09:33:00 2021 +0200

    build: version bump to flag existence of new API (UICC low level
    access service)

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 75149b78100f70bcc9172d0113fe75fb0790ed20
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Thu May 20 23:13:19 2021 +0530

    libmbim-glib,ms-uicc-low-level-access: adding cid 'uicc-reset'

    MSFT MBIM_CID_MS_UICC_RESET is used to reset the UICC or
    to query passthrough state of the function.
    If host/application specifies passthrough action, the function
    resets the UICC and upon UICC power up, treats the UICC as if
    it were in a passthrough mode. If the passthrough action is
    disabled during reset operation then upon power up, treats
    the UICC as a regular Telecom UICC and expects a Telecom
    UICC file system to be present on the UICC

 data/mbim-service-ms-uicc-low-level-access.json    | 16 ++++++++++-
 .../libmbim-glib/libmbim-glib-common.sections      | 10 +++++++
 src/libmbim-glib/mbim-cid.c                        |  3 ++-
 src/libmbim-glib/mbim-cid.h                        |  2 ++
 src/libmbim-glib/mbim-enums.h                      | 31
 ++++++++++++++++++++++
 5 files changed, 60 insertions(+), 2 deletions(-)

commit ebf1bed2122f960f4105b3be734f1f7b5776fd2a
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Thu May 20 23:02:17 2021 +0530

    libmbim-glib,ms-uicc-low-level-access: adding cid 'terminal capabilty'

    MSFT MBIM_CID_MS_UICC_TERMINAL_CAPABILITY is used to inform the
    modem about the capability of the sending entity/application.
    Details about terminal capability apdu can be found in
    section 11.1.19 of ETSI TS 102 221
    terminal capability apdu must be sent to the card before the
    application is selected using this CID by the host.

 data/mbim-service-ms-uicc-low-level-access.json | 38
 +++++++++++++++++++++----
 src/libmbim-glib/mbim-cid.c                     |  3 +-
 src/libmbim-glib/mbim-cid.h                     |  2 ++
 3 files changed, 36 insertions(+), 7 deletions(-)

commit 45ec01a13b96218947ea7c5b7103ce0ece31a0cc
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Sat May 8 15:46:01 2021 +0530

    libmbim-glib,ms-uicc-low-level-access: adding cid 'uicc-apdu'

    MSFT MBIM_CID_MS_UICC_APDU is used to send a command APDU to
    a specific logical channel on the UICC and receive the
    response. Sending entity has to ensure that the logical
    channel was previously opened with uicc-open channel.
    Refer section 10.1.1 of ETSI TS 102 221 TS for more details
    on apdu encoding/decoding.

 data/mbim-service-ms-uicc-low-level-access.json    | 22 ++++++++++++++-
 .../libmbim-glib/libmbim-glib-common.sections      | 10 +++++++
 src/libmbim-glib/mbim-cid.c                        |  3 ++-
 src/libmbim-glib/mbim-cid.h                        |  2 ++
 src/libmbim-glib/mbim-enums.h                      | 31
 ++++++++++++++++++++++
 5 files changed, 66 insertions(+), 2 deletions(-)

commit 3256374eb879a415d2d9edd0a783c7ebaa59647d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 31 15:16:07 2021 +0200

    libmbim-glib,enums: add section separator for the slot info enum

 src/libmbim-glib/mbim-enums.h | 3 +++
 1 file changed, 3 insertions(+)

commit 8327ce789c7bd8f16f2b3db389c7353b023611c0
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Sat May 8 15:27:13 2021 +0530

    libmbim-glib,ms-uicc-low-level-access: adding cid 'uicc-close channel'

    MSFT MBIM_CID_MS_UICC_CLOSE_CHANNEL is used to close a logical
    channel on the UICC. Sending entity may specify a channel number
    or may specify a channel group.

 data/mbim-service-ms-uicc-low-level-access.json | 14 +++++++++++++-
 src/libmbim-glib/mbim-cid.c                     |  3 ++-
 src/libmbim-glib/mbim-cid.h                     |  2 ++
 3 files changed, 17 insertions(+), 2 deletions(-)

commit e2667b6ef5b1b1a2d22b46752399cd77af94fd6f
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Sat May 8 14:51:58 2021 +0530

    libmbim-glib,ms-uicc-low-level-access: adding cid 'uicc-open channel'

    MSFT MBIM_CID_MS_UICC_OPEN_CHANNEL sends a Manage channel command to
    the UICC as described by section 11.1.17 of ETSI TS 102.221 TSpec.
    If the manage channel is successful UICC sends channel number of the
    new logical channel to the function.

 data/mbim-service-ms-uicc-low-level-access.json | 19 ++++++++++++++++++-
 src/libmbim-glib/mbim-cid.c                     |  3 ++-
 src/libmbim-glib/mbim-cid.h                     |  2 ++
 3 files changed, 22 insertions(+), 2 deletions(-)

commit 685a8b5737bef3f11867219da6864148c655112c
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Sat May 8 11:58:35 2021 +0530

    libmbim-glib,ms-uicc-low-level-access: adding cid 'uicc-atr'

    The Answer to Reset(ATR) CID implementation.
    ATR is the first string of bytes sent by the UICC after
    reset has been performed. Host should save this ATR when
    it is received from UICC for future use.

 data/Makefile.am                                       |  1 +
 data/mbim-service-ms-uicc-low-level-access.json        | 15
 +++++++++++++++
 docs/reference/libmbim-glib/Makefile.am                |  3 ++-
 .../libmbim-glib/libmbim-glib-common.sections          |  6 ++++++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml      |  1 +
 src/libmbim-glib/generated/Makefile.am                 | 18
 +++++++++++++++---
 src/libmbim-glib/generated/meson.build                 |  1 +
 src/libmbim-glib/libmbim-glib.h                        |  1 +
 src/libmbim-glib/mbim-cid.c                            | 15
 +++++++++++++++
 src/libmbim-glib/mbim-cid.h                            | 14
 ++++++++++++++
 src/libmbim-glib/mbim-message.c                        |  4 ++++
 src/libmbim-glib/mbim-uuid.c                           | 13 +++++++++++++
 src/libmbim-glib/mbim-uuid.h                           | 11 +++++++++++
 src/mbimcli/mbimcli.c                                  |  1 +
 14 files changed, 100 insertions(+), 4 deletions(-)

commit 667ad91d620c7fb75774abcc85b625bae1bb5161
Author: Som_SP <somashekhar.puttagangaiah@intel.com>
Date:   Fri May 28 14:28:58 2021 +0530

    mbim-codegen: add new 'uicc-ref-byte-array' field type

    New data-type 'uicc-ref-byte-array' is added which will help
    to encode byte-array which requires the encoding of the format
    size-offset-byte array.

 build-aux/mbim-codegen/Message.py       | 57
 ++++++++++++++++++++++++---------
 build-aux/mbim-codegen/Struct.py        | 16 ++++-----
 src/libmbim-glib/mbim-message-private.h |  9 ++++--
 src/libmbim-glib/mbim-message.c         | 41 ++++++++++++++++++++----
 4 files changed, 90 insertions(+), 33 deletions(-)

commit 737c576992e622a38b34525594db1004903f83d7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 26 12:09:22 2021 +0200

    ci: use script references in the artifacts build

    The artifacts build should run the same commands as the default build,
    with additional steps for the artifacts.

 .gitlab-ci.yml | 7 +------
 1 file changed, 1 insertion(+), 6 deletions(-)

commit a6eded819c43a1c80fa8538aac47aaf252caf117
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 26 11:56:25 2021 +0200

    ci: build with artifacts only in master and tags

 .gitlab-ci.yml | 18 ++++++++++++++++--
 1 file changed, 16 insertions(+), 2 deletions(-)

commit ed53f480650648351794beda2b50de5c9b49318e
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Tue May 25 20:25:54 2021 +0800

    ms-basic-connect-extensions: implement 'Device Slot Mappings'

    We set device slot mappings and we can see
    the following information.

    mimcli -d /dev/cdc-wdm0 -p --ms-set-device-slot-mappings=1
    [/dev/cdc-wdm0] Updated slot mappings retrieved:
                Executor 0: slot 1

    We query device slot mappings and we can see
    the following information.

    mbimcli -d /dev/cdc-wdm0 -p --ms-query-device-slot-mappings
    [/dev/cdc-wdm0] Slot mappings retrieved:
                Executor 0: slot 0

 data/mbim-service-ms-basic-connect-extensions.json |  29 ++++-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  | 141
 ++++++++++++++++++++-
 2 files changed, 168 insertions(+), 2 deletions(-)

commit 37c4d4919024c0565505cca45c8e0ad598c37fdd
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Tue May 25 15:35:08 2021 +0800

    ms-basic-connect-extensions: implement 'Slot Info Status'

    We query device slot information status and we can see
    the following information.

    mbimcli -d /dev/cdc-wdm0 -p --ms-query-slot-info-status=1
    [/dev/cdc-wdm0] Slot info status retrieved:
                SLot 1: slot-state-active

 data/mbim-service-ms-basic-connect-extensions.json |  21 ++++-
 .../libmbim-glib/libmbim-glib-common.sections      |   5 ++
 src/libmbim-glib/mbim-enums.h                      |  28 ++++++
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  | 100
 ++++++++++++++++++++-
 4 files changed, 152 insertions(+), 2 deletions(-)

commit 3d6acd3352ec80b98c774e0e4ccd6e04d658de54
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Mon May 24 15:57:05 2021 +0800

    mbimcli: add missing action flag for --query-sys-caps

 src/mbimcli/mbimcli-ms-basic-connect-extensions.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit a3929d66560070deeaa47dccadfd8c464f028ed0
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Thu May 20 15:49:20 2021 +0800

    ms-basic-connect-extensions: implement 'Sys caps'

    Update data/mbim-service-ms-basic-connect-extensions.json,
           src/mbimcli/mbimcli-ms-basic-connect-extensions.c

    We query the system capalibities and we can see
    the following information.

    mbimcli -d /dev/cdc-wdm0 -p --ms-query-sys-caps
    [/dev/cdc-wdm0] System capabilities retrieved:
          Number of executors: 'x'
              Number of slots: 'x'
                  Concurrency: 'x'
                     Modem ID: 'xxx'

 data/mbim-service-ms-basic-connect-extensions.json | 18 +++++-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  | 64
 ++++++++++++++++++++++
 2 files changed, 81 insertions(+), 1 deletion(-)

commit 764d91155570d653e178ae8f12ff4de00d71e06c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 11:09:54 2021 +0200

    core: drop "volatile" for g_once_init_enter locations

    This fixes a few (fatal in gcc 11) warnings.

    See https://gitlab.gnome.org/GNOME/glib/-/issues/600

 build-aux/templates/mbim-enum-types.c.template  | 8 ++++----
 build-aux/templates/mbim-error-types.c.template | 8 ++++----
 src/libmbim-glib/mbim-message.c                 | 8 ++++----
 3 files changed, 12 insertions(+), 12 deletions(-)

commit 9016e0d72d5c7da68eccdc8413e82240a27bfeef
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 15 15:29:32 2021 +0200

    libmbim-glib,message: fix overflows when checking required size

    The message parsers will make sure the amount of data read from the
    message is within the boundaries of the message itself. But, while
    doing so, the parser will "compute" the required size based on message
    field offsets and also based on offsets and sizes reported within the
    message itself.

    If these fields are malformed and report very long offsets or
    sizes (e.g. 0xFFFFFFFF), adding those values into a target uint32
    value will definitely overflow.

    Fix this by making the required size computations using a target
    uint64 value instead, so that adding up several uint32 values (even if
    some of them are e.g. 0xFFFFFFFF) won't overflow the operation.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/libmbim/-/issues/16

 src/libmbim-glib/mbim-message.c | 160
 ++++++++++++++++++++--------------------
 1 file changed, 80 insertions(+), 80 deletions(-)

commit 7a86e782e0778c458990d8f506db94bb65e4b44b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 15 15:28:51 2021 +0200

    libmbim-glib,message: trivial fix in guint64 value parsing

    All relative offsets are 32bit values

 src/libmbim-glib/mbim-message-private.h | 2 +-
 src/libmbim-glib/mbim-message.c         | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 31d9bd9f8252840c3174eece3880131fe610547e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 15 15:27:10 2021 +0200

    libmbim-glib,message: trivial fix to remove trailing whitespaces

 src/libmbim-glib/mbim-message.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f574596f2c092b4f779fc3ec03fa0e852b12a104
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 15 15:23:09 2021 +0200

    libmbim-glib,test: add test to trigger overflow in the message parser

    The test includes a "Basic Connect" "Visible Providers" response
    message that has both a string offset and size malformed (reported as
    0x80000020 and 0x8000000A instead of 0x00000020 and 0x0000000A).

    See
    https://gitlab.freedesktop.org/mobile-broadband/libmbim/-/issues/16

 src/libmbim-glib/test/test-message-parser.c | 74
 +++++++++++++++++++++++++++++
 1 file changed, 74 insertions(+)

commit c90c7c5b877de6e413b4833aaf1a42d2d128b051
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Tue May 4 09:55:55 2021 +0200

    build,meson: fix pkg-config variable get function

    When there is no `udevdir` variable set when `mbim_username` option
    is set, the variable is get from the `udev.pc` pkg-config file.

    However, the function used, this is `get_variable` was introduced in
    meson 0.51[0]. It has been replaced by `get_pkgconfig_variable` that
    was already supported in meson 0.45.1.

    [0]
    https://mesonbuild.com/Release-notes-for-0-51-0.html#dependency-objects-now-have-a-get_variable-method

 meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit dcde531919666e9d8c5dc74ab74f9e6449bd90e3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 4 01:40:11 2021 +0200

    libmbim-glib,compat: fix return of the MbimLteAttachStatus struct

    We should not free it before returning it... :)

      Thread 1 "ModemManager" received signal SIGABRT, Aborted.
      0x00007ffff7837ef5 in raise () from /usr/lib/libc.so.6
      (gdb) bt
      #0  0x00007ffff7837ef5 in raise () at /usr/lib/libc.so.6
      #1  0x00007ffff7821862 in abort () at /usr/lib/libc.so.6
      #2  0x00007ffff7879f38 in __libc_message () at /usr/lib/libc.so.6
      #3  0x00007ffff7881bea in  () at /usr/lib/libc.so.6
      #4  0x00007ffff7883113 in _int_free () at /usr/lib/libc.so.6
      #5  0x00007ffff7886ca8 in free () at /usr/lib/libc.so.6
      #6  0x0000555555616ec5 in lte_attach_status_query_ready
      (device=0x7fffe8007e30, res=0x7fffe8011ee0, task=0x55555574bb30)
      at mm-broadband-modem-mbim.c:2713
      #7  0x00007ffff7cd33d4 in  () at /usr/lib/libgio-2.0.so.0
      #8  0x00007ffff7cd77b9 in  () at /usr/lib/libgio-2.0.so.0
      #9  0x00007ffff7e26a7f in transaction_task_complete_and_free
      (task=0x7fffe8011ee0, error=0x0) at
      ../src/libmbim-glib/mbim-device.c:243
      #10 0x00007ffff7e2864d in process_message (message=<optimized out>,
      self=0x7fffe8007e30) at ../src/libmbim-glib/mbim-device.c:906
      #11 parse_response (self=0x7fffe8007e30) at
      ../src/libmbim-glib/mbim-device.c:1049
      #12 data_available (source=0x55555571ec50, condition=<optimized
      out>, self=0x7fffe8007e30) at ../src/libmbim-glib/mbim-device.c:1125
      #13 0x00007ffff7af5f30 in g_main_context_dispatch () at
      /usr/lib/libglib-2.0.so.0
      #14 0x00007ffff7b49b59 in  () at /usr/lib/libglib-2.0.so.0
      #15 0x00007ffff7af5593 in g_main_loop_run () at
      /usr/lib/libglib-2.0.so.0
      #16 0x000055555558402f in main (argc=2, argv=0x7fffffffead8)
      at main.c:210

 src/libmbim-glib/mbim-compat.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 2130590f449e4e330e8f07e87f6d1463027be883
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 4 00:47:07 2021 +0200

    build,meson: fix missing version bump

 meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7a1a45633c1b3a906730f5eac10480bdf4e93d51
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 4 00:37:34 2021 +0200

    build: version bump to flag existence of new API (LTE attach info)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5f1014391f64d5c42f43a31cdf72910aff15f6f0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 4 00:01:02 2021 +0200

    libmbim-glib,ms-basic-connect-extensions: rework 'LTE attach status'

    The "LTE Attach Status" message was relying on a bogus
    MbimLteAttachStatus struct that was created by the library and passed
    as output of the parser methods to the user.

    This struct is completely avoidable, just by updating the messages to
    include the fields directly in the response/notification fields.

    We rename the method to 'LTE attach info' following this approach, and
    compatibility symbols are included in order to avoid breaking API/ABI.

 data/mbim-service-ms-basic-connect-extensions.json |  68 +++++++------
 .../libmbim-glib/libmbim-glib-common.sections      |   9 ++
 src/libmbim-glib/mbim-cid.h                        |   4 +-
 src/libmbim-glib/mbim-compat.c                     |  72 ++++++++++++++
 src/libmbim-glib/mbim-compat.h                     | 110
 ++++++++++++++++++++-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  |  65 +++++++-----
 6 files changed, 271 insertions(+), 57 deletions(-)

commit 56a04aafe3bc7641f5d9deab95d20848bc5dca0f
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Mon May 3 22:05:51 2021 +0200

    ci: Add bash-completion package

    meson uses the `bash-completion` package to be able to acquire the
    `completionsdir` variable.

    Added it and bumped `FDO_DISTRIBUTION_TAG`.

 .gitlab-ci.yml | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit a9a3c70d6c277ffdb32435a200eab13e1d0074b3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 2 00:34:14 2021 +0200

    ci: add support for meson builds

 .gitlab-ci.yml | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit a4decd1bd2dbcda163e72abbd68894b2b396e969
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Apr 22 23:57:36 2021 +0200

    build: port to meson build system

    meson is a build system focused on speed an ease of use, which
    helps speeding up the software development. This patch adds meson
    support along autotools.

 docs/man/meson.build                               |  18 ++
 docs/reference/libmbim-glib/meson.build            |  67 +++++++
 .../libmbim-glib/xml/gtkdocentities.ent.in         |   7 +
 docs/reference/libmbim-glib/xml/meson.build        |  17 ++
 meson.build                                        | 208
 +++++++++++++++++++++
 meson_options.txt                                  |   6 +
 meson_post_install.py                              |  14 ++
 src/common/meson.build                             |  17 ++
 src/common/test/meson.build                        |  11 ++
 src/libmbim-glib/generated/meson.build             | 154 +++++++++++++++
 src/libmbim-glib/meson.build                       | 134 +++++++++++++
 src/libmbim-glib/symbol.map                        |   6 +
 src/libmbim-glib/test/meson.build                  |  39 ++++
 src/mbim-proxy/meson.build                         |  22 +++
 src/mbimcli/meson.build                            |  38 ++++
 src/meson.build                                    |   7 +
 utils/meson.build                                  |   9 +
 17 files changed, 774 insertions(+)

commit 13883cd5c4d28dbed3c49008430c7dbbae8d5ef0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 21:53:26 2021 +0200

    ci: build should be supported back to bionic

    Also, include ninja and meson in the image template, to have it ready
    by the time we add the meson support.

 .gitlab-ci.yml | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 6b6dabcd41a94787c04ea795177608498eb874cc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 21:45:19 2021 +0200

    build: require glib 2.56

    The 2.56.0 glib version is also the one provided by Ubuntu 18.04 LTS,
    and so we can now say that this LTS release is the last one we support
    in newer libmbim releases. The previous Ubuntu 16.04 LTS is already
    out of the standard 5-year support.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 09f2cffd1f2bf46f1e44eaae8a1e7eb997ccca15
Author: lywpljw <327669727@qq.com>
Date:   Thu Apr 29 18:11:26 2021 +0800

    mbim-proxy: update BUFFER_SIZE from 512 to 4096 for better performance

    Signed-off-by: lywpljw <327669727@qq.com>

 src/libmbim-glib/mbim-proxy.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 1ce808bd39477881201a552bafd7bce8bc667c52
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 21:53:33 2021 +0200

    build: version bump to flag existence of new API (QDU service)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 435649cbebd72aed8b128deabc8bd1405261ecfa
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 18:47:30 2021 +0200

    ci: switch to gitlab templates

 .gitlab-ci.yml | 83
 +++++++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 76 insertions(+), 7 deletions(-)

commit b0b78e871d06abf9f8990bdb30ef3f20b30d0fd1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 10:35:58 2021 +0200

    docs,libmbim-glib: add missing QDU related references

 .../libmbim-glib/libmbim-glib-common.sections       | 21
 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

commit 13a6a501c0908a6d052c1feabfed76ee89bbf4a5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 10:34:16 2021 +0200

    libmbim-glib,enums: minor coding style changes

 src/libmbim-glib/mbim-enums.h | 28 ++++++++++++++--------------
 1 file changed, 14 insertions(+), 14 deletions(-)

commit e985601baad822c8124a68f66b48563e9ecb2598
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 10:14:13 2021 +0200

    libmbim-glib,cid: add missing docs for MBIM_CID_QDU_UNKNOWN

 src/libmbim-glib/mbim-cid.h | 1 +
 1 file changed, 1 insertion(+)

commit 49c0f79783cfd029c4feb88c859079a505deec00
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 10:11:04 2021 +0200

    libmbim-glib,device: simplify printable logic with fragments

    We're going to build a GByteArray containing the whole fragment, so
    make sure we are able to re-use that for printable purposes, instead
    of creating additional GByteArrays or doing multiple
    mbim_common_str_hex() calls.

 src/libmbim-glib/mbim-device.c | 54
 +++++++++++++++++++-----------------------
 1 file changed, 24 insertions(+), 30 deletions(-)

commit 1fb69c341500a12ef54a301a79da5eec84d9c09f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 28 10:01:30 2021 +0200

    libmbim-glib,device: plug memory leak when building full fragments

    The gbytearray variable is used and reused multiple times inside the
    for loop, we should make sure it's freed after every iteration, not
    only once when the method ends.

 src/libmbim-glib/mbim-device.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit a61d12aac09213e036e5807d8f19eb5c427dafb5
Author: lywpljw <327669727@qq.com>
Date:   Wed Apr 28 11:26:15 2021 +0800

    libmbim-glib: write whole packet to MBIM device

    Here send whole packet rather than seperated elements, such as header,
    fragment_header, data, because some MBIM devices may have errors on
    seperated fragment case, such as "MBIM protocol error: LengthMismatch"

    Signed-off-by: lywpljw <327669727@qq.com>

 src/libmbim-glib/mbim-device.c | 26 ++++++++++++--------------
 1 file changed, 12 insertions(+), 14 deletions(-)

commit dd98d6877de74ff1b0145160a25bd26f71d3a665
Author: lywpljw <327669727@qq.com>
Date:   Wed Apr 28 11:17:56 2021 +0800

    api: add QDU service for modem firmware upgrade

    QDU (Qualcomm Device Upgrade) is required for Qualcomm modem
    firmware upgrade.

    Signed-off-by: lywpljw <327669727@qq.com>

 data/Makefile.am                                   |  1 +
 data/mbim-service-qdu.json                         | 59 +++++++++++++++
 docs/reference/libmbim-glib/Makefile.am            |  1 +
 .../libmbim-glib/libmbim-glib-common.sections      | 10 +++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml  |  5 ++
 src/libmbim-glib/generated/Makefile.am             | 12 +++
 src/libmbim-glib/libmbim-glib.h                    |  1 +
 src/libmbim-glib/mbim-cid.c                        | 15 ++++
 src/libmbim-glib/mbim-cid.h                        | 17 +++++
 src/libmbim-glib/mbim-enums.h                      | 85
 ++++++++++++++++++++++
 src/libmbim-glib/mbim-message.c                    |  4 +
 src/libmbim-glib/mbim-uuid.c                       | 13 ++++
 src/libmbim-glib/mbim-uuid.h                       | 13 ++++
 src/mbimcli/mbimcli.c                              |  1 +
 14 files changed, 237 insertions(+)

commit 3d6966640c7c3d11ba1a96577f1ddd4bc1549a78
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Apr 21 15:12:03 2021 +0200

    build: Rename template files

    The template files in the `build-aux/templates` directory used in
    enums sources and headers generation use the `{$name}-template.[ch]`
    pattern. However, the examples in the official guide[0] and usually
    GNOME and Freedesktop packages use the `{$name}.[ch].template`
    pattern.

    Due to this, the name of the template files and build commands have
    been changed.

    [0] https://developer.gnome.org/gobject/stable/glib-mkenums.html

 build-aux/templates/Makefile.am                      | 10 +++++-----
 ...m-types-template.c => mbim-enum-types.c.template} |  0
 ...m-types-template.h => mbim-enum-types.h.template} |  0
 ...uarks-template.c => mbim-error-quarks.c.template} |  0
 ...-types-template.c => mbim-error-types.c.template} |  0
 ...-types-template.h => mbim-error-types.h.template} |  0
 src/libmbim-glib/generated/Makefile.am               | 20
 ++++++++++----------
 7 files changed, 15 insertions(+), 15 deletions(-)

commit 6394a122407f31d2321a16833d9dd123767ff8d5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Apr 21 11:33:53 2021 +0200

    build: disable gtkdocize in autoreconf

    We have a custom modified gtk-doc.make file in our sources, which
    disables the gtkdoc-rebase on local install step, so we don't want
    autoreconf to copy a different one when we're bootstrapping.

 autogen.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3758ad06aa4badbfbda72c4d9a63ee69cd62e0ea
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Apr 6 21:30:20 2021 +0200

    libmbim-glib,device: plug leak when adding links

    The AddLinkResult contex was leaking.

 src/libmbim-glib/mbim-device.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 62d563a4ae2546571b52db57c4d5fd3a12fd6e3d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Apr 3 17:27:10 2021 +0200

    libmbim-glib,net-port-manager: plug hash table leak

    Also, assert to make sure the HT doesn't have any contents, which it
    shouldn't as each element in the HT holds a GTask and each such GTask
    holds a reference to the port manager object itsel.

        ==4391== 192 (96 direct, 96 indirect) bytes in 1 blocks are
        definitely lost in loss record 5,187 of 5,426
        ==4391==    at 0x483E77F: malloc (vg_replace_malloc.c:307)
        ==4391==    by 0x5080539: g_malloc (in
        /usr/lib/libglib-2.0.so.0.6600.7)
        ==4391==    by 0x50A1C8F: g_slice_alloc (in
        /usr/lib/libglib-2.0.so.0.6600.7)
        ==4391==    by 0x507038E: g_hash_table_new_full (in
        /usr/lib/libglib-2.0.so.0.6600.7)
        ==4391==    by 0x4DA90FB: mbim_net_port_manager_new
        (mbim-net-port-manager.c:734)
        ==4391==    by 0x4D9DB0C: setup_net_port_manager
        (mbim-device.c:531)
        ==4391==    by 0x4D9E2F4: mbim_device_delete_all_links
        (mbim-device.c:715)
        ==4391==    by 0x2523A1: reset_device_new_ready
        (mm-port-mbim.c:350)
        ==4391==    by 0x4EBC173: ??? (in /usr/lib/libgio-2.0.so.0.6600.7)
        ==4391==    by 0x4EC06E8: ??? (in /usr/lib/libgio-2.0.so.0.6600.7)
        ==4391==    by 0x4DA220B: query_info_async_ready
        (mbim-device.c:2355)
        ==4391==    by 0x4EBC173: ??? (in /usr/lib/libgio-2.0.so.0.6600.7)

 src/libmbim-glib/mbim-net-port-manager.c | 2 ++
 1 file changed, 2 insertions(+)

commit 227a79f976082bef2909540d57f1df6eb47cefd2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 16:16:05 2021 +0100

    build: version bump to flag existence of new API (link management)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 689a08607e7c0b8dea95c891e0a5cc525ff715ab
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 16:05:15 2021 +0100

    libmbim-glib,device: new method to check if link management is
    supported

 docs/reference/libmbim-glib/libmbim-glib-common.sections |  1 +
 src/libmbim-glib/mbim-device.c                           | 12
 ++++++++++++
 src/libmbim-glib/mbim-device.h                           | 14
 ++++++++++++++
 3 files changed, 27 insertions(+)

commit ef1f1bb49d509a3bc232469273396dadda755283
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 16:02:31 2021 +0100

    mbimcli: new '--link-delete-all' action

 src/mbimcli/mbimcli-link-management.c | 39
 ++++++++++++++++++++++++++++++++++-
 1 file changed, 38 insertions(+), 1 deletion(-)

commit 76029c38b592c26ca33e4d8a7891391d574cab89
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 15:59:46 2021 +0100

    libmbim-glib,device: new method to delete all links

 .../libmbim-glib/libmbim-glib-common.sections      |  2 +
 src/libmbim-glib/mbim-device.c                     | 53 +++++++++++++
 src/libmbim-glib/mbim-device.h                     | 45 +++++++++++
 src/libmbim-glib/mbim-net-port-manager.c           | 91
 ++++++++++++++++++++++
 src/libmbim-glib/mbim-net-port-manager.h           |  9 +++
 5 files changed, 200 insertions(+)

commit de919e3f1fa28662921315818a30ea338d5a5c66
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 15:52:38 2021 +0100

    mbimcli: new '--link-list' operation

 src/mbimcli/mbimcli-link-management.c | 39
 +++++++++++++++++++++++++++++++++--
 1 file changed, 37 insertions(+), 2 deletions(-)

commit fc42c0cb65b478606692d2b98ee0c8b5030319a9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 15:50:12 2021 +0100

    libmbim-glib,device: new list links operation

    We rely on sysfs to tell us which links a given network interface
    already has.

 .../libmbim-glib/libmbim-glib-common.sections      |  1 +
 src/libmbim-glib/mbim-device.c                     | 21 +++++
 src/libmbim-glib/mbim-device.h                     | 17 ++++
 src/libmbim-glib/mbim-helpers.c                    | 92
 ++++++++++++++++++++++
 src/libmbim-glib/mbim-helpers.h                    | 20 +++++
 src/libmbim-glib/mbim-net-port-manager.c           | 17 ++++
 src/libmbim-glib/mbim-net-port-manager.h           |  5 ++
 7 files changed, 173 insertions(+)

commit be9300434f3ce648a484d8fe0e3e1b50b70cc349
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 12:49:41 2021 +0100

    mbimcli: new '--link-add' and '--link-delete' operations

 src/mbimcli/Makefile.am               |   1 +
 src/mbimcli/mbimcli-link-management.c | 241
 ++++++++++++++++++++++++++++++++++
 src/mbimcli/mbimcli.c                 |  10 ++
 src/mbimcli/mbimcli.h                 |   7 +
 4 files changed, 259 insertions(+)

commit b2b4b06983513b451a6b7e71a2a779954763b3e2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 12:15:54 2021 +0100

    libmbim-glib,device: new link add/delete operations

    The MBIM devices support multiplexing as part of the protocol itself,
    and in the cdc_mbim driver this feature has been supported from the
    very first version of the driver.

    In the cdc_mbim driver, MBIM IP sessions are mapped to VLAN IDs
    matching the MBIM session IDs, and so we can use netlink operations to
    request adding or removing links as appropriate.

    This operation is completely equivalent to the link management
    operations done in libqmi when using RMNET, so the new net port
    manager internal object running the netlink operations is highly based
    on the QmiNetPortManagerRmnet class defined in libqmi-glib.

    Unlike in the libqmi case, there are no other supported net link
    management backends, just one, so the MbimNetPortManager is not an
    abstract class, it is instead the class implementing support for the
    single cdc_mbim backend.

 docs/reference/libmbim-glib/Makefile.am            |   3 +-
 .../libmbim-glib/libmbim-glib-common.sections      |   8 +
 src/libmbim-glib/Makefile.am                       |   1 +
 src/libmbim-glib/mbim-device.c                     | 235 ++++++++
 src/libmbim-glib/mbim-device.h                     | 127 ++++
 src/libmbim-glib/mbim-net-port-manager.c           | 658
 +++++++++++++++++++++
 src/libmbim-glib/mbim-net-port-manager.h           |  82 +++
 7 files changed, 1113 insertions(+), 1 deletion(-)

commit 00d0ae42fd12e00960801a1cb5367c4d8b84d96c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 12:55:32 2021 +0100

    mbimcli: minor coding style update

 src/mbimcli/mbimcli.c | 27 +++++++++------------------
 1 file changed, 9 insertions(+), 18 deletions(-)

commit 71634f988063dc870e391ef8a1f04526311c83a4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 12:52:01 2021 +0100

    mbimcli: fix error reporting when multiple actions requested

    When more than one action from a given service was requested, instead
    of reporting an error, we were silently running the first action
    processed, which is not right. E.g.:

       $ sudo mbimcli -d /dev/cdc-wdm0 -p --ms-query-lte-attach-status
       --atds-query-signal
       [/dev/cdc-wdm0] Signal info retrieved:
                  RSSI: -51 dBm
                   BER: unknown (99)
                  RSCP: unknown
                 Ec/No: unknown
                  RSRQ: -3,00 dBm
                  RSRP: -69 dBm
                 RSSNR: 29 dB

    Return an error instead.

 src/mbimcli/mbimcli.c | 33 ++++++++++++++++++++++++---------
 1 file changed, 24 insertions(+), 9 deletions(-)

commit ec8a342b238be12daf3280a9ccaf1f73c61bd542
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Mar 9 11:03:19 2021 +0100

    libmbim-glib,helpers: move all private helper methods to separate
    files

    Instead of having them listed in the installed mbim-utils.h

 docs/reference/libmbim-glib/Makefile.am |   3 +-
 src/libmbim-glib/Makefile.am            |   1 +
 src/libmbim-glib/mbim-helpers.c         | 115
 ++++++++++++++++++++++++++++++++
 src/libmbim-glib/mbim-helpers.h         |  49 ++++++++++++++
 src/libmbim-glib/mbim-proxy.c           |   7 +-
 src/libmbim-glib/mbim-utils.c           |  92 +------------------------
 src/libmbim-glib/mbim-utils.h           |  11 ---
 7 files changed, 172 insertions(+), 106 deletions(-)

commit 8806463b3eb6ff570c504d574e08b791b3c69067
Author: Michal Mazur <mkm@semihalf.com>
Date:   Fri Feb 19 23:34:16 2021 +0100

    mbimcli: extend pin operation to support other lock types

 src/mbimcli/mbimcli-basic-connect.c | 70
 ++++++++++++++++++++++---------------
 src/mbimcli/mbimcli-helpers.c       | 20 +++++++++++
 src/mbimcli/mbimcli-helpers.h       |  2 ++
 3 files changed, 64 insertions(+), 28 deletions(-)

commit 76c8be6976aab669f3e230ce9f00236405c67a3a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Feb 5 14:58:36 2021 +0100

    README: add CoC info

 README | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 2731324087a1ebead1ca326881f8da9f2172cba5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jan 22 10:23:11 2021 +0100

    build: add new RELEASING doc explaining how releases are made

 RELEASING | 35 +++++++++++++++++++++++++++++++++++
 1 file changed, 35 insertions(+)

commit e2b354698bdc7a8dde4afea607eefcd2da963e9d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 17 10:29:25 2021 +0100

    core: update copyright years to 2021

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 1 +
 src/mbim-proxy/mbim-proxy.c                       | 2 +-
 src/mbimcli/mbimcli.c                             | 2 +-
 utils/mbim-network.in                             | 2 +-
 4 files changed, 4 insertions(+), 3 deletions(-)

commit fdd51e505c230236ea07a88bc9178c09baa00ee3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 17 10:22:16 2021 +0100

    docs: add 'online-location' reference

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 55aca95335abc9f1e333b4ddc5af1e0dcc1259b6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 16 17:44:42 2021 +0100

    doc: skip running gtkdoc-rebase on local install step

    We can leave the relative paths to other books (e.g. '../glib')
    because running gtkdoc-rebase seems to be broken since the 1.29
    release, see:

      https://gitlab.gnome.org/GNOME/gtk-doc/-/issues/138

 gtk-doc.make | 1 -
 1 file changed, 1 deletion(-)

commit 97028c60c9e19cc44638d50fb956c70a25418a48
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 10 14:52:51 2021 +0100

    mbim-codegen: avoid struct plurals in method documentation

 build-aux/mbim-codegen/Message.py | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 6a0fd3881bf43df09c39ee0ee38584227c3b20c0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 10 14:45:03 2021 +0100

    docs: add missing doc for Transmission Status related enums

 docs/reference/libmbim-glib/libmbim-glib-common.sections | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 701de6d7a09c7f8ad24f4f920daf49c7a7c56c7e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 10 14:40:31 2021 +0100

    libmbim-glib,sar: renamed Transmission Status related enums

    Removing the MS prefix, and some other minor changes.

 data/mbim-service-ms-sar.json | 10 +++++-----
 src/libmbim-glib/mbim-enums.h | 28 ++++++++++++++--------------
 src/mbimcli/mbimcli-ms-sar.c  | 32 ++++++++++++++++----------------
 3 files changed, 35 insertions(+), 35 deletions(-)

commit d3ed5f90589e640268356ef9809a25bb4c7d6282
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 10 14:31:03 2021 +0100

    mbimcli,sar: set operations receive strings, not flags

 src/mbimcli/mbimcli-ms-sar.c | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 9cb417b25607bab80490c45d888832fe799ec2f4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 10 14:29:41 2021 +0100

    mbimcli,sar: reword command help items

    To be in line with other existing ones.

 src/mbimcli/mbimcli-ms-sar.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e9b5af35fad787c5440378118a5727a570c3f389
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 10 14:24:04 2021 +0100

    sar: add missing Since tags in enums

 src/libmbim-glib/mbim-enums.h | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 26ec43c5827ab6cd235550bb9b79e85c383303f1
Author: lvmaorui <ZRMaorui.Lu@fibocom.com>
Date:   Thu Dec 31 17:15:38 2020 +0800

    sar: add support for Transmission Status

    Added support for Set/Response/Indications in libmbim-glib, and
    Set/Response in mbimcli.

 data/mbim-service-ms-sar.json |  30 ++++++++-
 src/libmbim-glib/mbim-enums.h |  24 ++++++++
 src/mbimcli/mbimcli-ms-sar.c  | 137
 +++++++++++++++++++++++++++++++++++++++++-
 3 files changed, 189 insertions(+), 2 deletions(-)

commit 4545505d761471c928a0eeff96533e44e7dbd846
Author: maorui lv <zrmaorui.lu@fibocom.com>
Date:   Wed Dec 30 12:43:04 2020 +0000

    sar: remove the "Notification" of MBIM_CID_MS_SAR_CONFIG

    It's not applicable, see:
      https://docs.microsoft.com/en-us/windows-hardware/drivers/network/mb-sar-platform-support

 data/mbim-service-ms-sar.json |  15 ------
 src/mbimcli/mbimcli-ms-sar.c  | 113
 ++++++++++++++++++++++++++++++++++++++++--
 2 files changed, 110 insertions(+), 18 deletions(-)

commit aadfcd4375274ffd75741ccef75b3eb1b56d8d53
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Dec 15 11:27:28 2020 +0100

    sar: untabify JSON database

 data/mbim-service-ms-sar.json | 74
 +++++++++++++++++++++----------------------
 1 file changed, 37 insertions(+), 37 deletions(-)

commit 1885243204383cf34ff45072f299a93035550c66
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Dec 13 17:34:52 2020 +0100

    build: bump version to 1.25.1 to flag existence of new API (SAR
    service)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2584a183216af8ebedc2e7c17f2748fea9ef131e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Nov 26 00:48:51 2020 +0100

    docs: add API index for 1.26

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 4 ++++
 1 file changed, 4 insertions(+)

commit c9f0a326e70500c7da0a7065e87fcccc6c01f9dd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Nov 26 00:47:32 2020 +0100

    build,codegen: avoid using ${name}s

    So that gtk-doc doesn't complain, e.g.:
      html/libmbim-glib-MS-SAR.html:113: warning:
      no link for: "MbimSarConfigStates" -> (<span
      class="type">MbimSarConfigStates</span>).

 build-aux/mbim-codegen/Struct.py | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fe83ee4c1a28d5282cb5b4ff7d1f08b8b623b152
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Nov 26 00:00:23 2020 +0100

    sar: new service

    For now just with the "Config" message, and mbimcli query support.

 data/Makefile.am                                   |   1 +
 data/mbim-service-ms-sar.json                      |  64 +++++++
 docs/man/Makefile.am                               |   1 +
 docs/reference/libmbim-glib/Makefile.am            |   1 +
 .../libmbim-glib/libmbim-glib-common.sections      |  21 +++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml  |   1 +
 src/libmbim-glib/generated/Makefile.am             |  12 ++
 src/libmbim-glib/libmbim-glib.h                    |   1 +
 src/libmbim-glib/mbim-cid.c                        |  15 ++
 src/libmbim-glib/mbim-cid.h                        |  16 ++
 src/libmbim-glib/mbim-enums.h                      |  39 +++++
 src/libmbim-glib/mbim-message.c                    |   4 +
 src/libmbim-glib/mbim-uuid.c                       |  13 ++
 src/libmbim-glib/mbim-uuid.h                       |  13 ++
 src/libmbim-glib/test/test-cid.c                   |   9 +
 src/libmbim-glib/test/test-uuid.c                  |   8 +
 src/mbimcli/Makefile.am                            |   1 +
 src/mbimcli/mbimcli-completion                     |   2 +-
 src/mbimcli/mbimcli-ms-sar.c                       | 195
 +++++++++++++++++++++
 src/mbimcli/mbimcli.c                              |   8 +
 src/mbimcli/mbimcli.h                              |   4 +
 21 files changed, 428 insertions(+), 1 deletion(-)

commit d0ecfdab87dde3e2c63c7d034e7d8199bfb2921f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Nov 26 00:21:17 2020 +0100

    build: update builtin gtk-doc support

    From gtkdocize (gtk-doc) 1.33.0.

 gtk-doc.make  | 19 +++++++++++++++++++
 m4/gtk-doc.m4 | 27 ++++++++++++++++++++++++++-
 2 files changed, 45 insertions(+), 1 deletion(-)

commit 83736783fcbca51aed49e6acf942ee560546a9b6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Nov 26 00:20:05 2020 +0100

    build: fix distcheck with new gtk-doc

    The .actions file is generated by newer gtk-doc releases, we just
    treat it as e.g. the .signals or .types files.

    This is also already fixed in upstream gtk-doc:
      https://gitlab.gnome.org/GNOME/gtk-doc/-/merge_requests/61

 .gitignore                              | 1 +
 docs/reference/libmbim-glib/Makefile.am | 1 +
 2 files changed, 2 insertions(+)

commit f007997cc15494aac4791bc13b24bb118e6cdc91
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 13 11:53:36 2020 +0100

    libmbim-glib,device: don't warn if descriptors file cannot be read

    This is possibly just because we're not using cdc_mbim, it shouldn't
    be a reason to warn anything.

 src/libmbim-glib/mbim-device.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit aff2313b4153a05f6466ebd337f53354398b25f2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 13 11:51:19 2020 +0100

    libmbim-glib,device: realpath() returns NULL if path doesn't exist

    Running realpath() on a path that doesn't exist returns NULL, so don't
    even attempt to run g_file_test() on it. The g_file_test() may even be
    redundant, but well.

 src/libmbim-glib/mbim-device.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3d397f80b201e25caa10a0f92ef40b35290c1ac8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 13 11:39:25 2020 +0100

    libmbim-glib: drop GUdev optional build dependency

    GUdev is used only to find the descriptors file in sysfs in order to
    read the max control transfer from it.

    This operation is also implemented without GUdev for
    systems (e.g. OpenWRT) that don't use udev, using plain sysfs
    lookups.

    Therefore, there's no real need to keep the GUdev based implementation
    just for this single purpose. Drop it, and keep only the generic sysfs
    based implementation.

 .gitlab-ci.yml                 |  3 +-
 configure.ac                   | 32 ---------------
 src/libmbim-glib/mbim-device.c | 89
 ------------------------------------------
 3 files changed, 1 insertion(+), 123 deletions(-)

commit ef133a7a59874cfed3e9afff896ad05505f58769
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 13 10:11:13 2020 +0100

    libmbim-glib,device: avoid using an already unref-ed source

    We were creating the source, attaching it to the main context, and
    removing our reference right away. That meant that the ownership of
    the source was fully given to the main context, and so we shouldn't
    have attempted to remove it from the main context later on, as it
    could have already been fired and removed behind our back.

    Solve this, by making sure we keep a valid source reference of our
    own, and in this way we can safely destroy the source (it's fine to
    destroy an already destroyed source, as long as the reference is
    valid) and then fully unref it.

      ModemManager[55085]: transaction 0x6 aborted, but message is
      not abortable
      ModemManager[55085]: [/dev/mhi_MBIM] MBIM error: Cannot write
      message: Broken pipe

      (ModemManager:55085): GLib-CRITICAL **: 10:04:58.605:
      g_source_destroy: assertion 'g_atomic_int_get (&source->ref_count)
      > 0' failed

      Thread 1 "ModemManager" received signal SIGTRAP, Trace/breakpoint
      trap.
      0x00007ffff775ef23 in g_logv () from /usr/lib/libglib-2.0.so.0
      (gdb) bt
      #0  0x00007ffff775ef23 in g_logv () at /usr/lib/libglib-2.0.so.0
      #1  0x00007ffff775f1a0 in g_log () at /usr/lib/libglib-2.0.so.0
      #2  0x00007ffff7a8f564 in transaction_context_free
      (ctx=0x5555558254a0) at mbim-device.c:162
      #3  0x00007ffff79240ba in  () at /usr/lib/libgio-2.0.so.0
      #4  0x00007ffff78537b1 in g_object_unref () at
      /usr/lib/libgobject-2.0.so.0
      #5  0x00007ffff77512b3 in  () at /usr/lib/libglib-2.0.so.0
      #6  0x00007ffff775384a in  () at /usr/lib/libglib-2.0.so.0
      #7  0x00007ffff7756b90 in g_main_context_dispatch () at
      /usr/lib/libglib-2.0.so.0
      #8  0x00007ffff77a81f9 in  () at /usr/lib/libglib-2.0.so.0
      #9  0x00007ffff7756163 in g_main_loop_run () at
      /usr/lib/libglib-2.0.so.0
      #10 0x00005555555a0b15 in main (argc=2, argv=0x7fffffffeac8)
      at main.c:206

 src/libmbim-glib/mbim-device.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit f59b3f513ad04f83ae96db443fc5352118dd678f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Oct 1 12:01:28 2020 +0200

    libmbim-glib,device: get_transaction_id() already in 1.24.4

    (cherry picked from commit 2f870ec400c4c12513d809eccde1da34e80f7d9f)

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 6 +++---
 src/libmbim-glib/mbim-device.h                    | 2 +-
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 34ce4755f8e926f7c9fa20b777e8cd7aa1720dae
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Oct 1 12:11:58 2020 +0200

    docs: add missing references to mbim_device_get_transaction_id()

 docs/reference/libmbim-glib/libmbim-glib-common.sections | 1 +
 docs/reference/libmbim-glib/libmbim-glib-docs.xml        | 4 ++++
 2 files changed, 5 insertions(+)

commit 7e0957dfdeb66368a5a0e281800a2f203dc6d6e5
Author: wicadmin <west.indian.cricket@gmail.com>
Date:   Tue Sep 29 08:56:25 2020 +0000

    ci: create release tarball and hash as build artifacts

 .gitlab-ci.yml | 8 ++++++++
 1 file changed, 8 insertions(+)

commit e266810e03712ac79b0bf4682c92a4834e216b9b
Author: Bjørn Mork <bjorn@mork.no>
Date:   Mon Sep 21 13:08:38 2020 +0200

    libmbim-glib,proxy: use same transaction id for all fragments

    All fragments must have the same transaction id.

    Signed-off-by: Bjørn Mork <bjorn@mork.no>

 src/libmbim-glib/mbim-device.c | 10 ++++++++++
 src/libmbim-glib/mbim-device.h | 13 +++++++++++++
 src/libmbim-glib/mbim-proxy.c  |  8 ++++++--
 3 files changed, 29 insertions(+), 2 deletions(-)

commit feaf875cee6e1a0ed36a495f68edc3810e6c89c8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 9 11:10:53 2020 +0200

    mbim-network: don't manage MBIM channel open when using the proxy

    If we're using the proxy, we should not try to handle the status of
    the MBIM channel or attempt to keep the flow of transaction ids in the
    mbim-network program, because that is implicitly done by the proxy
    itself.

 utils/mbim-network.in | 100
 ++++++++++++++++++++++++++++++++++----------------
 1 file changed, 68 insertions(+), 32 deletions(-)

commit 830885ba9f5d6f77cf13f91c14933ad0ed262114
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 9 09:43:53 2020 +0200

    libmbim-glib,proxy: improve per-device operation logging

 src/libmbim-glib/mbim-proxy.c | 35 ++++++++++++++++++-----------------
 1 file changed, 18 insertions(+), 17 deletions(-)

commit d3ac22b5d5b47c0fc35dafd9862de3707f231acc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 9 09:19:12 2020 +0200

    libmbim-glib,proxy: improve per-client operation logging

 src/libmbim-glib/mbim-proxy.c | 140
 +++++++++++++++++++++++++++++-------------
 1 file changed, 99 insertions(+), 41 deletions(-)

commit 927706715bd91cc5cd681f29a6c643dc7d16047c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 9 09:42:40 2020 +0200

    libmbim-glib,proxy: don't acquire device context during untrack

    Because if the context was never created, we would be creating it at
    this point, and it wouldn't make sense to do so; e.g.:

      [Debug] [/dev/cdc-wdm1] unexpected port hangup!
      [Debug] [/dev/cdc-wdm1] channel destroyed
      [Debug] Initial device subscribe list...
      [Debug] [service 0] a289cc33-bcbb-8b4f-b6b0-133ec2aae6df
      (basic-connect)
      [Debug] [service 0] 11 CIDs enabled
      [Debug] [service 0] [cid 0] 2 (subscriber-ready-status)
      [Debug] [service 0] [cid 1] 3 (radio-state)

 src/libmbim-glib/mbim-proxy.c | 7 ++-----
 1 file changed, 2 insertions(+), 5 deletions(-)

commit 21f797058c07139e128e0b10850e921a2e982ad0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 9 10:16:54 2020 +0200

    mbimcli: add missing EOL in error print when closing device

        [09 ago 2020, 10:15:51] [Debug] [/dev/cdc-wdm1] Received message
        (translated)...
        >>>>>> Header:
        >>>>>>   length      = 16
        >>>>>>   type        = function-error (0x80000004)
        >>>>>>   transaction = 11
        >>>>>> Contents:
        >>>>>>   error = 'NotOpened' (0x00000005)

        error: couldn't close device: MBIM protocol error: NotOpened[09
        ago 2020, 10:15:51] [Debug] [/dev/cdc-wdm1] channel destroyed

 src/mbimcli/mbimcli.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 095cd71491adeab32bdc00cc247487327114e1d0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 9 08:48:52 2020 +0200

    libmbim-glib,proxy: avoid double GError free

 src/libmbim-glib/mbim-proxy.c | 1 -
 1 file changed, 1 deletion(-)

commit ecd188ff0126866199fd453e962ba54ba1dce290
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 10 10:17:01 2020 +0200

    libmbim-glib,proxy: fix reporting of merged subscribe list

    We were doing the subscribe list merge correctly, but not reporting it
    as done because the 'updated' pointer is set to NULL before returning
    it.

    This was breaking QMI over MBIM indications, as the registration
    message to request them was never sent to the device.

 src/libmbim-glib/mbim-proxy.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0590b7e911df6e014fa6a7ec48a291f33a53d580
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 28 09:08:54 2020 +0200

    libmbim-glib,proxy: fix segfault when printing updated subscriber list

    We were printing the 'updated' variable after its contents had already
    been stolen.

        [28 Jun 2020, 03:06:27] [Debug] Merged service subscribe list
        built for device '/dev/cdc-wdm0'
        Thread 1 "mbim-proxy" received signal SIGSEGV, Segmentation fault.
        _mbim_proxy_helper_service_subscribe_list_debug
        (list=list@entry=0x0, list_size=6) at mbim-proxy-helpers.c:104
        104         const MbimEventEntry *entry = list[i];
        (gdb) p list
        $1 = (const MbimEventEntry * const *) 0x0
        (gdb) p list_size
        $2 = 6

    The segfault was only triggered when the mbim-proxy was run with
    --verbose.

 src/libmbim-glib/mbim-proxy.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit cbb3e3944452a940ba583020882d13f2e49acd27
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jun 23 10:44:36 2020 +0200

    libmbim-glib,device: ignore messages with wrong MBIM message type

    The Cinterion mPLS62-w may end up sending messages which are clearly
    not well formatted MBIM messages, and upon receiving one of them, the
    mbim-proxy would get completely stuck (e.g. attempting to read a
    message of >800MB because of the reported length in the first
    malformed messae).

    Try to avoid this, by doing an initial filter by message type, which
    at least solves the seen problem. Not a fully robust fix yet, though.

    E.g. new logs:

        [23 jun 2020, 10:43:49] [Debug] [/dev/cdc-wdm1] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 48
        <<<<<<   type        = command (0x00000003)
        <<<<<<   transaction = 20
        <<<<<< Fragment header:
        <<<<<<   total   = 1
        <<<<<<   current = 0
        <<<<<< Contents:
        <<<<<<   service = 'atds' (5967bdcc-7fd2-49a2-9f5c-b2e70e527db3)
        <<<<<<   cid     = 'location' (0x00000002)
        <<<<<<   type    = 'query' (0x00000000)

        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        293 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        200 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        168 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        311 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        311 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        311 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        335 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        277 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        312 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        314 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        312 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        280 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        312 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        312 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        326 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        260 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        244 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        326 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        326 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        326 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        306 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        334 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        324 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        356 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        356 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        191 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        201 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        356 bytes in MBIM stream as message type validation fails
        [23 jun 2020, 10:43:49] -Warning ** [/dev/cdc-wdm1] discarding
        356 bytes in MBIM stream as message type validation fails

 src/libmbim-glib/mbim-device.c | 29 ++++++++++++++++++++++++++++-
 1 file changed, 28 insertions(+), 1 deletion(-)

commit a5e8f71c5d33b3471632280af5e21790b335c08c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 18 10:53:49 2020 +0200

    build: post-release version bump to 1.25.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1a186e61a34e0b267cc91e9a72dd266429ab6408
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 18 10:40:31 2020 +0200

    release: bump version to 1.24.0

 configure.ac | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 53dd98b856711845af761d2bab2779e85aa45520
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 30 13:11:49 2020 +0200

    AUTHORS: update with latest commit stats

 AUTHORS | 2 ++
 1 file changed, 2 insertions(+)

commit 30dd906a658bbd182c252f046c76697218d1da8b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 30 08:59:15 2020 +0200

    example: always perform a clean exit, even on error

 examples/simple-tester-python/simple-tester-python | 2 --
 1 file changed, 2 deletions(-)

commit ede2849ce88e951ab1b07a6d80406e571b6d21aa
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 30 08:56:04 2020 +0200

    example: GObject import not explicitly required

 examples/simple-tester-python/simple-tester-python | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2f8c625da4b8b9faad0b9120aa1613ae53b47661
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri May 29 18:30:21 2020 +0200

    example: separate with 2 whitelines the program methods

 examples/simple-tester-python/simple-tester-python | 6 ++++++
 1 file changed, 6 insertions(+)

commit 3564fde972c3e39aeccd589ed4919aa058dd23ca
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri May 29 18:16:34 2020 +0200

    example: don't attempt to continue logic after quitting main loop

 examples/simple-tester-python/simple-tester-python | 3 +++
 1 file changed, 3 insertions(+)

commit 47e2ed70db68f655710a558e03bc0d77e3be96d4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 14:02:03 2020 +0200

    build: bump version to 1.23.900 (1.24-rc1)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f9bb4d26175512cc2b3084189fc9826a78fbd43d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 14:01:20 2020 +0200

    NEWS: update for 1.24

 NEWS | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 3757cf5a1946613d3b11fa6af6f262097967759a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 13:49:04 2020 +0200

    libmbim-glib: skip unneeded methods from introspection

    Don't add in introspection the methods reading GObject properties.

 src/libmbim-glib/mbim-device.h | 4 ++--
 src/libmbim-glib/mbim-proxy.h  | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 368450ecec0cce1abca098995428733d6db38b88
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 13:45:15 2020 +0200

    mbim-codegen: setup introspection annotations in message creators

 build-aux/mbim-codegen/Message.py | 34 +++++++++++++++++-----------------
 1 file changed, 17 insertions(+), 17 deletions(-)

commit aedc73750a10f3bb18a72e0a9bb63863a6390c34
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 10:50:41 2020 +0200

    examples: new simple python tester for introspection support

 Makefile.am                                        |   2 +-
 configure.ac                                       |   2 +
 examples/Makefile.am                               |   1 +
 examples/simple-tester-python/Makefile.am          |   2 +
 examples/simple-tester-python/README               |  29 ++++++
 examples/simple-tester-python/simple-tester-python | 102
 +++++++++++++++++++++
 6 files changed, 137 insertions(+), 1 deletion(-)

commit 8612624c1d674f9f23cd4b442060dce1d4d34873
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 11:56:05 2020 +0200

    mbim-codegen: set array detail annotations

 build-aux/mbim-codegen/Message.py | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit b1d92278f9689547894d0aa28228b53636f3c47c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 11:00:17 2020 +0200

    mbim-codegen: set transfer annotations in parsers

 build-aux/mbim-codegen/Message.py | 32 ++++++++++++++++----------------
 1 file changed, 16 insertions(+), 16 deletions(-)

commit 539e570b161c7127c3a267493cf760cd41ec586c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 27 10:51:06 2020 +0200

    mbim-codegen: explicitly flag as optional outputs all fields in
    parsers

 build-aux/mbim-codegen/Message.py | 34 +++++++++++++++++-----------------
 1 file changed, 17 insertions(+), 17 deletions(-)

commit 891ff842fdb84a2f8628a19af89794a9c4287623
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 13:32:50 2020 +0200

    mbim-codegen: avoid needing python packaging.version.parse

 build-aux/mbim-codegen/Struct.py |  4 +---
 build-aux/mbim-codegen/utils.py  | 21 +++++++++++++++++++++
 2 files changed, 22 insertions(+), 3 deletions(-)

commit fc550c38e88f6228a492546f1d75edb98846a194
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 06:42:26 2020 +0200

    docs,libmbim-glib: include API indices

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 50
 +++++++++++++++++++++--
 1 file changed, 47 insertions(+), 3 deletions(-)

commit 03f4969bc7d79e1d6aa78af2fa69d6ff1de815ca
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 13:07:59 2020 +0200

    build-aux: include Since tag in methods built from enums

 build-aux/templates/mbim-enum-types-template.c |  17 ----
 build-aux/templates/mbim-enum-types-template.h |  21 +++++
 src/libmbim-glib/mbim-cid.h                    |  28 +++----
 src/libmbim-glib/mbim-device.h                 |   2 +-
 src/libmbim-glib/mbim-enums.h                  | 112
 ++++++++++++-------------
 src/libmbim-glib/mbim-errors.h                 |   6 +-
 src/libmbim-glib/mbim-message.h                |   4 +-
 src/libmbim-glib/mbim-uuid.h                   |   4 +-
 8 files changed, 99 insertions(+), 95 deletions(-)

commit 0237c972093c716eeab82a94272cd0ae8a00426f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 12:54:20 2020 +0200

    build-aux: import custom mkenums tool

    Equivalent to the glib-mkenums released in 2.66, we just include it in
    the repo to be able to use it earlier than requiring 2.66 in the whole
    project.

 build-aux/Makefile.am                  |   4 +-
 build-aux/mbim-mkenums                 | 788
 +++++++++++++++++++++++++++++++++
 configure.ac                           |   3 -
 src/libmbim-glib/generated/Makefile.am |  10 +-
 4 files changed, 796 insertions(+), 9 deletions(-)

commit 4c2a7b4f8285dfbf7ff3c45c142c454f5f5530b9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 09:10:36 2020 +0200

    libmbim-glib: add Since tags to all API types and methods

 src/libmbim-glib/mbim-cid.h        |  40 +++++++-
 src/libmbim-glib/mbim-compat.h     |  12 ++-
 src/libmbim-glib/mbim-device.c     |  21 ++++
 src/libmbim-glib/mbim-device.h     |  92 +++++++++++++++++-
 src/libmbim-glib/mbim-enums.h      | 194
 +++++++++++++++++++++++++++++--------
 src/libmbim-glib/mbim-errors.h     |  10 +-
 src/libmbim-glib/mbim-message.h    |  92 ++++++++++++++++++
 src/libmbim-glib/mbim-proxy.c      |  11 ++-
 src/libmbim-glib/mbim-proxy.h      |  40 +++++++-
 src/libmbim-glib/mbim-utils.h      |   4 +
 src/libmbim-glib/mbim-uuid.h       |  72 ++++++++++++--
 src/libmbim-glib/mbim-version.h.in |   8 ++
 12 files changed, 536 insertions(+), 60 deletions(-)

commit 8abe015a9ab756b2248df892a6b601d17e1a6611
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 07:05:16 2020 +0200

    mbim-codegen: add Since tags to all public structs and methods

 build-aux/mbim-codegen/Message.py | 236
 +++++++++++++++++++++-----------------
 build-aux/mbim-codegen/Struct.py  |  46 +++++---
 2 files changed, 159 insertions(+), 123 deletions(-)

commit e20be27adea9fbc0ebcca4fe74e4d872fea75bad
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 18 06:15:27 2020 +0200

    data: add 'since' version tags to all messages

    E.g.:
      "since" : "1.0"

    Or per-message-type version tags with 'since-ex', e.g.:
      "since-ex" : { "query"        : "1.0",
                     "response"     : "1.0",
                     "notification" : "1.8" },

 data/mbim-service-atds.json                        |   6 +
 data/mbim-service-auth.json                        |   9 +-
 data/mbim-service-basic-connect.json               | 163 ++++++----
 data/mbim-service-dss.json                         |   1 +
 data/mbim-service-intel-firmware-update.json       |   9 +-
 data/mbim-service-ms-basic-connect-extensions.json |   6 +
 data/mbim-service-ms-firmware-id.json              |   1 +
 data/mbim-service-ms-host-shutdown.json            |   1 +
 data/mbim-service-phonebook.json                   |  73 ++---
 data/mbim-service-proxy-control.json               |   1 +
 data/mbim-service-qmi.json                         |  35 ++-
 data/mbim-service-sms.json                         | 347
 +++++++++++----------
 data/mbim-service-stk.json                         |   4 +-
 data/mbim-service-ussd.json                        |  69 ++--
 14 files changed, 402 insertions(+), 323 deletions(-)

commit 21f8b992e8d17c9fa944641c0e4e1c02a756c5a9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu May 14 19:24:41 2020 +0200

    libmbim-glib,proxy: fix proxy reference count

    Fixes bf9a52868047c11463692a57fdda6af9f0b59588

 src/libmbim-glib/mbim-proxy.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 91d107fd4f052da5728656a45261aedde77de95e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 13 07:00:46 2020 +0200

    build: update list of ignored files

 .gitignore | 47 ++++++++++++++++++-----------------------------
 1 file changed, 18 insertions(+), 29 deletions(-)

commit c26e9494166ba45a36db65dc89362e2fed861136
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 13 06:02:10 2020 +0200

    libmbim-glib,introspection: add introspection support

 .gitlab-ci.yml               |  4 +-
 configure.ac                 | 26 +++++++-----
 m4/introspection.m4          | 97
 ++++++++++++++++++++++++++++++++++++++++++++
 src/libmbim-glib/Makefile.am | 40 ++++++++++++++++++
 4 files changed, 154 insertions(+), 13 deletions(-)

commit 0bf83040b3addca4dce3fea17f15292f33fbb403
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 13 06:55:54 2020 +0200

    libmbim-glib: move method docs to headers

 src/libmbim-glib/mbim-cid.c     |  45 ----
 src/libmbim-glib/mbim-cid.h     |  61 ++++-
 src/libmbim-glib/mbim-compat.c  |  33 ---
 src/libmbim-glib/mbim-compat.h  |  33 +++
 src/libmbim-glib/mbim-device.c  | 187 --------------
 src/libmbim-glib/mbim-device.h  | 294 ++++++++++++++++++----
 src/libmbim-glib/mbim-message.c | 373 ----------------------------
 src/libmbim-glib/mbim-message.h | 524
 +++++++++++++++++++++++++++++++++++-----
 src/libmbim-glib/mbim-proxy.c   |  16 --
 src/libmbim-glib/mbim-proxy.h   |  54 ++++-
 src/libmbim-glib/mbim-utils.c   |  13 -
 src/libmbim-glib/mbim-utils.h   |  17 +-
 src/libmbim-glib/mbim-uuid.c    | 109 ---------
 src/libmbim-glib/mbim-uuid.h    | 134 +++++++++-
 14 files changed, 984 insertions(+), 909 deletions(-)

commit f3f906bd4bcceac34a9e69accd819bb88fb68edf
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 17:13:29 2020 +0200

    ci: also test distcheck by default

 .gitlab-ci.yml | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit bf9a52868047c11463692a57fdda6af9f0b59588
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 16:58:37 2020 +0200

    libmbim-glib,proxy: port to use g_auto() helpers

 src/libmbim-glib/mbim-proxy.c | 164
 +++++++++++++++++-------------------------
 1 file changed, 64 insertions(+), 100 deletions(-)

commit 9e31bd6f3b4f2063b0b0d2ea78b1846e65e0ca3a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 16:39:47 2020 +0200

    libmbim-glib,message: port to use g_auto() helpers

 src/libmbim-glib/mbim-message.c | 65
 +++++++++++++++++------------------------
 1 file changed, 27 insertions(+), 38 deletions(-)

commit a4c7b1a17f7267a1146d33e39b41f70f7e110062
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 16:31:04 2020 +0200

    libmbim-glib,device: port to use g_auto() helpers

 src/libmbim-glib/mbim-device.c | 302
 ++++++++++++++++-------------------------
 1 file changed, 117 insertions(+), 185 deletions(-)

commit 1e4654e2b326cfc98d20b3171bc54d2654bb9b23
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 16:02:03 2020 +0200

    libmbim-glib,device: proxy_control_configuration_set_new() never fails

 src/libmbim-glib/mbim-device.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 073df58b71ac4edacddd18e4e822eae4cab0e59a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 14:54:17 2020 +0200

    mbim-codegen: port to use g_auto() helpers

 build-aux/mbim-codegen/Message.py | 57
 ++++++++++++++-------------------------
 build-aux/mbim-codegen/Struct.py  |  8 +++---
 2 files changed, 23 insertions(+), 42 deletions(-)

commit f8856c71607a0d2612cb5e9b050efd01f8c6e9d4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 14:46:20 2020 +0200

    mbim-proxy: port to use g_auto() helpers

 src/mbim-proxy/mbim-proxy.c | 8 +++-----
 1 file changed, 3 insertions(+), 5 deletions(-)

commit 00dcb26cd6993104cb2d255487df7e9d754d0e94
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 14:38:31 2020 +0200

    mbimcli: port to use g_auto() helpers

 src/mbimcli/mbimcli-atds.c                        |  50 +-
 src/mbimcli/mbimcli-basic-connect.c               | 735
 +++++++---------------
 src/mbimcli/mbimcli-dss.c                         |  61 +-
 src/mbimcli/mbimcli-helpers.c                     | 130 ++--
 src/mbimcli/mbimcli-intel-firmware-update.c       |  15 +-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c |  79 +--
 src/mbimcli/mbimcli-ms-firmware-id.c              |  25 +-
 src/mbimcli/mbimcli-ms-host-shutdown.c            |  13 +-
 src/mbimcli/mbimcli-phonebook.c                   |  89 +--
 src/mbimcli/mbimcli.c                             |  16 +-
 10 files changed, 400 insertions(+), 813 deletions(-)

commit 7ae92677360a57e796d10c982a0d4d125ae86731
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 11 16:33:02 2020 +0200

    build: bump version to 1.23.1 to flag existence of new API (autoptr
    support)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 50d43376a6ac9c6fc9a1e3d595675937ae90cc86
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Mar 21 15:19:58 2020 +0100

    mbimcli: remove empty whiteline in --version

    This also fixes the Copyright section in the troffit generated HTML
    output.

 src/mbimcli/mbimcli.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit adaeaa6ad14854655b092bdaf7e7b02f7d616ccd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Mar 21 15:09:00 2020 +0100

    mbimcli: add ':' to the section titles

    So that --help-all print all sections in the same way as the Help and
    Application option groups.

 src/mbimcli/mbimcli-atds.c                        | 2 +-
 src/mbimcli/mbimcli-basic-connect.c               | 2 +-
 src/mbimcli/mbimcli-dss.c                         | 2 +-
 src/mbimcli/mbimcli-intel-firmware-update.c       | 2 +-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c | 2 +-
 src/mbimcli/mbimcli-ms-firmware-id.c              | 2 +-
 src/mbimcli/mbimcli-ms-host-shutdown.c            | 2 +-
 src/mbimcli/mbimcli-phonebook.c                   | 2 +-
 8 files changed, 8 insertions(+), 8 deletions(-)

commit 4f67acb16e0dbafad78387090b8c086c2428f663
Author: Eric Caruso <ejcaruso@chromium.org>
Date:   Tue Feb 4 11:04:14 2020 -0800

    mbim-proxy: flag print_version_and_exit() as noreturn

 src/mbim-proxy/mbim-proxy.c | 1 +
 1 file changed, 1 insertion(+)

commit cc307468d078a28ea99660b33d740f563484d910
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 15 18:35:45 2020 +0100

    libmbim-glib,test: port message parser tests to use autoptr

 src/libmbim-glib/test/test-message-parser.c | 224
 +++++++++++-----------------
 1 file changed, 90 insertions(+), 134 deletions(-)

commit 7100b28963a34581ff44a7b43626ef81cd7c87e8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 15 18:09:32 2020 +0100

    libmbim-glib,mbim-codegen: define autoptr cleanup functions for
    all types

 build-aux/mbim-codegen/Message.py |  8 ++++----
 build-aux/mbim-codegen/Struct.py  | 21 ++++++++++++++++-----
 src/libmbim-glib/mbim-device.h    |  1 +
 src/libmbim-glib/mbim-message.h   |  2 ++
 src/libmbim-glib/mbim-proxy.h     |  1 +
 5 files changed, 24 insertions(+), 9 deletions(-)

commit 8819bb94affc97455f1716c71b10ca5a4a574879
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 15 17:37:22 2020 +0100

    build: bump minimum glib required version to 2.48

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f6506bccdfc43c3c89eaf928cf4576963fdacf32
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 15 17:33:21 2020 +0100

    build: post-release version bump to 1.23.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 697465da7e976d15b13061368d37f76d8e0c33c4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 15 16:09:39 2020 +0100

    release: bump version to 1.22.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit dfffc52415ef1504cd0c088b4cc7dbe5d54211f0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 15 16:07:54 2020 +0100

    NEWS: update for 1.22

 NEWS | 31 +++++++++++++++++++++++++++++++
 1 file changed, 31 insertions(+)

commit 2374eeabf2f163fba3f9680a3e95ddeef8bb8a2e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jan 9 11:36:51 2020 +0100

    libmbim-glib,message: fix build with -Wcast-align in ARM

      mbim-message.c: In function '_mbim_struct_builder_complete':
      mbim-message.c:534:24: error: cast increases required alignment
      of target type [-Werror=cast-align]
               offset_value = (guint32 *)
               &(builder->fixed_buffer->data[offset_offset]);
                            ^

 src/libmbim-glib/mbim-message.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 1c58bd3c10eca49eaf83afd667aa8e5b079bc8ad
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jan 3 20:38:31 2020 +0100

    build: bump copyright years to 2020

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 1 +
 src/mbim-proxy/mbim-proxy.c                       | 2 +-
 src/mbimcli/mbimcli.c                             | 2 +-
 3 files changed, 3 insertions(+), 2 deletions(-)

commit 9c82fe382b49808131a087e69de709ba988f0e47
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jan 3 20:35:16 2020 +0100

    mbimcli: flag print_version_and_exit() as noreturn

    Same thing as done in libqmi, see
    https://gitlab.freedesktop.org/mobile-broadband/libqmi/merge_requests/82

 src/mbimcli/mbimcli.c | 1 +
 1 file changed, 1 insertion(+)

commit 78541004048aa15880ca99b5e06b9d7529742c77
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Dec 23 08:24:02 2019 +0100

    test,basic-connect: fail provisioned contexts response without
    information buffer

 src/libmbim-glib/test/test-message-parser.c | 37
 +++++++++++++++++++++++++++++
 1 file changed, 37 insertions(+)

commit 2ed61627f885de72a20850b02f262a7e851240c3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Dec 21 16:48:45 2019 +0100

    libmbim-glib,device: plug memleak when processing Open errors

       ==8725== 40 (16 direct, 24 indirect) bytes in 1 blocks are
       definitely lost in loss record 825 of 1,273
       ==8725==    at 0x483877F: malloc (vg_replace_malloc.c:309)
       ==8725==    by 0x4B7C8D9: g_malloc (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x4B5D893: g_slice_alloc (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x4B979DA: g_error_copy (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x48AA3BC: transaction_task_complete_and_free
       (mbim-device.c:243)
       ==8725==    by 0x48AAE00: finalize_pending_open_request
       (mbim-device.c:541)
       ==8725==    by 0x48AB12B: process_message (mbim-device.c:632)
       ==8725==    by 0x48AB530: parse_response (mbim-device.c:762)
       ==8725==    by 0x48AB844: data_available (mbim-device.c:842)
       ==8725==    by 0x4B8226E: g_main_context_dispatch (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x4B841B0: ??? (in /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x4B850C2: g_main_loop_run (in
       /usr/lib/libglib-2.0.so.0.6200.3)

 src/libmbim-glib/mbim-device.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 4d5a77fe68feeef3c0aed27c865ac7645760789b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Dec 21 16:38:40 2019 +0100

    libmbim,device: plug memleak when processing responses with multiple
    fragments

       ==8725== 48 bytes in 3 blocks are definitely lost in loss record
       840 of 1,273
       ==8725==    at 0x483877F: malloc (vg_replace_malloc.c:309)
       ==8725==    by 0x4B7C8D9: g_malloc (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x4B5D893: g_slice_alloc (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x48AA78D: device_store_transaction
       (mbim-device.c:371)
       ==8725==    by 0x48AE34C: mbim_device_command (mbim-device.c:2218)
       ==8725==    by 0x48B0E83: process_command (mbim-proxy.c:1020)
       ==8725==    by 0x48B0F8C: process_message (mbim-proxy.c:1052)
       ==8725==    by 0x48B1052: parse_request (mbim-proxy.c:1091)
       ==8725==    by 0x48B1279: connection_readable_cb
       (mbim-proxy.c:1140)
       ==8725==    by 0x49D32E9: ??? (in /usr/lib/libgio-2.0.so.0.6200.3)
       ==8725==    by 0x4B8226E: g_main_context_dispatch (in
       /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==    by 0x4B841B0: ??? (in /usr/lib/libglib-2.0.so.0.6200.3)
       ==8725==

 src/libmbim-glib/mbim-device.c | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit 0d3017abc39d14d4c8356f54af81aa4dbb0f4e79
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Dec 21 15:57:00 2019 +0100

    libmbim-glib,proxy: validate service subscribe request before parsing

 src/libmbim-glib/mbim-proxy-helpers.c | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit a5089b41e442bbd9fedcb51e976b3cbdab360f32
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Dec 21 15:30:19 2019 +0100

    mbim-codegen,message: information buffer only required if fields
    expected

    If a MBIM response/indication message does not expect any field in
    payload, don't even validate the existence of the information buffer.

    E.g. the SMS delete response doesn't have any field, so we shouldn't
    fail when we detect that:

        ModemManager[6065]: [/dev/cdc-wdm0] Received message
        (translated)...
        >>>>>> Header:
        >>>>>>   length      = 48
        >>>>>>   type        = command-done (0x80000003)
        >>>>>>   transaction = 36
        >>>>>> Fragment header:
        >>>>>>   total   = 1
        >>>>>>   current = 0
        >>>>>> Contents:
        >>>>>>   status error = 'None' (0x00000000)
        >>>>>>   service      = 'sms'
        (533fbeeb-14fe-4467-9f90-33a223e56c3f)
        >>>>>>   cid          = 'delete' (0x00000004)
        ModemManager[6065]: <debug> [1576938340.872769] Couldn't delete
        SMS part with index 3: 'Message does not have information buffer'

 build-aux/mbim-codegen/Message.py | 38
 ++++++++++++++++++++++----------------
 1 file changed, 22 insertions(+), 16 deletions(-)

commit a850e71dadc4a109b81d580b6c2d7be1132b1f32
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 22:14:01 2019 +0100

    libmbim-glib,test: add test for failed message parsing

 src/libmbim-glib/test/test-message-parser.c | 48
 +++++++++++++++++++++++++++++
 1 file changed, 48 insertions(+)

commit b9d63f822a57fc09afacbef37cbe2cd57bd1054d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 22:05:22 2019 +0100

    build-aux,message: no longer need early out count management

 build-aux/mbim-codegen/Message.py | 53
 +++------------------------------------
 1 file changed, 3 insertions(+), 50 deletions(-)

commit 02631fbb74c5daed91f1d56595b4bab0ed54d962
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 21:56:21 2019 +0100

    build-aux,struct: no longer need early out count management

 build-aux/mbim-codegen/Struct.py | 23 ++---------------------
 1 file changed, 2 insertions(+), 21 deletions(-)

commit d498e9323ea133de9993d1fba7f4d548e8ca2152
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 21:42:26 2019 +0100

    libmbim-glib,message: reading IPv6 array may fail

 build-aux/mbim-codegen/Message.py       |  9 ++++---
 src/libmbim-glib/mbim-message-private.h |  9 ++++---
 src/libmbim-glib/mbim-message.c         | 43
 +++++++++++++++++++++++++--------
 3 files changed, 44 insertions(+), 17 deletions(-)

commit 5ddf637c1636c79eaf69dee6fb5223fea9766927
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 21:34:02 2019 +0100

    libmbim-glib,message: reading IPv6 may fail

 build-aux/mbim-codegen/Message.py       | 18 ++++++++++-----
 build-aux/mbim-codegen/Struct.py        | 22 ++++++++++++++----
 src/libmbim-glib/mbim-message-private.h |  8 ++++---
 src/libmbim-glib/mbim-message.c         | 40
 ++++++++++++++++++++++++++-------
 4 files changed, 67 insertions(+), 21 deletions(-)

commit f39f22bd173b27b925b8aaa76650d92ea72584c0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 20:17:06 2019 +0100

    libmbim-glib,message: reading IPv4 array may fail

 build-aux/mbim-codegen/Message.py       |  9 ++++---
 src/libmbim-glib/mbim-message-private.h |  8 ++++---
 src/libmbim-glib/mbim-message.c         | 42
 +++++++++++++++++++++++++--------
 3 files changed, 43 insertions(+), 16 deletions(-)

commit 91568c1a79790754eecaaeaf0cf53c27c6494c49
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 20:07:25 2019 +0100

    libmbim-glib,message: reading IPv4 may fail

 build-aux/mbim-codegen/Message.py       | 18 ++++++++++-----
 build-aux/mbim-codegen/Struct.py        | 22 ++++++++++++++----
 src/libmbim-glib/mbim-message-private.h |  8 ++++---
 src/libmbim-glib/mbim-message.c         | 40
 ++++++++++++++++++++++++++-------
 4 files changed, 67 insertions(+), 21 deletions(-)

commit 8ecb23418fd79f25458b35363738ebdbe8c8ff11
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 18:28:49 2019 +0100

    libmbim-glib,message: reading string array may fail

 build-aux/mbim-codegen/Message.py       |  9 +++++---
 build-aux/mbim-codegen/Struct.py        |  4 +++-
 src/libmbim-glib/mbim-message-private.h | 11 ++++-----
 src/libmbim-glib/mbim-message.c         | 40
 +++++++++++++++++++++------------
 4 files changed, 41 insertions(+), 23 deletions(-)

commit d01b83df1b96172b90cf70ca2f6fdd39fe3a2539
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 18:23:26 2019 +0100

    libmbim-glib,message: reading string may fail

 build-aux/mbim-codegen/Message.py       |  9 +++--
 build-aux/mbim-codegen/Struct.py        |  4 +-
 src/libmbim-glib/mbim-message-private.h |  9 +++--
 src/libmbim-glib/mbim-message.c         | 66
 +++++++++++++++++++++------------
 src/libmbim-glib/mbim-proxy.c           |  7 ++--
 5 files changed, 62 insertions(+), 33 deletions(-)

commit 74068b23d1db1d73f6a91a14d87f1b251edd907d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 16:59:48 2019 +0100

    libmbim-glib,message: reading guint64 may fail

 build-aux/mbim-codegen/Message.py       | 21 ++++++++++++++++++---
 build-aux/mbim-codegen/Struct.py        |  4 +++-
 src/libmbim-glib/mbim-message-private.h |  6 ++++--
 src/libmbim-glib/mbim-message.c         | 29
 ++++++++++++++++++++++-------
 4 files changed, 47 insertions(+), 13 deletions(-)

commit 093b0bf07eb85d989c6db855bcb63ef36ab372b9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 16:52:58 2019 +0100

    libmbim-glib,message: reading guint32 array may fail

 build-aux/mbim-codegen/Struct.py        |  4 ++-
 src/libmbim-glib/mbim-message-private.h |  8 ++++--
 src/libmbim-glib/mbim-message.c         | 49
 +++++++++++++++++++++------------
 src/libmbim-glib/mbim-proxy-helpers.c   |  4 +--
 4 files changed, 41 insertions(+), 24 deletions(-)

commit 3e33a1e839254940ff17b4b38923dca21f857a6a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 16:44:58 2019 +0100

    libmbim-glib,message: reading guint32 may fail

 build-aux/mbim-codegen/Message.py       | 37
 +++++++++++++++++++++++++--------
 build-aux/mbim-codegen/Struct.py        | 14 +++++++++----
 src/libmbim-glib/mbim-message-private.h |  6 ++++--
 src/libmbim-glib/mbim-message.c         | 29 +++++++++++++++++++-------
 src/libmbim-glib/mbim-proxy-helpers.c   | 24 ++++++++++-----------
 src/libmbim-glib/mbim-proxy.c           |  8 ++++++-
 6 files changed, 82 insertions(+), 36 deletions(-)

commit b7c36db1550521336262508deadda195d3feb5b4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 15:29:49 2019 +0100

    libmbim-glib,message: reading uuid may fail

 build-aux/mbim-codegen/Message.py       | 11 +++++++----
 build-aux/mbim-codegen/Struct.py        | 11 +++++++++--
 src/libmbim-glib/mbim-message-private.h |  6 ++++--
 src/libmbim-glib/mbim-message.c         | 24 +++++++++++++++++++-----
 src/libmbim-glib/mbim-proxy-helpers.c   | 17 +++++++++++++----
 5 files changed, 52 insertions(+), 17 deletions(-)

commit 28084e36e20d2436cf9dff03f83fc3f150c2b9e2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 19:34:12 2019 +0100

    libmbim-glib,test: fix byte array reading test

    The STK buffer is 256 bytes, fixed-size, so use that array size for
    the actual test, or it'll fail with the new strict reading checks.

 src/libmbim-glib/test/test-message-parser.c | 56
 +++++++++++++++++++++++++++--
 1 file changed, 53 insertions(+), 3 deletions(-)

commit 413133f2f88b6636a7f2613e7fead937a5be8b33
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 13:03:15 2019 +0100

    libmbim-glib,message: reading byte array may fail

 build-aux/mbim-codegen/Message.py       |  32 ++++++---
 build-aux/mbim-codegen/Struct.py        |  24 +++++--
 src/libmbim-glib/mbim-message-private.h |  18 +++--
 src/libmbim-glib/mbim-message.c         | 116
 +++++++++++++++++++++++++++-----
 4 files changed, 154 insertions(+), 36 deletions(-)

commit 45545bb78e8f3c0a72b4a5075f0652f167c38e54
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 16:36:23 2019 +0100

    libmbim-glib,proxy: helper service_subscribe_request_parse() may fail

 src/libmbim-glib/mbim-proxy-helpers.c      |  5 +++--
 src/libmbim-glib/mbim-proxy-helpers.h      |  3 ++-
 src/libmbim-glib/mbim-proxy.c              | 14 +++++++++++++-
 src/libmbim-glib/test/test-proxy-helpers.c |  9 ++++++---
 4 files changed, 24 insertions(+), 7 deletions(-)

commit 896cd9cbca60a90609a6cedb23d6c176b5b12b8d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 14:54:10 2019 +0100

    build-aux,message: struct reading may fail

 build-aux/mbim-codegen/Message.py | 49 +++++++++++++++++++-----
 build-aux/mbim-codegen/Struct.py  | 79
 +++++++++++++++++++++++----------------
 2 files changed, 86 insertions(+), 42 deletions(-)

commit 60da80336b13fab5039e84fc8803ade278ed2edb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 13:13:04 2019 +0100

    build-aux,struct: setup base logic to abort early

 build-aux/mbim-codegen/Struct.py | 26 ++++++++++++++++++++++----
 1 file changed, 22 insertions(+), 4 deletions(-)

commit 3ebb80f9e35d84a185dd7e49f6092fb7621ea1d7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 11:45:05 2019 +0100

    build-aux,message: setup base logic to abort early

    All memory allocated variables will be freed if the parsing is aborted
    at any time.

 build-aux/mbim-codegen/Message.py | 51
 +++++++++++++++++++++++++++++++++------
 1 file changed, 43 insertions(+), 8 deletions(-)

commit ab6a1bd1df422968ef526e615f30945e343c5baf
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 11:30:19 2019 +0100

    build-aux,message: set all output mem allocated variables just
    before returning

    This is just a minor refactor to make it easier to abort the
    processing early if reading specific fields fail.

 build-aux/mbim-codegen/Message.py | 66
 ++++++++++++++++++++++++++++++++-------
 1 file changed, 55 insertions(+), 11 deletions(-)

commit fd3306c8070aae12fda4f4493de3cdef6f73a34c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 26 10:57:10 2019 +0100

    build-aux,message: always reset inner template

    So that the 'else' path has an empty string as template.

 build-aux/mbim-codegen/Message.py | 6 ++++++
 1 file changed, 6 insertions(+)

commit 2f27283834cb54492b3f9cf72f7d83b0a9838063
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 25 15:04:26 2019 +0100

    build-aux,message: rename output variables in message parsers as
    'out_..'

 build-aux/mbim-codegen/Message.py | 198
 +++++++++++++++++++-------------------
 1 file changed, 99 insertions(+), 99 deletions(-)

commit 80b27d4dc307451cea631f3a7c25d1845f457911
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 25 13:37:11 2019 +0100

    build-aux,message: error out if trying to parse contents and none
    given

    If the message doesn't have an information buffer, don't allow
    content parsing.

 build-aux/mbim-codegen/Message.py | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 404de179081c52ae310adae16788fb5f68e7d30a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 25 13:33:45 2019 +0100

    libmbim-glib,message: allow NULL length output when getting
    information buffer

 src/libmbim-glib/mbim-message.c | 39
 ++++++++++++++++++++++++---------------
 src/libmbim-glib/mbim-message.h |  6 +++---
 2 files changed, 27 insertions(+), 18 deletions(-)

commit d08dd6f0071f94838c5f6fd78413c7f51461ba8e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Nov 21 11:50:54 2019 +0100

    mbimcli: G_LOG_FLAG_FATAL is an internal flag

 src/mbimcli/mbimcli.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0cb13839345633fa0dfe8d11393231d59e7defd8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:21:38 2019 +0100

    libmbim-glib,device: fix warnings with -Wimplicit-fallthrough

      mbim-device.c: In function ‘device_open_context_step’:
      mbim-device.c:1601:18: warning: this statement may fall through
      [-Wimplicit-fallthrough=]
       1601 |         ctx->step++;
            |         ~~~~~~~~~^~
      mbim-device.c:1604:5: note: here
       1604 |     case DEVICE_OPEN_CONTEXT_STEP_CREATE_IOCHANNEL:
            |     ^~~~
      mbim-device.c:1616:18: warning: this statement may fall through
      [-Wimplicit-fallthrough=]
       1616 |         ctx->step++;
            |         ~~~~~~~~~^~
      mbim-device.c:1619:5: note: here
       1619 |     case DEVICE_OPEN_CONTEXT_STEP_CLOSE_MESSAGE:
            |     ^~~~
      mbim-device.c:1626:18: warning: this statement may fall through
      [-Wimplicit-fallthrough=]
       1626 |         ctx->step++;
            |         ~~~~~~~~~^~
      mbim-device.c:1629:5: note: here
       1629 |     case DEVICE_OPEN_CONTEXT_STEP_OPEN_MESSAGE:
            |     ^~~~
      mbim-device.c:1635:18: warning: this statement may fall through
      [-Wimplicit-fallthrough=]
       1635 |         ctx->step++;
            |         ~~~~~~~~~^~
      mbim-device.c:1638:5: note: here
       1638 |     case DEVICE_OPEN_CONTEXT_STEP_LAST:
            |     ^~~~

 src/libmbim-glib/mbim-device.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 140c87ff54aba91d86bac41fa7aa974ce333d6d4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:19:14 2019 +0100

    libmbim-glib,message: avoid warning with -Wsuggest-attribute=noreturn

      mbim-message.c: In function
      ‘_mbim_struct_builder_append_string_array’:
      mbim-message.c:749:1: warning: function might be candidate for
      attribute ‘noreturn’ [-Wsuggest-attribute=noreturn]
        749 | _mbim_struct_builder_append_string_array (MbimStructBuilder
        *builder,
            | ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 src/libmbim-glib/mbim-message.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 63935cc128285537248865bf4e1501fb63ca4088
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:16:02 2019 +0100

    libmbim-glib,message: fix warnings with -Wswitch-enum

      mbim-message.c:1321:9: warning: enumeration value
      ‘MBIM_SERVICE_INVALID’ not handled in switch [-Wswitch-enum]
       1321 |         switch (service_read_fields) {
            |         ^~~~~~
      mbim-message.c:1321:9: warning: enumeration value
      ‘MBIM_SERVICE_LAST’ not handled in switch [-Wswitch-enum]

      mbim-message.c: In function ‘mbim_message_response_get_result’:
      mbim-message.c:2307:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_INVALID’ not handled in switch
      [-Wswitch-enum]
       2307 |     switch (type) {
            |     ^~~~~~
      mbim-message.c:2307:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_OPEN’ not handled in switch [-Wswitch-enum]
      mbim-message.c:2307:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_CLOSE’ not handled in switch [-Wswitch-enum]
      mbim-message.c:2307:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_COMMAND’ not handled in switch
      [-Wswitch-enum]
      mbim-message.c:2307:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_HOST_ERROR’ not handled in switch
      [-Wswitch-enum]
      mbim-message.c:2307:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_INDICATE_STATUS’ not handled in switch
      [-Wswitch-enum]

 src/libmbim-glib/mbim-message.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit 88dcc5724c5461cd0b7a7f7a79a63a32ece0b2de
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:14:29 2019 +0100

    libmbim-glib,message: fix warnings with -Wswitch-default

      mbim-message.c: In function ‘mbim_message_get_printable’:
      mbim-message.c:1169:5: warning: switch missing default case
      [-Wswitch-default]
       1169 |     switch (MBIM_MESSAGE_GET_MESSAGE_TYPE (self)) {
            |     ^~~~~~

 src/libmbim-glib/mbim-message.c | 3 +++
 1 file changed, 3 insertions(+)

commit 23e572bbdbc61831cb0cdb682b3b01969791ba74
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:09:45 2019 +0100

    libmbim-glib,cid: fix warnings with -Wswitch-enum

      mbim-uuid.c: In function ‘mbim_uuid_from_service’:
      mbim-uuid.c:402:5: warning: enumeration value
      ‘MBIM_SERVICE_LAST’ not handled in switch [-Wswitch-enum]
        402 |     switch (service) {
            |     ^~~~~~
        CC       libmbim_glib_core_la-mbim-cid.lo
      mbim-cid.c: In function ‘mbim_cid_can_set’:
      mbim-cid.c:200:5: warning: enumeration value
      ‘MBIM_SERVICE_INVALID’ not handled in switch [-Wswitch-enum]
        200 |     switch (service) {
            |     ^~~~~~
      mbim-cid.c:200:5: warning: enumeration value ‘MBIM_SERVICE_LAST’
      not handled in switch [-Wswitch-enum]
      mbim-cid.c: In function ‘mbim_cid_can_query’:
      mbim-cid.c:254:5: warning: enumeration value
      ‘MBIM_SERVICE_INVALID’ not handled in switch [-Wswitch-enum]
        254 |     switch (service) {
            |     ^~~~~~
      mbim-cid.c:254:5: warning: enumeration value ‘MBIM_SERVICE_LAST’
      not handled in switch [-Wswitch-enum]
      mbim-cid.c: In function ‘mbim_cid_can_notify’:
      mbim-cid.c:308:5: warning: enumeration value
      ‘MBIM_SERVICE_INVALID’ not handled in switch [-Wswitch-enum]
        308 |     switch (service) {
            |     ^~~~~~
      mbim-cid.c:308:5: warning: enumeration value ‘MBIM_SERVICE_LAST’
      not handled in switch [-Wswitch-enum]
      mbim-cid.c: In function ‘mbim_cid_get_printable’:
      mbim-cid.c:362:5: warning: enumeration value ‘MBIM_SERVICE_LAST’
      not handled in switch [-Wswitch-enum]
        362 |     switch (service) {
            |     ^~~~~~

 src/libmbim-glib/mbim-cid.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit b9ca93b4492e5f2bb2a646fda1c3a4d582133310
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:07:48 2019 +0100

    libmbim-glib,uuid: fix warnings with -Wswitch-enum

      mbim-uuid.c: In function ‘mbim_uuid_from_service’:
      mbim-uuid.c:402:5: warning: enumeration value
      ‘MBIM_SERVICE_LAST’ not handled in switch [-Wswitch-enum]
        402 |     switch (service) {
            |     ^~~~~~
        CC       libmbim_glib_core_la-mbim-cid.lo

 src/libmbim-glib/mbim-uuid.c | 2 ++
 1 file changed, 2 insertions(+)

commit 6285b5a303a8ba6e46c49a82eb07de4f125b6090
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:04:51 2019 +0100

    libmbim-glib,device: fix warnings with -Wswitch-default

      mbim-device.c: In function ‘process_message’:
      mbim-device.c:579:5: warning: switch missing default case
      [-Wswitch-default]
        579 |     switch (MBIM_MESSAGE_GET_MESSAGE_TYPE (message)) {
            |     ^~~~~~

      mbim-device.c: In function ‘device_write’:
      mbim-device.c:1951:9: warning: switch missing default case
      [-Wswitch-default]
       1951 |         switch (write_status) {
            |         ^~~~~~

 src/libmbim-glib/mbim-device.c | 5 +++++
 1 file changed, 5 insertions(+)

commit ff5d9807a5873065e8cedd33c4682a379eb0533a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 15:02:57 2019 +0100

    libmbim-glib,proxy: fix warnings with -Wswitch-enum

      mbim-proxy.c: In function ‘process_message’:
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_INVALID’ not handled in switch
      [-Wswitch-enum]
       1018 |     switch (mbim_message_get_message_type (message)) {
            |     ^~~~~~
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_HOST_ERROR’ not handled in switch
      [-Wswitch-enum]
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_OPEN_DONE’ not handled in switch
      [-Wswitch-enum]
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_CLOSE_DONE’ not handled in switch
      [-Wswitch-enum]
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_COMMAND_DONE’ not handled in switch
      [-Wswitch-enum]
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_FUNCTION_ERROR’ not handled in switch
      [-Wswitch-enum]
      mbim-proxy.c:1018:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_INDICATE_STATUS’ not handled in switch
      [-Wswitch-enum]

 src/libmbim-glib/mbim-proxy.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 6bc51195b2e8302d96d1ff9c8c56a4447c386600
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:25:27 2019 +0100

    libmbim-glib,message: fix warnings with -Wswitch-enum

      mbim-message.c: In function
      ‘_mbim_message_get_information_buffer_offset’:
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_INVALID’ not handled in switch
      [-Wswitch-enum]
        146 |     switch (MBIM_MESSAGE_GET_MESSAGE_TYPE (self)) {
            |     ^~~~~~
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_OPEN’ not handled in switch [-Wswitch-enum]
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_CLOSE’ not handled in switch [-Wswitch-enum]
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_HOST_ERROR’ not handled in switch
      [-Wswitch-enum]
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_OPEN_DONE’ not handled in switch
      [-Wswitch-enum]
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_CLOSE_DONE’ not handled in switch
      [-Wswitch-enum]
      mbim-message.c:146:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_FUNCTION_ERROR’ not handled in switch
      [-Wswitch-enum]

 src/libmbim-glib/mbim-message.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit d32e6c70420b92a342cee3b2dde16a415c047245
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:17:44 2019 +0100

    build-aux: fix warnings with -Wswitch-enum

      mbim-basic-connect.c: In function
      ‘__mbim_message_basic_connect_get_printable_fields’:
      mbim-basic-connect.c:10724:5: warning: enumeration value
      ‘MBIM_MESSAGE_TYPE_OPEN’ not handled in switch [-Wswitch-enum]
      10724 |     switch (mbim_message_get_message_type (message)) {
            |     ^~~~~~

      mbim-basic-connect.c: In function
      ‘__mbim_message_basic_connect_get_printable_fields’:
      mbim-basic-connect.c:10728:17: warning: enumeration value
      ‘MBIM_MESSAGE_COMMAND_TYPE_UNKNOWN’ not handled in switch
      [-Wswitch-enum]
      10728 |                 switch
      (mbim_message_command_get_command_type (message)) {
            |                 ^~~~~~

 build-aux/mbim-codegen/ObjectList.py | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 02a9c9791a9acf4770e6dec16e6962645af36c9f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:10:53 2019 +0100

    build-aux: fix warning in the built _get_string() methods with
    -Wsign-compare

      mbim-error-types.c: In function ‘mbim_core_error_get_string’:
      mbim-error-types.c:53:17: warning: comparison of integer
      expressions of different signedness: ‘MbimCoreError’ {aka
      ‘enum <anonymous>’} and ‘gint’ {aka ‘const int’}
      [-Wsign-compare]
         53 |         if (val == mbim_core_error_values[i].value)
            |                 ^~

      mbim-enum-types.c: In function
      ‘mbim_cid_basic_connect_get_string’:
      mbim-enum-types.c:68:17: warning: comparison of integer
      expressions of different signedness: ‘MbimCidBasicConnect’
      {aka ‘enum <anonymous>’} and ‘gint’ {aka ‘const int’}
      [-Wsign-compare]
         68 |         if (val == mbim_cid_basic_connect_values[i].value)
            |                 ^~

      mbim-enum-types.c: In function
      ‘mbim_data_class_build_string_from_mask’:
      mbim-enum-types.c:1958:18: warning: comparison of integer
      expressions of different signedness: ‘MbimDataClass’ {aka
      ‘enum <anonymous>’} and ‘guint’ {aka ‘const unsigned
      int’} [-Wsign-compare]
       1958 |         if (mask == mbim_data_class_values[i].value) {
            |                  ^~
        CC       libmbim_glib_generated_la-mbim-basic-connect.lo

 build-aux/templates/mbim-enum-types-template.c  | 4 ++--
 build-aux/templates/mbim-error-types-template.c | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit b9c011634ea5e890610f431456c973d20d4dee2b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:09:18 2019 +0100

    mbimcli: fix warnings with -Wdouble-promotion

      mbimcli-atds.c: In function ‘query_signal_ready’:
      mbimcli-atds.c:200:55: warning: implicit conversion from ‘float’
      to ‘double’ to match other operand of binary expression
      [-Wdouble-promotion]
        200 |         ecno_str = g_strdup_printf ("%.2f dBm", -24.0 +
        ((float) ecno / 2));
            |                                                       ^
      mbimcli-atds.c:207:55: warning: implicit conversion from ‘float’
      to ‘double’ to match other operand of binary expression
      [-Wdouble-promotion]
        207 |         rsrq_str = g_strdup_printf ("%.2f dBm", -19.5 +
        ((float) rsrq / 2));
            |

 src/mbimcli/mbimcli-atds.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 862710295bcba06aadd8affbbb3d1468aa4f6ede
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:06:32 2019 +0100

    mbimcli: fix warnings with -Wswitch-default

      mbimcli-atds.c: In function ‘query_signal_ready’:
      mbimcli-atds.c:160:5: warning: switch missing default case
      [-Wswitch-default]
        160 |     switch (error_rate) {
            |     ^~~~~~

 src/mbimcli/mbimcli-atds.c | 3 +++
 1 file changed, 3 insertions(+)

commit e59c5c19a948f324964e994386f3d0c392e4ffe1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:03:19 2019 +0100

    mbimcli: fix warnings with -Wsign-compare

      mbimcli-basic-connect.c: In function
      ‘provisioned_contexts_ready’:
      mbimcli-basic-connect.c:1810:19: warning: comparison of integer
      expressions of different signedness: ‘int’ and ‘guint32’
      {aka ‘unsigned int’} [-Wsign-compare]
       1810 |     for (i = 0; i < provisioned_contexts_count; i++) {
            |                   ^

      mbimcli-phonebook.c: In function ‘query_phonebook_read_ready’:
      mbimcli-phonebook.c:285:19: warning: comparison of integer
      expressions of different signedness: ‘gint’ {aka ‘int’}
      and ‘guint32’ {aka ‘unsigned int’} [-Wsign-compare]
        285 |     for (i = 0; i < entry_count; i++) {
            |                   ^

 src/mbimcli/mbimcli-basic-connect.c | 2 +-
 src/mbimcli/mbimcli-phonebook.c     | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit f2d2a7897b08df41e15f5efc10a78a35c0b3a210
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 20 14:01:58 2019 +0100

    mbimcli: fix warnings with -Wsign-compare

      mbimcli-basic-connect.c: In function ‘connect_session_id_parse’:
      mbimcli-basic-connect.c:1107:54: warning: comparison of integer
      expressions of different signedness: ‘long int’ and ‘size_t’
      {aka ‘long unsigned int’} [-Wsign-compare]
       1107 |     if (errno || n < 0 || n > 255 || ((endptr - str) <
       strlen (str))) {
            |                                                      ^

      mbimcli-ms-basic-connect-extensions.c: In function
      ‘session_id_parse’:
      mbimcli-ms-basic-connect-extensions.c:114:54: warning: comparison
      of integer expressions of different signedness: ‘long int’
      and ‘size_t’ {aka ‘long unsigned int’} [-Wsign-compare]
        114 |     if (errno || n < 0 || n > 255 || ((endptr - str) <
        strlen (str))) {
            |                                                      ^

 src/mbimcli/mbimcli-basic-connect.c               | 2 +-
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 2d4bcd3161115f0aa4d969eae40eec49d9637067
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 12:39:45 2019 +0100

    mbimcli: fix warnings with -Wswitch-enum

      mbimcli.c: In function ‘device_open_ready’:
      mbimcli.c:265:5: warning: enumeration value
      ‘MBIM_SERVICE_INVALID’ not handled in switch [-Wswitch-enum]
        265 |     switch (service) {
            |     ^~~~~~
      mbimcli.c:265:5: warning: enumeration value ‘MBIM_SERVICE_SMS’
      not handled in switch [-Wswitch-enum]
      mbimcli.c:265:5: warning: enumeration value ‘MBIM_SERVICE_USSD’
      not handled in switch [-Wswitch-enum]
      mbimcli.c:265:5: warning: enumeration value ‘MBIM_SERVICE_STK’
      not handled in switch [-Wswitch-enum]
      mbimcli.c:265:5: warning: enumeration value ‘MBIM_SERVICE_AUTH’
      not handled in switch [-Wswitch-enum]
      mbimcli.c:265:5: warning: enumeration value
      ‘MBIM_SERVICE_PROXY_CONTROL’ not handled in switch
      [-Wswitch-enum]
      mbimcli.c:265:5: warning: enumeration value ‘MBIM_SERVICE_QMI’
      not handled in switch [-Wswitch-enum]

 src/mbimcli/mbimcli.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 5ffe757ac6dbb88bd45e179f112cff9cb76a14ee
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 12:36:50 2019 +0100

    mbim-proxy: fix warnings with -Wswitch-enum

      mbim-proxy.c: In function ‘log_handler’:
      mbim-proxy.c:101:5: warning: enumeration value
      ‘G_LOG_FLAG_RECURSION’ not handled in switch [-Wswitch-enum]
        101 |     switch (log_level) {
            |     ^~~~~~
      mbim-proxy.c:101:5: warning: enumeration value
      ‘G_LOG_LEVEL_MESSAGE’ not handled in switch [-Wswitch-enum]
      mbim-proxy.c:101:5: warning: enumeration value
      ‘G_LOG_LEVEL_INFO’ not handled in switch [-Wswitch-enum]
      mbim-proxy.c:101:5: warning: enumeration value
      ‘G_LOG_LEVEL_MASK’ not handled in switch [-Wswitch-enum]

 src/mbim-proxy/mbim-proxy.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit b95dd7a12da2815e01d9ceb218d4532e066385cf
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 12:36:11 2019 +0100

    mbimcli: fix warnings with -Wswitch-enum

        mbimcli.c: In function ‘log_handler’:
        mbimcli.c:138:5: warning: enumeration value
        ‘G_LOG_FLAG_RECURSION’ not handled in switch [-Wswitch-enum]
          138 |     switch (log_level) {
              |     ^~~~~~
        mbimcli.c:138:5: warning: enumeration value
        ‘G_LOG_LEVEL_MESSAGE’ not handled in switch [-Wswitch-enum]
        mbimcli.c:138:5: warning: enumeration value ‘G_LOG_LEVEL_INFO’
        not handled in switch [-Wswitch-enum]
        mbimcli.c:138:5: warning: enumeration value ‘G_LOG_LEVEL_MASK’
        not handled in switch [-Wswitch-enum]

 src/mbimcli/mbimcli.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 448e8fe7c50493c2c42399ed903906b9bb35d244
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 12:28:59 2019 +0100

    build: use AX_IS_RELEASE() and AX_COMPILER_FLAGS()

    The autoconf macros AX_COMPILER_FLAGS_{CFLAGS|GIR|LDFLAGS} test
    for compiler and linker support of various flags, and add the flags to
    the generated output.

    If the command-line option '--enable-compile-warnings' is specified to
    'configure', a number of additional warning options is also added to
    the output. This is the default.

    This update requires the presence of the GNU autoconf-archive in the
    system when building from git (not required when building from a
    source tarball).

 configure.ac                           | 30 ++++++++++++++++++++++++--
 m4/compiler-warnings.m4                | 39
 ----------------------------------
 src/common/Makefile.am                 |  2 ++
 src/common/test/Makefile.am            |  2 ++
 src/libmbim-glib/Makefile.am           |  2 ++
 src/libmbim-glib/generated/Makefile.am |  2 ++
 src/libmbim-glib/test/Makefile.am      |  2 ++
 src/mbim-proxy/Makefile.am             |  2 ++
 src/mbimcli/Makefile.am                |  2 ++
 9 files changed, 42 insertions(+), 41 deletions(-)

commit fce75f2242e4e1a38e300b3af527ee131c32f980
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 12:41:08 2019 +0100

    ci: require autoconf-archive

 .gitlab-ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit aa36234e905a31da045e8c09f2ac2b2204a40cf6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 12:19:39 2019 +0100

    build: rework cflags/cppflags/ldflags

 src/common/Makefile.am                 |  13 +++-
 src/common/test/Makefile.am            |  22 ++++--
 src/libmbim-glib/Makefile.am           |  24 +++---
 src/libmbim-glib/generated/Makefile.am |  11 ++-
 src/libmbim-glib/test/Makefile.am      | 129
 +++++++++------------------------
 src/mbim-proxy/Makefile.am             |  12 ++-
 src/mbimcli/Makefile.am                |  13 +++-
 7 files changed, 99 insertions(+), 125 deletions(-)

commit 60f686ba451b1b64da828503da06c2c00cabe138
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 19 11:44:23 2019 +0100

    libmbim-glib,uuid: remove redundant declaration

 src/libmbim-glib/mbim-uuid.h | 2 --
 1 file changed, 2 deletions(-)

commit eceb6b70ad74dc5c346561c382cb02795b4870f6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 4 10:36:09 2019 +0100

    libmbim-glib,device: fix handling of fragmented indication messages

    The transactions for the fragmented indication messages were being
    stored in the "host" type transaction hashtable, instead of in the
    "modem" type transaction hashtable.

    Fixes https://gitlab.freedesktop.org/mobile-broadband/libmbim/issues/8

 src/libmbim-glib/mbim-device.c | 20 ++++++++++++++------
 1 file changed, 14 insertions(+), 6 deletions(-)

commit 0bbe65cc3b4bd1321dc6e14dfe74b963ef8ba257
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Sep 21 14:38:28 2019 +0200

    libmbim-glib,proxy: plug memleak

 src/libmbim-glib/mbim-proxy.c | 2 ++
 1 file changed, 2 insertions(+)

commit 40640217fb40921c787cf309d6b988f04f1af84c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Sep 21 14:01:30 2019 +0200

    libmbim-glib,proxy: always use realpath in the MbimDevice

    We don't want to create different MbimDevices for the same cdc-wdm
    port when it's accessed through different symlinks.

    Fixes https://gitlab.freedesktop.org/mobile-broadband/libmbim/issues/6

 src/libmbim-glib/mbim-proxy.c | 22 ++++++++++++++++++----
 1 file changed, 18 insertions(+), 4 deletions(-)

commit b0ede0ce4626353e89387f8bb3ab05b608f2e38d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Sep 21 14:00:15 2019 +0200

    libmbim-glib,device: use realpath basename to look for descriptors
    file

    Fixes https://gitlab.freedesktop.org/mobile-broadband/libmbim/issues/6

 src/libmbim-glib/mbim-device.c | 14 +++++++++++---
 1 file changed, 11 insertions(+), 3 deletions(-)

commit 4932766d8cc77430283f708385eab45cc13bbc6a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Sep 21 13:59:51 2019 +0200

    libmbim-glib,utils: new helpers to work with symlinks

 src/libmbim-glib/mbim-utils.c | 44
 ++++++++++++++++++++++++++++++++++++++++++-
 src/libmbim-glib/mbim-utils.h |  8 ++++++--
 2 files changed, 49 insertions(+), 3 deletions(-)

commit 2999e9a8629938b9666f8d71eebc79a8670f5da0
Author: Eric Caruso <ejcaruso@chromium.org>
Date:   Thu Sep 12 15:52:52 2019 -0700

    mbimcli: add --query-provisioned-contexts flag

    This allows a user to check the provisioned contexts from the
    CLI to see if e.g. the network wants to set up a connection using
    a class 3 APN.

    BUG=b:133125116
    TEST=run on sarien

    Change-Id: Ida30061c336b2a504fbdfb2118c7a165c1ad0ce8

 src/mbimcli/mbimcli-basic-connect.c | 85
 ++++++++++++++++++++++++++++++++++++-
 1 file changed, 84 insertions(+), 1 deletion(-)

commit 399dcf407bc3f8385aae77e49a71591ba1a351bd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Sep 6 14:26:42 2019 +0200

    build: post-release version bump to 1.21.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 376824c586fbf72ea0aeda3c8fb0df38c213a99e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Sep 6 14:03:13 2019 +0200

    release: bump version to 1.20.0

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e12c9629b71e2f819e8811100bad4a9f4417f7b8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Sep 6 14:02:28 2019 +0200

    NEWS: update for 1.20.0

 NEWS | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit b8f305d7f5bbf1712ed6ca39e5089e77fbd98eac
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 4 16:17:01 2019 +0200

    mbim-proxy: fix client unsubscribe logic

    When building the merged service subscribe list, we should never start
    with the previously existing list, because if we do that we would
    never process service/cid unsubscriptions.

    Instead, start with the default services list because we don't want to
    lose any of those ever.

 src/libmbim-glib/mbim-proxy.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a5379fbbd397f6d0d9d585efb34a65629440f41b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 4 15:28:29 2019 +0200

    mbim-proxy: if client subscribes using wildcard, don't match cid

    Patch by Michael O'Dwyer.
    https://gitlab.freedesktop.org/mobile-broadband/libmbim/issues/5

 src/libmbim-glib/mbim-proxy.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 9495539021fc0e4bc80cc9ae28bd7b8980bff393
Author: Ben Chan <benchan@chromium.org>
Date:   Tue Sep 3 16:15:02 2019 -0700

    ms-basic-connect-extensions: untabify

 data/mbim-service-ms-basic-connect-extensions.json | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 47cf7e1aebb3d0ccd95c0e88a30df68bf6dfc0f4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 23 13:41:52 2019 +0200

    libmbim,cid: fix build with -Werror=type-limits

      mbim-cid.c: In function 'mbim_cid_get_printable':
      mbim-cid.c:360:5: error: comparison of unsigned expression >=
      0 is always true [-Werror=type-limits]

 src/libmbim-glib/mbim-cid.c | 1 -
 1 file changed, 1 deletion(-)

commit 07f4f8fa3f53e93a8988a6a2f3e5179c334b7f2f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 23 13:24:03 2019 +0200

    libmbim,uuid: fix build with -Werror=type-limits

      mbim-uuid.c: In function 'mbim_uuid_from_service':
      mbim-uuid.c:400:5: error: comparison of unsigned expression >=
      0 is always true [-Werror=type-limits]
      mbim-uuid.c: In function 'mbim_uuid_from_context_type':
      mbim-uuid.c:594:5: error: comparison of unsigned expression >=
      0 is always true [-Werror=type-limits]

 src/libmbim-glib/mbim-uuid.c | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit e7a327fafd75f9d020b0de7539fb072cef059b9a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 2 13:57:38 2019 +0200

    build: define GLIB_VERSION_MAX_ALLOWED and disable deprecation
    warnings

 configure.ac | 6 ++++++
 1 file changed, 6 insertions(+)

commit 67ba57f89fd3a2f4b280361e650eaef0057baeaa
Author: Ben Chan <benchan@chromium.org>
Date:   Tue Apr 2 12:46:26 2019 -0700

    build: make compiler warning options compatible with clang

    This patch updates m4/compiler-warnings.m4 as follows to make it more
    compatible with clang:

    * clang doesn't support -Wunused-but-set-variable, which can be
    replaced
      with -Wunused-variable as the latter covers unused variables with or
      without an assigned value and is supported by gcc and clang.

    * -Wno-unused-function is added to let clang ignore unused functions
    that
      are auto-generated by mbim-codegen.

 m4/compiler-warnings.m4 | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cdf25b2853257d986e4a3c00993182d39649395f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Mar 7 15:11:57 2019 +0100

    mbim-proxy: new '--empty-timeout=[SECS}' option

    We allow specifying how long the proxy should be kept running after
    the last client/device has exited.

 src/mbim-proxy/mbim-proxy.c | 23 ++++++++++++++++++-----
 1 file changed, 18 insertions(+), 5 deletions(-)

commit 27257959196e34d8312f3fd481ab94199e779026
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Mar 7 15:08:05 2019 +0100

    mbim-proxy: new --no-exit option to avoid the proxy from exiting

 src/mbim-proxy/mbim-proxy.c | 26 +++++++++++++++++---------
 1 file changed, 17 insertions(+), 9 deletions(-)

commit 8a3c88eaa76e606b113000889bfa0f8d9901eb99
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Mar 7 15:04:04 2019 +0100

    mbim-proxy: update default empty lifetime timeout to 300s

 src/mbim-proxy/mbim-proxy.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 92501dffafee34ac8ba358cc27c5bb89cd8a2625
Author: Eric Caruso <ejcaruso@chromium.org>
Date:   Mon Feb 11 15:46:12 2019 -0800

    Add .gitlab-ci.yml

    This allows us to run unit tests on every commit to the gitlab
    instance.

 .gitlab-ci.yml | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 29b09c4d146c8d0a0cc12417ecdc3356fa5559da
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jan 8 14:01:58 2019 +0100

    build: post-release version bump to 1.19.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 18cd1d2b3f21ca825f4d2eb31a058b1e43860f5b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jan 8 13:38:27 2019 +0100

    release: bump version to 1.18.0

 configure.ac | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 9d1e55f989408d2fe0159162affceaea7a504550
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jan 8 13:38:00 2019 +0100

    NEWS: update for 1.18.0

 NEWS | 41 +++++++++++++++++++++++++++++++++++++++++
 1 file changed, 41 insertions(+)

commit a68d54ba609c2bd34f9a8be05a814a9414ca2bac
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jan 8 13:51:00 2019 +0100

    build: bump copyrights to 2019

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 1 +
 src/mbim-proxy/mbim-proxy.c                       | 2 +-
 src/mbimcli/mbimcli.c                             | 2 +-
 3 files changed, 3 insertions(+), 2 deletions(-)

commit ea42bbf13d3369664973c29f8bf07fd76bd43eef
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Dec 10 10:56:05 2018 -0800

    build: enable -Wtype-limits

    -Wtype-limits helps catch unnecessary comparisons such as comparing
    unsigned variables <= 0.

    This patch essentially brings the list of compiler warnings defined in
    m4/compiler-warnings.m4 to be on par with libqmi.

 m4/compiler-warnings.m4 | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bff6abc1d7e424d7d594caba540ffe587fd0d723
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 12 15:14:53 2018 +0100

    build: version bump to 1.17.5 to flag existence of new API (LTE
    attach config)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a7b6be938af94cf2d54d4352d899831394276b6e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 4 16:43:53 2018 +0100

    ms-basic-connect-extensions: implement 'LTE attach state'

 data/mbim-service-ms-basic-connect-extensions.json | 36 ++++++++++-
 .../libmbim-glib/libmbim-glib-common.sections      |  5 ++
 src/libmbim-glib/mbim-enums.h                      | 12 ++++
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  | 71
 +++++++++++++++++++++-
 4 files changed, 122 insertions(+), 2 deletions(-)

commit dc3c5923fa19620360b198bc1ce66fed16ec97ff
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 4 09:17:16 2018 +0100

    ms-basic-connect-extensions: implement 'LTE attach configuration'

 data/mbim-service-ms-basic-connect-extensions.json | 53 +++++++++++++-
 .../libmbim-glib/libmbim-glib-common.sections      | 15 ++++
 src/libmbim-glib/mbim-enums.h                      | 45 ++++++++++++
 src/mbimcli/mbimcli-ms-basic-connect-extensions.c  | 83
 +++++++++++++++++++++-
 4 files changed, 192 insertions(+), 4 deletions(-)

commit aa5e4ee5666c9f22b71a0bbbed7475b665eab85b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 4 23:04:37 2018 +0100

    libmbim-glib,proxy: also track standard services

    The assumption that we could totally ignore enabling/disabling
    standard services seems to be wrong, as not all devices follow that
    logic. Looks like some do expect the FULL list of service/cids to
    subscribe to on every request, and we are not specifying the standard
    services, we would totally be losing the notifications they emit.

    So, track the full default list of CIDs of all standard services that
    emit notifications, and assume that all new clients have that list
    enabled by default. At device level we will NEVER disable the standard
    services, but clients may do so. This means that the list of
    service/cids that we pass down to the device must ALWAYS include all
    cids from all standard services.

    Fixes: 0073cbed59a270e1a8f18f591d31cbaf64a995ae

 src/libmbim-glib/mbim-proxy-helpers.c | 130
 +++++++++++++++++++++++++++++++++-
 src/libmbim-glib/mbim-proxy-helpers.h |   4 ++
 src/libmbim-glib/mbim-proxy.c         |  45 +++++-------
 3 files changed, 148 insertions(+), 31 deletions(-)

commit 3eeaa4248b98e1c3265caa5efca0db00a00e8a56
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 4 12:08:27 2018 +0100

    ms-basic-connect-extensions: rename service

    This service is not a generic service, it is defined by Microsoft, so
    rename it to follow the same naming scheme as for other services also
    defined by Microsoft.

    We do not provide compatibility symbols, as this is a NEW service to
    be first released in libmbim 1.18.0.

    We do bump the micro versionto 1.17.4, so that applications relying
    on the git version of libmbim can bump their minimum required version
    accordingly.

 configure.ac                                       |  2 +-
 data/Makefile.am                                   |  4 +-
 ... mbim-service-ms-basic-connect-extensions.json} |  4 +-
 docs/man/Makefile.am                               |  2 +-
 docs/reference/libmbim-glib/Makefile.am            |  4 +-
 .../libmbim-glib/libmbim-glib-common.sections      | 12 ++---
 docs/reference/libmbim-glib/libmbim-glib-docs.xml  | 16 +++++-
 src/libmbim-glib/generated/Makefile.am             | 30 +++++------
 src/libmbim-glib/libmbim-glib.h                    |  2 +-
 src/libmbim-glib/mbim-cid.c                        | 40 +++++++-------
 src/libmbim-glib/mbim-cid.h                        | 62
 +++++++++++-----------
 src/libmbim-glib/mbim-message.c                    | 20 +++----
 src/libmbim-glib/mbim-uuid.c                       | 10 ++--
 src/libmbim-glib/mbim-uuid.h                       | 38 ++++++-------
 src/libmbim-glib/test/test-uuid.c                  | 26 ++++-----
 src/mbimcli/Makefile.am                            |  4 +-
 ...ons.c => mbimcli-ms-basic-connect-extensions.c} | 22 ++++----
 src/mbimcli/mbimcli.c                              | 10 ++--
 src/mbimcli/mbimcli.h                              |  6 +--
 19 files changed, 163 insertions(+), 151 deletions(-)

commit 61b3f09e417e4f6131a763094960a7d45bb4fc56
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 4 17:14:32 2018 +0100

    mbim-codegen: don't print response contents if an error is being
    reported

        [04 nov 2018, 16:54:27] [Debug] [/dev/cdc-wdm2] Received
        message...
        >>>>>> RAW:
        >>>>>>   length = 48
        >>>>>>   data   =
        03:00:00:80:30:00:00:00:13:00:00:00:01:00:00:00:00:00:00:00:A2:89:CC:33:BC:BB:8B:4F:B6:B0:13:3E:C2:AA:E6:DF:13:00:00:00:22:00:00:00:00:00:00:00

        (mbim-proxy:14139): GLib-ERROR **: 16:54:27.373:
        ../glib/glib/gmem.c:105: failed to allocate 33235360392 bytes

 build-aux/mbim-codegen/Message.py | 6 ++++++
 1 file changed, 6 insertions(+)

commit 88d2cddb9d7861e59219400a4e4ff453cdd32d20
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 4 08:59:15 2018 +0100

    basic-connect-extensions: define common struct before the message

 data/mbim-service-basic-connect-extensions.json | 29
 ++++++++++++-------------
 1 file changed, 14 insertions(+), 15 deletions(-)

commit ce04c635358d9ac1bdbdf3bcbc70e469a9f6317f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 17 11:32:35 2018 +0200

    libmbim-glib,proxy: compare MbimDevices by pointer not by path

    The MbimDevice objects are stored in the proxy private info, and
    additional references of the same objects are also referenced in each
    client info. We can do a much quicker MbimDevice comparison just by
    comparing pointers directly instead of paths.

 src/libmbim-glib/mbim-proxy.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 0073cbed59a270e1a8f18f591d31cbaf64a995ae
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 10 13:20:46 2018 +0200

    libmbim-glib: explicitly configure only non-standard services

    The MBIM documentation states that the DEVICE_SERVICE_SUBSCRIBE_LIST
    message may be used by clients to specify which indications it is
    interested in receiving, and then the modem "must only indicate
    notifications for CIDs which have been enabled via this command".

    A bit later it says that "Upon OPEN_DONE completion, notifications for
    CIDs defined in this specification are enabled (aka subscribed to) by
    default, and vendor extension notifications are off by default."

    These two previous statements seem to contradict each other, as this
    would mean that devices emit by default indications for all standard
    services, regardless of whether clients have subscribed to them
    explicitly via DEVICE_SERVICE_SUBSCRIBE_LIST.

    Looking at actual real devices, giving a DEVICE_SERVICE_SUBSCRIBE_LIST
    that includes NO basic service CID enabled does NOT disable all
    indications of the standard services, which means we have no way to
    do so.

    This commit simplifies the "merged" service subscribe list handling by
    making the assumption that basic services are by default already
    subscribed to and also that there is no way to un-subscribe from
    them. We will use DEVICE_SERVICE_SUBSCRIBE_LIST only to track the
    subscriptions to CIDs of non-standard services in the device.

    If the client subscribes to standard services explicitly, the proxy
    will ignore those and will not send those explicit subscriptions to
    the device. In the same way, if the client un-subscribes from standard
    services it was previously subscribed to, we will also ignore those
    attempts. Clients should be simplified and ignore these subscriptions,
    but meanwhile the proxy should really behave as the real device.

    And while trying to behave as the real device, the indications emitted
    for standard services should always be sent to the clients, even if
    the clients tried to do custom management of which CIDs of the
    standard services it's subscribed to. We shouldn't add additional
    filtering in our end if the device isn't doing that.

 src/libmbim-glib/mbim-proxy-helpers.c      |  30 +--
 src/libmbim-glib/mbim-proxy-helpers.h      |   1 -
 src/libmbim-glib/mbim-proxy.c              | 115 ++++++-----
 src/libmbim-glib/test/test-proxy-helpers.c | 303
 +++++++++--------------------
 4 files changed, 164 insertions(+), 285 deletions(-)

commit 8f491a2d885db43c4814407bfa36f62adf4561c0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 10 01:39:28 2018 +0200

    libmbim-glib,proxy: full event entry cleanup on NotOpened function
    error

    If the device suddenly reports that the MBIM session is not open,
    e.g. after a suspend/resume cycle, we also cannot assume that the
    client-configured lists of events are valid.

    E.g. if the modem had QMI-over-MBIM indications enabled before the
    suspend operation, once the modem is re-configured after the resume we
    wouldn't be re-enabling these indications because we wrongly thought
    they were already enabled.

    This fixes the QMI-over-MBIM LOC support, which was broken after a
    suspend/resume cycle.

 src/libmbim-glib/mbim-proxy.c | 51
 +++++++++++++++++++++++++++++++++++--------
 1 file changed, 42 insertions(+), 9 deletions(-)

commit 2bf75ebc1f82c86b324db47fe037f6bbe230e6f4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 10 01:29:24 2018 +0200

    libmbim-glib,proxy: device error signal handling not per client

    There is no point in having one error signal connected per client,
    especially since the action performed is just a device forced close
    operation. Setup just one signal connected listening to errors
    reported by the device.

 src/libmbim-glib/mbim-proxy.c | 64
 +++++++++++++++++++++----------------------
 1 file changed, 31 insertions(+), 33 deletions(-)

commit cbd09e3b42807182a2f5879babd8e5658d87ad31
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 10 01:07:51 2018 +0200

    libmbim-glib,mbim-proxy: per-device event entry merged lists

    Having a global event entry merged list applicable to all devices
    doesn't have any sense, we should have a merged list *per device*. Do
    that by keeping the merged list in a private data associated to each
    MbimDevice.

 src/libmbim-glib/mbim-proxy.c | 174
 +++++++++++++++++++++++++-----------------
 1 file changed, 106 insertions(+), 68 deletions(-)

commit fbec1f4763168c75f0b221343e747545386ae9f8
Author: Ben Chan <benchan@chromium.org>
Date:   Tue Oct 16 16:27:42 2018 -0700

    libmbim-glib,proxy: remove explicit GDestroyNotify cast on
    g_object_unref

    g_object_unref is in form of  `void (*)(gpointer)`, which matches the
    GDestroyNotify signature. An explicit GDestroyNotify cast on
    g_object_unref is thus not needed.

 src/libmbim-glib/mbim-proxy.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ced77fcf59ca74bd1fe8cc05dc8286a351e4e11f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Oct 9 22:48:12 2018 +0200

    libmbim-glib,device: emit signal before completing transaction task

    Completion of transaction tasks is done inline, not in idle, and so a
    lot of things may happen during the completion handler, and we may
    even find that the input MbimMessage isn't valid any more, as the
    message container is the input channel buffer and this buffer may be
    closed and recreated during the function error handling...

        [09 oct 2018, 22:34:59] [Debug] [/dev/cdc-wdm2] Received message
        (translated)...
        >>>>>> Header:
        >>>>>>   length      = 16
        >>>>>>   type        = function-error (0x80000004)
        >>>>>>   transaction = 46
        >>>>>> Contents:
        >>>>>>   error = 'NotOpened' (0x00000005)

        [09 oct 2018, 22:34:59] [Debug] device not-opened error reported,
        reopening
        [09 oct 2018, 22:34:59] [Debug] [/dev/cdc-wdm2] channel destroyed
        [09 oct 2018, 22:34:59] [Debug] opening device...
        [09 oct 2018, 22:34:59] [Debug] [/dev/cdc-wdm2] Queried max
        control message size: 4096
        Segmentation fault

    Avoid this, just by emitting the error signal before the task
    completion.

 src/libmbim-glib/mbim-device.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 89c29c18c95f7f02481a4c620039c4c90d6c1889
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 7 21:27:13 2018 +0200

    mbim-codegen: implement support for printing message fields in traces

 build-aux/mbim-codegen/Message.py    | 343
 ++++++++++++++++++++++++++++++++++-
 build-aux/mbim-codegen/ObjectList.py | 128 ++++++++++++-
 build-aux/mbim-codegen/Struct.py     | 132 +++++++++++++-
 build-aux/mbim-codegen/mbim-codegen  |   5 +-
 build-aux/mbim-codegen/utils.py      |   4 +-
 src/libmbim-glib/mbim-message.c      |  92 +++++++++-
 6 files changed, 696 insertions(+), 8 deletions(-)

commit 603e24febf12e09ed0ef5c6ceaf813c99650c5a3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Oct 9 10:09:54 2018 +0200

    mbim-codegen: remove broken support for guint32-array types out
    of struct

    The only 2 fields flagged with 'guint32-array' type are given inside
    structs, and this lead to having a buggy implementation of the type
    when out of structs. E.g. we were assuming we could use '${public}' to
    refer to the enum/flag type associated to the guint32 when in an
    array, but that logic was totally broken as the public variable would
    be equal to 'guint32-array' if no enum/flag type given. Just remove
    that, and leave only the in-struct support.

 build-aux/mbim-codegen/Message.py | 22 +---------------------
 1 file changed, 1 insertion(+), 21 deletions(-)

commit 9ba08cc9951d41afa3195010fac1cbffa2a826b9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Oct 9 09:53:50 2018 +0200

    mbim-codegen: remove broken support for unused guint64-array types

    The code generator was ready to support these fields completely, but
    the library helper methods for reading these fields didn't even exist.

    Just remove the support from the code generator all together, whenever
    such a field is supported in any MBIM message, we'll add a proper
    implementation.

 build-aux/mbim-codegen/Message.py       | 14 --------------
 build-aux/mbim-codegen/Struct.py        |  2 --
 src/libmbim-glib/mbim-message-private.h |  6 ------
 src/libmbim-glib/mbim-message.c         | 20 --------------------
 4 files changed, 42 deletions(-)

commit 8d748c69e4ea622a126477df900c6b44efabd4ec
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 7 22:29:17 2018 +0200

    libmbim-glib,docs: add missing MbimPcoType references

 docs/reference/libmbim-glib/libmbim-glib-common.sections | 3 +++
 1 file changed, 3 insertions(+)

commit 670641b4f2aee333cd809e1c06a380eeb7144a2a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 7 22:26:55 2018 +0200

    mbim-codegen: remove support for ipv4-array and ipv6-array inside
    structs

    It was never used and the implementation was actually buggy. Not worth
    maintaining this.

 build-aux/mbim-codegen/Struct.py | 32 --------------------------------
 1 file changed, 32 deletions(-)

commit 6ac1b7f994d8e07b7c27caed47f97f927505a488
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 7 21:25:59 2018 +0200

    mbim-codegen: advance offset 16 bytes when reading a guint64 field

    https://gitlab.freedesktop.org/mobile-broadband/libmbim/issues/4

 build-aux/mbim-codegen/Message.py | 2 +-
 build-aux/mbim-codegen/Struct.py  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 124c01fc75c96328284c9b8721a9773d4cf7b632
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 7 21:25:15 2018 +0200

    atds: fix service name

    Should be the same as the 'service' fields in each message.

 data/mbim-service-atds.json                       | 4 ++--
 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 531ee220339b285078a91b73cb1857881d6aa506
Author: Ben Chan <benchan@chromium.org>
Date:   Sun Sep 16 11:52:39 2018 -0700

    libmbim-glib: fix UUID for 'Basic Connectivity Extensions' service

    The 'Basic Connectivity Extensions' service UUID was inconsistently
    stated in some Microsoft documentations, which has been fixed in [1].
    This patch updates libmbim to use the correct UUID for the 'Basic
    Connectivity Extensions' service UUID, which is
    3d01dcc5-fef5-4d05-0d3a-bef7058e9aaf.

    [1] https://github.com/MicrosoftDocs/windows-driver-docs/issues/831

 src/libmbim-glib/mbim-uuid.c      | 2 +-
 src/libmbim-glib/test/test-uuid.c | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit c603ab385baf5050fdbd47af9bdf9d46d407b1ab
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Aug 9 11:30:02 2018 +0200

    mbimcli,atds: fix thresholds in LTE SNR processing

    The encoded LTE SNR value is between 0 and 35, not up to 97.

 src/mbimcli/mbimcli-atds.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b1b0ff50d86e240d2c1d6aa2f19272ce000a5704
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Aug 9 11:22:36 2018 +0200

    mbimcli,atds: fix LTE SNR processing

 src/mbimcli/mbimcli-atds.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 652188fe3e5f015b637b19c68869a54b56b18620
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Jul 30 13:42:11 2018 -0700

    build: version bump to 1.17.3 for newly added MBIM_CID_PCO support

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1475ed59d265e6c25cfa048aba4a378940da697d
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Jul 26 23:38:07 2018 -0700

    mbimcli: new '--query-pco' action

    Change-Id: I7f24d481cb92b2e817eba487d38739b8fed58b28

 docs/man/Makefile.am                           |   1 +
 src/mbimcli/Makefile.am                        |   1 +
 src/mbimcli/mbimcli-basic-connect-extensions.c | 246
 +++++++++++++++++++++++++
 src/mbimcli/mbimcli.c                          |   8 +
 src/mbimcli/mbimcli.h                          |   4 +
 5 files changed, 260 insertions(+)

commit dbe70fee692974a92ce102642049b072bb17c9bd
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Jul 26 23:38:06 2018 -0700

    libmbim-glib: add partial support for Basic IP Connectivity Extensions
    service

    This patch adds partial support for the Basic IP Connectivity
    Extensions
    service defined in Microsoft Mobile Broadband Design Guide. Only the
    Protocol Configuration Operations (PCO) command is defined.

 data/Makefile.am                                   |  1 +
 data/mbim-service-basic-connect-extensions.json    | 34
 ++++++++++++++++++++++
 docs/reference/libmbim-glib/Makefile.am            |  1 +
 .../libmbim-glib/libmbim-glib-common.sections      |  8 +++++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml  |  1 +
 src/libmbim-glib/generated/Makefile.am             | 12 ++++++++
 src/libmbim-glib/libmbim-glib.h                    |  1 +
 src/libmbim-glib/mbim-cid.c                        | 23 +++++++++++++++
 src/libmbim-glib/mbim-cid.h                        | 30
 +++++++++++++++++++
 src/libmbim-glib/mbim-enums.h                      | 15 ++++++++++
 src/libmbim-glib/mbim-uuid.c                       | 13 +++++++++
 src/libmbim-glib/mbim-uuid.h                       | 11 +++++++
 src/libmbim-glib/test/test-uuid.c                  |  8 +++++
 13 files changed, 158 insertions(+)

commit b7f244c7206142fd869e2b865ae7f29e677036e1
Author: Ben Chan <benchan@chromium.org>
Date:   Fri Jul 27 15:14:38 2018 -0700

    mbim-codegen: handle 'ref-byte-array-no-offset' fields in Structs

 build-aux/mbim-codegen/Struct.py | 20 +++++++++++---------
 1 file changed, 11 insertions(+), 9 deletions(-)

commit cb54dd691967f21a6a9b1bb3e40d33e3cff35d7a
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jun 27 14:44:31 2018 -0700

    libmbim-glib: handle MBIM_SERVICE_INTEL_FIRMWARE_UPDATE in
    mbim_cid_get_printable()

    This patch adds a missing handling of
    MBIM_SERVICE_INTEL_FIRMWARE_UPDATE
    in mbim_cid_get_printable() for commit d2ae618d
    ("intel-firmware-update:
    add support for Intel Firmware Update service")

 src/libmbim-glib/mbim-cid.c | 2 ++
 1 file changed, 2 insertions(+)

commit 12f1a4f623d915957bb8b9b1b9a5e6c19b708e8c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 24 18:44:11 2018 +0200

    build: version bump to 1.17.2 to flag existence of new API (QMI
    indications)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4a853eb22b564bbaf0b591042abe75da8c3bd408
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 24 18:37:59 2018 +0200

    libmbim-glib,qmi: enable notifications in the QMI_MSG CID

    The QMI service allows QMI indications to be reported via MBIM
    notifications, once they're enabled with 'Basic Connect Device Service
    Subscribe List'.

 data/mbim-service-qmi.json  | 21 ++++++++++++---------
 src/libmbim-glib/mbim-cid.c |  2 +-
 2 files changed, 13 insertions(+), 10 deletions(-)

commit f967d117ce1a44cfe8121b5b09a5bb5d7838531e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 24 09:44:40 2018 +0200

    libmbim-glib,cid: fix QMI_MSG documentation

 src/libmbim-glib/mbim-cid.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit baa8dbc42c824a6d7e5a60cd096d8eb2c6f20f4e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jun 2 18:23:00 2018 +0200

    build: version bump to 1.17.1 to flag existence of new API

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2a97e39cdda125dd1b28ad7eef0f45f3646fc65e
Author: Ben Chan <benchan@chromium.org>
Date:   Fri Jun 1 19:44:14 2018 -0700

    libmbim-glib: add additional cause codes to MbimNwError

    This patch updates MbimNwError to include additional cause codes,
    which
    are related to PDP context activation, defined in the 3GPP TS 24.008
    specification section 6.1.3.1.3.1.

 src/libmbim-glib/mbim-enums.h | 92
 +++++++++++++++++++++++++++----------------
 1 file changed, 57 insertions(+), 35 deletions(-)

commit 2726ecd6c810fe9ccf030953893af9e90ec20073
Author: Lubomir Rintel <lkundrak@v3.sk>
Date:   Tue Apr 24 08:10:32 2018 +0200

    build: figure out the right Python provider for the build

    Python can be called python3, python2 or merely python, but we're
    fine with
    either.

 configure.ac                           |  2 ++
 src/libmbim-glib/generated/Makefile.am | 26 +++++++++++++-------------
 2 files changed, 15 insertions(+), 13 deletions(-)

commit 86e8e8cdd65a8a7b5bb40b04068358dc8ee5473f
Author: Lubomir Rintel <lkundrak@v3.sk>
Date:   Tue Apr 24 08:08:46 2018 +0200

    all: drop exec bit and shebang from Python modules

    Only the executables are supposed to possess those.

 build-aux/mbim-codegen/Message.py    | 1 -
 build-aux/mbim-codegen/ObjectList.py | 1 -
 build-aux/mbim-codegen/Struct.py     | 1 -
 build-aux/mbim-codegen/utils.py      | 1 -
 4 files changed, 4 deletions(-)

commit b2af1edd5c813c8b09491cbb09f4c38f0f00ff2e
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jan 31 21:56:41 2018 -0800

    mbimcli: longer timeout for '--disconnect' operation

 src/mbimcli/mbimcli-basic-connect.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2e99e5f8a8cf2e73cea971abae35731b80249941
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jan 31 21:56:40 2018 -0800

    libmbim-glib,message: handle unknown status when setting error

    g_set_error_literal() requires a non-NULL 'message' argument. Passing
    mbim_status_error_get_string() as the 'message' argument to
    g_set_error_literal() could result in an assertion as
    mbim_status_error_get_string() returns NULL for a status code
    without an
    associated MbimStatusError enum.

 src/libmbim-glib/mbim-message.c | 40
 ++++++++++++++++++++++++----------------
 1 file changed, 24 insertions(+), 16 deletions(-)

commit 18eb8aceede2092e4db61ef93caf94f0154c7bf7
Author: Dan Williams <dcbw@redhat.com>
Date:   Mon Jan 22 13:01:02 2018 -0600

    mbimcli: add "ip-type" property to --connect

 src/mbimcli/mbimcli-basic-connect.c | 64
 ++++++++++++++++++++++++++++---------
 1 file changed, 49 insertions(+), 15 deletions(-)

commit 156859daee873d7415c18620e0b5601d607c2f30
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 10:29:43 2018 +0100

    build: post release version bump to 1.17.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 16e15d49297f72397f6b691cf7a9ccf47bdae844
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 10:26:11 2018 +0100

    release: 1.16.0

    Updated libtool versioning for the stable release.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 1a1d9801e6bb5951aa53068d35357b15ff00851e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 10:24:08 2018 +0100

    Revert "build: post-release version bump to 1.17.0"

    This reverts commit 3134204465a2b13316bcbcf6c646b521c4389cec.

    Didn't bump libtool library versioning...

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3134204465a2b13316bcbcf6c646b521c4389cec
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 10:11:46 2018 +0100

    build: post-release version bump to 1.17.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bec91eb31bad02ef776a17115e6644ebbf26ffe0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 09:55:41 2018 +0100

    release: bump version to 1.16.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4097bddb60036b2e3560b24b9d16cc74ee3c91c9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 09:54:58 2018 +0100

    NEWS: update for 1.16.0

 NEWS | 42 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 42 insertions(+)

commit 232ad747ee3476e86a4e0af578f7899da7b01344
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 09:31:46 2018 +0100

    AUTHORS: update based on latest git stats

 AUTHORS | 17 ++++++++++++-----
 1 file changed, 12 insertions(+), 5 deletions(-)

commit 4bb9e85d9b16a9bf43c4705f02d4911f7f9207b1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 09:28:31 2018 +0100

    mbimcli,mbim-proxy,mbim-network: update copyright year to 2018

 src/mbim-proxy/mbim-proxy.c | 4 ++--
 src/mbimcli/mbimcli.c       | 2 +-
 utils/mbim-network.in       | 2 +-
 3 files changed, 4 insertions(+), 4 deletions(-)

commit 497b1a6298bd90e791920438e52457abbdcaa8b1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 10:01:07 2018 +0100

    build: ignore built test file

 .gitignore | 2 ++
 1 file changed, 2 insertions(+)

commit d57ef9cca58ef08e7e6471b396dbdd2c7fa89339
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 20 09:10:29 2018 +0100

    docs: update copyright year to 2018

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 1 +
 1 file changed, 1 insertion(+)

commit 2ee8bf11ad8fd16f0c36cb292be712e2b10c6fca
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 10 22:08:35 2018 +0100

    build: don't rebuild mbim-proxy-helpers

    They're already included in the non-inst core library.

 src/libmbim-glib/test/Makefile.am | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 810da895a4d7e722a9dae40578e52d12135e262b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jan 10 22:02:18 2018 +0100

    docs: add missing pieces to document the Intel Firmware Update service

 docs/reference/libmbim-glib/libmbim-glib-common.sections | 4 ++++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml        | 1 +
 2 files changed, 5 insertions(+)

commit 4128a33e9b08442853aa739070fec3a85c607a55
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jan 10 12:47:00 2018 -0800

    mbimcli: new '--intel-modem-reboot' action

 docs/man/Makefile.am                        |   1 +
 src/mbimcli/Makefile.am                     |   3 +-
 src/mbimcli/mbimcli-intel-firmware-update.c | 159
 ++++++++++++++++++++++++++++
 src/mbimcli/mbimcli.c                       |   8 ++
 src/mbimcli/mbimcli.h                       |   4 +
 5 files changed, 174 insertions(+), 1 deletion(-)

commit d2ae618dd598fb05d42c914ef74ba09c6b80b032
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jan 10 12:46:59 2018 -0800

    intel-firmware-update: add support for Intel Firmware Update service

 data/Makefile.am                                       |  3 ++-
 data/mbim-service-intel-firmware-update.json           | 11 +++++++++++
 docs/reference/libmbim-glib/Makefile.am                |  3 ++-
 .../libmbim-glib/libmbim-glib-common.sections          |  2 ++
 src/libmbim-glib/generated/Makefile.am                 | 18
 +++++++++++++++---
 src/libmbim-glib/libmbim-glib.h                        |  1 +
 src/libmbim-glib/mbim-cid.c                            | 12 ++++++++++++
 src/libmbim-glib/mbim-cid.h                            | 12 ++++++++++++
 src/libmbim-glib/mbim-uuid.c                           | 13 +++++++++++++
 src/libmbim-glib/mbim-uuid.h                           | 11 +++++++++++
 src/libmbim-glib/test/test-uuid.c                      |  8 ++++++++
 11 files changed, 89 insertions(+), 5 deletions(-)

commit bf3a6ab8e01ecf9ee7494aade4bcbd59c1e71c3f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 22:12:10 2017 -0700

    libmbim-glib,device: port transactions to GTask

 src/libmbim-glib/mbim-device.c | 464
 ++++++++++++++++++++++-------------------
 1 file changed, 248 insertions(+), 216 deletions(-)

commit b9a684084f753e9025f16b4c4fbf40d92a63c3e3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Aug 19 12:35:11 2017 +0200

    mbim-proxy: port internal device open to GTask

 src/libmbim-glib/mbim-proxy.c | 83
 +++++++++++++++++++++----------------------
 1 file changed, 40 insertions(+), 43 deletions(-)

commit 0cd2280bf5912c84f817e4a0b1c5a889ac65583b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Sep 14 07:02:11 2017 -0700

    build: add missing gtk-doc.m4

    Fixes: 9ef8723927c28d731e8f4041e45fb4df6c919a0b

 m4/gtk-doc.m4 | 88
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 88 insertions(+)

commit 7becf366e78a71778232ca636f7677bd00ea2a00
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 18:25:22 2017 +0200

    build: generate ChangeLog from git during dist

 Makefile.am | 14 ++++++++++++++
 autogen.sh  |  1 -
 2 files changed, 14 insertions(+), 1 deletion(-)

commit e50f84f3fc499042939a190994127bd7718953ce
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 18:13:39 2017 +0200

    doc,atds: avoid redefining MbimAtdsProvider documentation

    MbimAtdsProvider is a struct and is already documented in the ATDS
    service doc.

 docs/reference/libmbim-glib/libmbim-glib-common.sections | 1 -
 1 file changed, 1 deletion(-)

commit 6ec653bc83c364ff24145d348bfbfbd771ab31e3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 17:55:43 2017 +0200

    libmbim-glib,uuid: also document internal enum value

    Just to make gtk-doc happy really.

 src/libmbim-glib/mbim-uuid.h | 1 +
 1 file changed, 1 insertion(+)

commit 040f3b43ffd50ed932b66e7ebd361bb94eec34a9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 17:49:00 2017 +0200

    build: the m4 directory always exists

    Even when cloning a git checkout, as we have m4/compiler-warnings
    under version control.

 autogen.sh | 1 -
 1 file changed, 1 deletion(-)

commit 9ef8723927c28d731e8f4041e45fb4df6c919a0b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 17:32:43 2017 +0200

    build: import gtk-doc support

    Remove the need to run `gtkdocize' when building from git; this should
    be an operation done by the maintainer when modernizing the gtk-doc
    setup (think of e.g. gettextize), no need to do it unconditionally.

    This makes it easier for platforms without gtk-doc to build from git.

    When trying to build with documentation enabled and gtk-doc isn't
    found, we get some nice warnings and errors in the configure report:

        checking for gtk-doc... no
        configure: WARNING:
          You will not be able to create source packages with 'make dist'
          because gtk-doc >= 1.0 is not found.
        checking for gtkdoc-check... no
        checking for gtkdoc-check... no
        checking for gtkdoc-rebase... no
        checking for gtkdoc-mkpdf... no
        checking whether to build gtk-doc documentation... yes
        configure: error:
          You must have gtk-doc >= 1.0 installed to build documentation
          for
          ModemManager. Please install gtk-doc or disable building the
          documentation by adding '--disable-gtk-doc' to './configure'.

    Files generated with gtkdocize (gtk-doc) 1.26.1.

 .gitignore   |   1 -
 autogen.sh   |   1 -
 gtk-doc.make | 302
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 302 insertions(+), 2 deletions(-)

commit 4f0f3f85cdab90635bbf58e17bc1dc91fc7f06af
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 13 17:02:59 2017 +0200

    api: don't use intermediate variables for deprecation warnings

    Using an intermediate constant variable breaks compilation with C
    compilers, as these variables cannot be used as initializers.

    Instead, define a deprecated type and cast all deprecated symbols to
    that type. We lose the information about what the new replacement
    symbol is, but we don't break compilation.

    Also, add MBIM_DISABLE_DEPRECATED guards around deprecated symbols. So
    that when this symbol is defined, e.g. via CFLAGS, building a program
    that uses the libmbim API will fail if the program references
    deprecated symbols. For now we just use it to keep gtk-doc-scan happy
    and avoid unnecessary warnings.

    Equivalent to ModemManager commits eedd4ab4457 and f0bb6ef856.

 docs/reference/libmbim-glib/Makefile.am            |  2 +-
 .../libmbim-glib/libmbim-glib-common.sections      |  3 +++
 src/libmbim-glib/mbim-compat.c                     |  4 ++++
 src/libmbim-glib/mbim-compat.h                     | 22
 ++++++++++++++--------
 4 files changed, 22 insertions(+), 9 deletions(-)

commit 7626a0784b602ea01192a068c745a21bd9095781
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 6 17:08:10 2017 +0200

    device: detect already open MBIM channel on EM7345

    If we try to 'MBIM open' the channel with a Sierra Wireless EM7345
    (FIH7160_V1.1_MODEM_01.1349.12) and the channel is already open in the
    device (e.g. mbim-proxy crashed and we try to reopen, or just running
    consecutive mbimcli commands with --no-close), the device returns a
    'MBIM close done' message for every 'MBIM open' request we send.

    We update the logic to try to detect this case, and if we do, we
    launch an explicit 'MBIM close' operation before retrying the 'MBIM
    open' again.

    E.g. this is the flow when trying to run mbimcli command while the
    MBIM channel is already open in the device side:

        $ mbimcli -d /dev/cdc-wdm1 --query-device-caps --no-close
        --verbose
        [06 ago 2017, 16:58:21] [Debug] opening device...
        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Queried max
        control message size: 512
        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Sent message...
        <<<<<< RAW:
        <<<<<<   length = 16
        <<<<<<   data   = 01:00:00:00:10:00:00:00:01:00:00:00:00:02:00:00

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 16
        <<<<<<   type        = open (0x00000001)
        <<<<<<   transaction = 1
        <<<<<< Contents:
        <<<<<<   max_control_transfer = 512

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Received
        message...
        >>>>>> RAW:
        >>>>>>   length = 16
        >>>>>>   data   = 02:00:00:80:10:00:00:00:02:00:00:00:00:00:00:00

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] No transaction
        matched in received message
        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Received
        unexpected message (translated)...
        >>>>>> Header:
        >>>>>>   length      = 16
        >>>>>>   type        = close-done (0x80000002)
        >>>>>>   transaction = 2
        >>>>>> Contents:
        >>>>>>   status error = 'None' (0x00000000)

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Sent message...
        <<<<<< RAW:
        <<<<<<   length = 12
        <<<<<<   data   = 02:00:00:00:0C:00:00:00:02:00:00:00

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 12
        <<<<<<   type        = close (0x00000002)
        <<<<<<   transaction = 2

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Received
        message...
        >>>>>> RAW:
        >>>>>>   length = 16
        >>>>>>   data   = 02:00:00:80:10:00:00:00:02:00:00:00:00:00:00:00

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Sent message...
        <<<<<< RAW:
        <<<<<<   length = 16
        <<<<<<   data   = 01:00:00:00:10:00:00:00:03:00:00:00:00:02:00:00

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 16
        <<<<<<   type        = open (0x00000001)
        <<<<<<   transaction = 3
        <<<<<< Contents:
        <<<<<<   max_control_transfer = 512

        [06 ago 2017, 16:58:21] [Debug] [/dev/cdc-wdm1] Received
        message...
        >>>>>> RAW:
        >>>>>>   length = 16
        >>>>>>   data   = 01:00:00:80:10:00:00:00:03:00:00:00:00:00:00:00

        [06 ago 2017, 16:58:21] [Debug] MBIM Device at '/dev/cdc-wdm1'
        ready

 src/libmbim-glib/mbim-device.c | 114
 +++++++++++++++++++++++++++++++++++++++--
 src/libmbim-glib/mbim-errors.h |   6 ++-
 2 files changed, 115 insertions(+), 5 deletions(-)

commit 9aef2e779dbec73d3740ef5281a9f1487cf84307
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 6 17:08:09 2017 +0200

    device: open timeout check in main state machine

    Lets check if the operation timed out on the main state machine,
    instead of when the open command response is processed. This will
    allow us to queue up new steps sending/receiving messages and have
    a single place to check the timeout for all of them.

 src/libmbim-glib/mbim-device.c | 39
 ++++++++++++++++++++++++---------------
 1 file changed, 24 insertions(+), 15 deletions(-)

commit 417b0b80023dc30d61c111ec0a54da2884d3a541
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Sep 11 09:31:03 2017 +0200

    mbim-device: prefer realpath() to canonicalize_file_name()

    Usually the canonicalize_file_name() GNU extension is preferred to the
    POSIX realpath(), as it covers some of the limitations the latter has.
    But this extension isn't available in lots of platforms or in other
    c library implementations (e.g. musl), so just default to the POSIX
    method to improve portability.

    Note that the check for canonicalize_file_name() availability during
    configure isn't as trivial as adding a new AC_CHECK_FUNCS(), and
    importing a gnulib module seems overkill just for this one liner.

 src/libmbim-glib/mbim-device.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5bb673fe87ff9462bdec6435487d57982f886968
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 6 13:13:40 2017 +0200

    device: avoid signals sent to the mbim-proxy process

    If e.g. mbim-proxy is started by ModemManager and we send a Ctrl+C to
    it, the signal would be propagated to the mbim-proxy process and we
    would kill it right away, while leaving ModemManager still around
    wondering why the socket to the proxy got a HUP.

    Avoid this, by making sure the mbim-proxy gets its own process group.

 src/libmbim-glib/mbim-device.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit cd65ee939cbc95de7ee50e1fd3756c35fddaa41f
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Aug 7 13:40:19 2017 -0700

    mbimcli: new '--query-pin-list' action

    This patch adds a new '--query-pin-list' action to mbimcli for
    querying
    the list of PINs supported by a MBIM device and additional details for
    each PIN type.

 src/mbimcli/mbimcli-basic-connect.c | 116
 ++++++++++++++++++++++++++++++++++++
 1 file changed, 116 insertions(+)

commit 2fbfb74c14ebea038aa08186af7ccaa37ee633dd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jul 30 17:42:03 2017 +0200

    mbim-proxy: avoid double-free of 'opening device info' struct

    When the device is gone while an open() operation is ongoing, we're
    completing and freeing the 'opening device info' struct, but we didn't
    remove it from the private info, so when device_open_ready() happened,
    we were trying to complete and free it again.

    Avoid this issue by making sure no already-freed structs are kept in
    the private info, and also allowing device_open_ready() to get called
    without a valid pending 'opening device info'.

        [30 Jul 2017, 15:24:33] [Debug] [/dev/cdc-wdm0] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 16
        <<<<<<   type        = open (0x00000001)
        <<<<<<   transaction = 1
        <<<<<< Contents:
        <<<<<<   max_control_transfer = 4096

        [30 Jul 2017, 15:24:38] [Debug] [/dev/cdc-wdm0] Sent message...
        <<<<<< RAW:
        <<<<<<   length = 16
        <<<<<<   data   = 01:00:00:00:10:00:00:00:02:00:00:00:00:10:00:00

        [30 Jul 2017, 15:24:38] [Debug] [/dev/cdc-wdm0] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 16
        <<<<<<   type        = open (0x00000001)
        <<<<<<   transaction = 2
        <<<<<< Contents:
        <<<<<<   max_control_transfer = 4096

        [30 Jul 2017, 15:24:42] [Debug] [/dev/cdc-wdm0] unexpected
        port hangup!
        [30 Jul 2017, 15:24:42] [Debug] Client (7) connection closed...
        [30 Jul 2017, 15:24:42] -Warning ** error opening device: Device
        is gone
        [30 Jul 2017, 15:24:43] [Debug] open operation timed out: closed
        ==24404== Invalid read of size 8
        ==24404==    at 0x4E4A673: peek_opening_device_info (in
        /usr/lib/libmbim-glib.so.4.2.0)
        ==24404==    by 0x4E4BD7B: device_open_ready (in
        /usr/lib/libmbim-glib.so.4.2.0)
        ==24404==    by 0x50CAF61: g_simple_async_result_complete (in
        /usr/lib/libgio-2.0.so.0.3707.0)
        ==24404==    by 0x50CB028: complete_in_idle_cb (in
        /usr/lib/libgio-2.0.so.0.3707.0)
        ==24404==    by 0x5602EEA: g_main_context_dispatch (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x5603207: g_main_context_iterate.isra.13 (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x56035D1: g_main_loop_run (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x4010F8: main (in /usr/lib/mbim-proxy)
        ==24404==  Address 0x6d3bfe0 is 0 bytes inside a block of size
        16 free'd
        ==24404==    at 0x4C2A0C0: free (in
        /usr/lib/valgrind/vgpreload_memcheck-amd64-linux.so)
        ==24404==    by 0x4E4AC21: untrack_device (in
        /usr/lib/libmbim-glib.so.4.2.0)
        ==24404==    by 0x5395392: _g_closure_invoke_va (in
        /usr/lib/libgobject-2.0.so.0.3707.0)
        ==24404==    by 0x53A805D: g_signal_emit_valist (in
        /usr/lib/libgobject-2.0.so.0.3707.0)
        ==24404==    by 0x53A8A51: g_signal_emit (in
        /usr/lib/libgobject-2.0.so.0.3707.0)
        ==24404==    by 0x4E49424: data_available (in
        /usr/lib/libmbim-glib.so.4.2.0)
        ==24404==    by 0x5602EEA: g_main_context_dispatch (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x5603207: g_main_context_iterate.isra.13 (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x56035D1: g_main_loop_run (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x4010F8: main (in /usr/lib/mbim-proxy)
        ==24404==  Block was alloc'd at
        ==24404==    at 0x4C2B3D0: malloc (in
        /usr/lib/valgrind/vgpreload_memcheck-amd64-linux.so)
        ==24404==    by 0x5607B00: g_malloc (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x5617E12: g_slice_alloc (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x5618385: g_slice_alloc0 (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x4E4B1A9: internal_open (in
        /usr/lib/libmbim-glib.so.4.2.0)
        ==24404==    by 0x4E4BAC5: device_new_ready (in
        /usr/lib/libmbim-glib.so.4.2.0)
        ==24404==    by 0x50CAF61: g_simple_async_result_complete (in
        /usr/lib/libgio-2.0.so.0.3707.0)
        ==24404==    by 0x50CB028: complete_in_idle_cb (in
        /usr/lib/libgio-2.0.so.0.3707.0)
        ==24404==    by 0x5602EEA: g_main_context_dispatch (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x5603207: g_main_context_iterate.isra.13 (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x56035D1: g_main_loop_run (in
        /usr/lib/libglib-2.0.so.0.3707.0)
        ==24404==    by 0x4010F8: main (in /usr/lib/mbim-proxy)
        ==24404==

 src/libmbim-glib/mbim-proxy.c | 26 +++++++++++++++++---------
 1 file changed, 17 insertions(+), 9 deletions(-)

commit c689c7700545feb16381a2e892fa1e00a4d54ee8
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Jul 31 23:47:45 2017 -0700

    mbimcli: make output more consistent in capitalization

 src/mbimcli/mbimcli-basic-connect.c | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit f2f87bf2b9811ba7fa593ac2ab9852693cef08c2
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Jul 31 10:50:34 2017 -0700

    build: add other source files that affect the output of --help-all

 docs/man/Makefile.am | 5 +++++
 1 file changed, 5 insertions(+)

commit f2c2df8e4879920923b0423f92ec2a66fbee054d
Author: Ben Chan <benchan@chromium.org>
Date:   Sat Jul 29 01:37:34 2017 -0700

    mbimcli: show unknown CID name as "unknown" instead of "(null)"

 src/mbimcli/mbimcli-basic-connect.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cf3c041f590a00b739c1b7eb145642c5ccc80185
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Jul 27 19:45:55 2017 -0700

    mbimcli: new '--query-ip-packet-filters' action

    This patch adds a new '--query-ip-packet-filters' action to mbimcli
    for
    querying the IP packet filters currently set up on a MBIM device.

 src/mbimcli/Makefile.am             |   2 +
 src/mbimcli/mbimcli-basic-connect.c | 116
 +++++++++++++++++++++++++++++++++++-
 2 files changed, 117 insertions(+), 1 deletion(-)

commit 44c7593c716ac321d6b2640a86fce34e41d8fbb6
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Jul 27 19:45:54 2017 -0700

    mbim-common,test: add unit tests for mbim_common_str_hex

 configure.ac                  |  1 +
 src/common/Makefile.am        |  2 +-
 src/common/test/Makefile.am   | 17 ++++++++++++++
 src/common/test/test-common.c | 54
 +++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 73 insertions(+), 1 deletion(-)

commit 8e64510e706d7192ec9e0db6c506d05beda9820c
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Jul 27 19:45:53 2017 -0700

    mbim-common: turn __mbim_utils_str_hex into mbim_common_str_hex

    __mbim_utils_str_hex is a useful utility method for returning
    a hexadecimal
    string representation of a sequence of bytes in memory. This patch
    turns it
    into 'mbim_common_str_hex', which can be shared between libmbim-glib
    and
    mbimcli.

 configure.ac                                 |  7 ++++
 src/Makefile.am                              |  2 +-
 src/common/Makefile.am                       | 15 +++++++
 src/common/mbim-common.c                     | 61
 ++++++++++++++++++++++++++++
 src/common/mbim-common.h                     | 31 ++++++++++++++
 src/libmbim-glib/Makefile.am                 |  2 +
 src/libmbim-glib/mbim-device.c               | 15 +++----
 src/libmbim-glib/mbim-utils.c                | 36 ----------------
 src/libmbim-glib/mbim-utils.h                |  3 --
 src/libmbim-glib/test/Makefile.am            |  4 ++
 src/libmbim-glib/test/test-message-builder.c |  6 +--
 src/libmbim-glib/test/test-message-parser.c  |  6 +--
 12 files changed, 135 insertions(+), 53 deletions(-)

commit 0e2ad4993ebcbcbc52ca0b0cc13a65ecfcbd81c8
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 18:44:53 2017 -0700

    mbimcli: make 'session_id' variables consistently guint32

    This patch updates the code to consistently use guint32, instead of
    guint, for 'session_id' variables as SessionId is UINT32.

 src/mbimcli/mbimcli-basic-connect.c | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

commit 06dd18bff47f94cb5a4ddadca414cec8bb3858d4
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 18:44:52 2017 -0700

    mbimcli,ms-firmware-id: fix memory leaks

 src/mbimcli/mbimcli-ms-firmware-id.c | 1 +
 1 file changed, 1 insertion(+)

commit 79010dab08f7a44c94e47dbe5e403cdeda3c6321
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 18:44:51 2017 -0700

    mbimcli,basic-connect: fix memory leaks

 src/mbimcli/mbimcli-basic-connect.c | 13 +++++++++++++
 1 file changed, 13 insertions(+)

commit 716c4850b9c2c4bdaa07f18fdf364bdf0719786b
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 18:44:50 2017 -0700

    mbimcli,atds: fix memory leaks

 src/mbimcli/mbimcli-atds.c | 2 ++
 1 file changed, 2 insertions(+)

commit a1cf1e233fef337a58a2a991a00b1b099a6f2b02
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 18:44:49 2017 -0700

    mbimcli,phonebook: fix memory leaks

 src/mbimcli/mbimcli-phonebook.c | 3 +++
 1 file changed, 3 insertions(+)

commit 8abc5808262cc3048983457d367533c786a19656
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 18:44:48 2017 -0700

    mbimcli,phonebook: add missing return statement in
    set_phonebook_delete_ready

    When mbim_message_phonebook_delete_response_parse fails,
    set_phonebook_delete_ready should shutdown with a failure status and
    return.

 src/mbimcli/mbimcli-phonebook.c | 2 ++
 1 file changed, 2 insertions(+)

commit 752855389c8fc7f23e74f2e9e4224dee4e28362d
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 11:33:29 2017 -0700

    mbimcli: ensure 'cancellable' in Context is always initialized

    As the Context struct is allocated via g_slice_new and its
    'cancellable' field
    is only set when a GCancellable is provided, there is no guarantee
    that the
    cancellable field is always initialized. This patch fixes the code
    to always
    initialize the cancellable field of the Context struct.

 src/mbimcli/mbimcli-atds.c             | 3 +--
 src/mbimcli/mbimcli-basic-connect.c    | 3 +--
 src/mbimcli/mbimcli-dss.c              | 3 +--
 src/mbimcli/mbimcli-ms-firmware-id.c   | 3 +--
 src/mbimcli/mbimcli-ms-host-shutdown.c | 3 +--
 src/mbimcli/mbimcli-phonebook.c        | 3 +--
 6 files changed, 6 insertions(+), 12 deletions(-)

commit 221ab6581f589ed720419c7459e6ae597ead4e05
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 00:35:58 2017 -0700

    mbimcli: wire up cancellable for query-ip-configuration action

 src/mbimcli/mbimcli-basic-connect.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 519b0815b11de2b7c441024ef4a05b76cde40d02
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jul 26 00:10:00 2017 -0700

    mbimcli,dss: fix a potential memory leak in set_dss_ready

 src/mbimcli/mbimcli-dss.c | 2 ++
 1 file changed, 2 insertions(+)

commit fc81452adabe554e2493aa1dda2af0ef0eaea184
Author: Ben Chan <benchan@chromium.org>
Date:   Tue Jul 25 23:42:34 2017 -0700

    mbimcli: avoid calling mbim_message_unref on NULL MbimMessage

 src/mbimcli/mbimcli-basic-connect.c | 1 -
 1 file changed, 1 deletion(-)

commit 242e7f738bcc7589dc08c901771a90e35f4ef738
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 18 11:12:45 2017 +0200

    mbim-device: plug memleak

        ==21554== 64 bytes in 1 blocks are definitely lost in loss record
        2,960 of 4,396
        ==21554==    at 0x4C2E10F: realloc (in
        /usr/lib/valgrind/vgpreload_memcheck-amd64-linux.so)
        ==21554==    by 0x644E0CF: g_realloc (in
        /usr/lib/libglib-2.0.so.0.5200.2)
        ==21554==    by 0x6469C06: ??? (in
        /usr/lib/libglib-2.0.so.0.5200.2)
        ==21554==    by 0x6469F94: g_string_insert_len (in
        /usr/lib/libglib-2.0.so.0.5200.2)
        ==21554==    by 0x64345E1: ??? (in
        /usr/lib/libglib-2.0.so.0.5200.2)
        ==21554==    by 0x643585A: g_build_path (in
        /usr/lib/libglib-2.0.so.0.5200.2)
        ==21554==    by 0x57C25E2: get_descriptors_filepath
        (mbim-device.c:837)
        ==21554==    by 0x57C267A: read_max_control_transfer
        (mbim-device.c:921)
        ==21554==    by 0x57C2F89: create_iochannel_with_socket
        (mbim-device.c:1161)
        ==21554==    by 0x57C2C06: wait_for_proxy_cb (mbim-device.c:1073)
        ==21554==    by 0x6449332: ??? (in
        /usr/lib/libglib-2.0.so.0.5200.2)
        ==21554==    by 0x64488B4: g_main_context_dispatch (in
        /usr/lib/libglib-2.0.so.0.5200.2)

 src/libmbim-glib/mbim-device.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 47c8b0b7e71ad208496c290e564406803276b816
Author: Ben Chan <benchan@chromium.org>
Date:   Wed Jun 28 08:28:21 2017 -0700

    libmbim-glib: make gtk-doc work again on deprecated enumerators

    Commit e5b6807d6 "libmbim-glib: fix G_DEPRECATED_FOR annotations"
    replaced macro defintions with `static const int' definitions
    for those
    deprecated enumerators. However, gtk-doc doesn't seem to document
    `static const int' defintions. This patch works around the issue by
    adding a macro defintion on top of a `static const int' defintion.

 src/libmbim-glib/mbim-compat.h | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 5f5680f7b604771f8e9f4145e2a2bb41d9bb85a8
Author: Dan Williams <dcbw@redhat.com>
Date:   Wed Jun 28 10:57:26 2017 -0500

    mbimcli: make ATDS commands consistent with other subsystems

 src/mbimcli/mbimcli-atds.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 1f86135579311bb22d391bde39024f8fb1d014b8
Author: Dan Williams <dcbw@redhat.com>
Date:   Tue Apr 18 15:47:25 2017 -0500

    atds: add AT&T Device Service implementation

    See
    https://code.wireshark.org/review/gitweb?p=wireshark.git;a=blob;f=epan/dissectors/packet-mbim.c

    ATDS/Operators seems to be the same as BasicConnect/VisibleProviders
    except that
    CellularClass has been replaced with a "Provider PLMN Mode".

    ATDS/RegisterState seems to be exactly the same as
    BasicConnect/RegisterState if
    the Wireshark dissector is to be believed.

    Doesn't implement ATDS/SetProjectionTables yet.

 data/Makefile.am                                   |   3 +-
 data/mbim-service-atds.json                        | 147 +++++++++
 docs/reference/libmbim-glib/Makefile.am            |   3 +-
 .../libmbim-glib/libmbim-glib-common.sections      |  17 ++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml  |   1 +
 src/libmbim-glib/generated/Makefile.am             |  18 +-
 src/libmbim-glib/libmbim-glib.h                    |   1 +
 src/libmbim-glib/mbim-cid.c                        |  18 ++
 src/libmbim-glib/mbim-cid.h                        |  20 ++
 src/libmbim-glib/mbim-enums.h                      |  36 +++
 src/libmbim-glib/mbim-uuid.c                       |  13 +
 src/libmbim-glib/mbim-uuid.h                       |  11 +
 src/mbimcli/Makefile.am                            |   3 +-
 src/mbimcli/mbimcli-atds.c                         | 336
 +++++++++++++++++++++
 src/mbimcli/mbimcli.c                              |   8 +
 src/mbimcli/mbimcli.h                              |   4 +
 16 files changed, 633 insertions(+), 6 deletions(-)

commit e5b6807d6f2a8488878cd1cc1530f3b3fd92a2ec
Author: Ben Chan <benchan@chromium.org>
Date:   Tue Jun 27 23:37:43 2017 -0700

    libmbim-glib: fix G_DEPRECATED_FOR annotations

    mbim-compat.h defines a few deprecated enumerators as an alias
    to their
    equivalence using macros and annotates those macros with
    G_DEPRECATED_FOR, which may be expanded to
    `__attribute__((deprecated))'.

    Neither gcc nor clang supports `__attribute__((deprecated))'
    on macros.
    Thus, a G_DEPRECATED_FOR annotation before a macro definition is
    actually associated with the next identifier found after the macro
    definition, which is incorrect.

    Alternatively, the G_DEPRECATED_FOR annotation can be used on the
    deprecated enumerators. But only gcc 6 or above supports enumerator
    attributes.

    To address the issue, this patch defines the deprecated enumerators as
    `static const int' values, which can then be annotated with
    G_DEPRECATED_FOR.

 src/libmbim-glib/mbim-compat.h | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 895d9847e461cb03d9772a2a60f863f4265d1506
Author: Ben Chan <benchan@chromium.org>
Date:   Tue Jun 27 00:15:01 2017 -0700

    libmbim-glib: add MBIM_READY_INFO_FLAG_NONE to MbimReadyInfoFlag

    According to MBIM spec Rev 1.0 Errata-1 Table 10-17, a value 0 of the
    ReadyInfo field in MBIM_SUBSCRIBER_READY_INFO refers to
    MBIMReadyInfoFlagsNone and indicates that the device is in normal
    mode.

    This patch adds MBIM_READY_INFO_FLAG_NONE (0) to the MbimReadyInfoFlag
    enum, such that `mbimcli --query-subscriber-ready-info` shows 'Ready
    info' as 'none' instead of 'unknown' when the ReadyInfo field is 0.

 src/libmbim-glib/mbim-enums.h | 2 ++
 1 file changed, 2 insertions(+)

commit b6e03a03906b6b4d632b41f2039f4f62311278fc
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Jun 26 20:58:22 2017 -0700

    glib: remove invocations of g_type_init()

    g_type_init() has been deprecated (and also marked with the attribute
    'deprecated') since glib 2.36 as the type system is automatically
    initialized. Since the minimum version of glib required by libmbim is
    2.36, calling g_type_init() isn't necessarily in the libmbim code.

 src/mbim-proxy/mbim-proxy.c | 4 ----
 src/mbimcli/mbimcli.c       | 4 ----
 2 files changed, 8 deletions(-)

commit e34fde1e097ed56506b64a1abe66774038ffde2b
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Jun 22 04:21:04 2017 -0700

    build: only define WITH_UDEV if enabled

 configure.ac                   | 1 -
 src/libmbim-glib/mbim-device.c | 4 ++--
 2 files changed, 2 insertions(+), 3 deletions(-)

commit 9896cdad8a027fba76965d81f9e61622ed0d80ea
Author: Jaroslav Stepanek <xstej70@gmail.com>
Date:   Mon Jun 5 13:50:04 2017 +0200

    mbim-network: add support for short help switch

    https://bugs.freedesktop.org/show_bug.cgi?id=101279

 utils/mbim-network.in | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 4148d2d9de1b62b86cd62414856a5c388a3f5f25
Author: Ben Chan <benchan@chromium.org>
Date:   Tue May 2 06:27:13 2017 -0700

    libmbim-glib,device: port create_iochannel to use GTask

 src/libmbim-glib/mbim-device.c | 163
 +++++++++++++++++++++--------------------
 1 file changed, 83 insertions(+), 80 deletions(-)

commit 205dc3b36f3ffac2fa6addc0110e3ab4d3c42f3a
Author: Ben Chan <benchan@chromium.org>
Date:   Tue May 2 06:27:12 2017 -0700

    libmbim-glib,device: port mbim_device_close to use GTask

 src/libmbim-glib/mbim-device.c | 53
 ++++++++++++++++++------------------------
 1 file changed, 22 insertions(+), 31 deletions(-)

commit 01fbb01748754185e715af01d03169c4d155d6ca
Author: Ben Chan <benchan@chromium.org>
Date:   Tue May 2 06:27:11 2017 -0700

    libmbim-glib,device: port mbim_device_open_full to use GTask

 src/libmbim-glib/mbim-device.c | 159
 ++++++++++++++++++++++-------------------
 1 file changed, 84 insertions(+), 75 deletions(-)

commit 50f359fbe8edc84dcfa8c13873e8f0bbf6e79bd3
Author: Ben Chan <benchan@chromium.org>
Date:   Tue May 2 06:27:10 2017 -0700

    libmbim-glib,device: port initable_init_async to use GTask

 src/libmbim-glib/mbim-device.c | 70
 +++++++++++++++---------------------------
 1 file changed, 24 insertions(+), 46 deletions(-)

commit ef772d671785d42fdb550ef9b064d210d43ba78a
Author: Ben Chan <benchan@chromium.org>
Date:   Mon Apr 24 10:48:40 2017 -0700

    build: require glib 2.36

    We want to start using new features like GTask, which is available in
    GLib 2.36.

 configure.ac | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 6c78817ecde8c0d303783b53d1137410e7900826
Author: Carlo Lobrano <c.lobrano@gmail.com>
Date:   Thu Mar 23 11:58:58 2017 +0100

    libmbim-glib,device: misplaced trace_transaction

    Moved trace_transaction with error message in the right context.

 src/libmbim-glib/mbim-device.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit cad5a59e4edab65a0f477eec858e5eab99762452
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Mar 8 14:12:09 2017 +0100

    docs: update copyright year to 2017

 docs/reference/libmbim-glib/libmbim-glib-docs.xml | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 27592d6c104a8fa034107f96bca40218336a1c12
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 8 23:32:40 2017 +0100

    libmbim-glib,device: destroy channel when closed

 src/libmbim-glib/mbim-device.c | 4 ++++
 1 file changed, 4 insertions(+)

commit bc21faa7a2567415035499e19221fa6826349d3f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 8 21:29:44 2017 +0100

    libmbim-glib: return NULL on method returning string

    No big deal anyway due to the g_assert_not_reached(), so just to make
    compilers happy.

 src/libmbim-glib/mbim-cid.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ec84b21414ab1b86f23564650ff5a9dead1faf27
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 8 21:21:26 2017 +0100

    libmbim-glib: allow printing cid from invalid service

    E.g. to avoid warnings like this:

        [08 feb 2017, 21:15:45] -Error ** mbim_cid_get_printable:
        assertion 'service > MBIM_SERVICE_INVALID' failed
        [08 feb 2017, 21:15:45] [Debug] [/dev/cdc-wdm1] Received message
        (translated)...
        >>>>>> Header:
        >>>>>>   length      = 48
        >>>>>>   type        = command-done (0x80000003)
        >>>>>>   transaction = 2
        >>>>>> Fragment header:
        >>>>>>   total   = 1
        >>>>>>   current = 0
        >>>>>> Contents:
        >>>>>>   status error = 'NoDeviceSupport' (0x00000009)
        >>>>>>   service      = 'invalid'
        (00000000-0000-0000-0000-000000000000)
        >>>>>>   cid          = '(null)' (0x00000001)

 src/libmbim-glib/mbim-cid.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit d2cd0a2a2feb64548c9d3d2b2e1d781b652fd4eb
Author: Ben Chan <benchan@chromium.org>
Date:   Thu Feb 2 16:46:09 2017 -0800

    glib: guard invocations of g_type_init()

    g_type_init() has been deprecated (and also marked with the attribute
    'deprecated') since glib 2.36 as the type system is automatically
    initialized. Since the minimum version of glib required by libmbim is
    2.32, calling g_type_init() should be guarded with the
    GLIB_CHECK_VERSION macro. When libmbim later requires at least glib
    2.36, we can completely remove all invocations of g_type_init()
    from the
    code.

 src/mbim-proxy/mbim-proxy.c | 2 ++
 src/mbimcli/mbimcli.c       | 2 ++
 2 files changed, 4 insertions(+)

commit f5a34e57f6c543e893366c987402b9d4a56d96b0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 1 23:20:19 2017 +0100

    Revert "libmbim-glib,device: plug memleak in open timeout"

    This reverts commit f6249fee1710484a749a5b919ca130d36d64eb2d.

    Oops...

 src/libmbim-glib/mbim-device.c | 1 -
 1 file changed, 1 deletion(-)

commit f6249fee1710484a749a5b919ca130d36d64eb2d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 1 23:05:40 2017 +0100

    libmbim-glib,device: plug memleak in open timeout

 src/libmbim-glib/mbim-device.c | 1 +
 1 file changed, 1 insertion(+)

commit 8286e0b93f742295d0fcdfae655d97fe7bb0dcf4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 15 23:47:56 2017 +0100

    libmbim-glib,device: fix segfault when cancellable already cancelled

    The g_cancellable_connect() method will also call the given callback
    when the input cancellable is already cancelled. This means that the
    cancellation callback should also handle the case where the
    transaction
    hasn't been stored in the tracking table yet.

    Thanks to Benoît Donnette <benoit.donnette@21net.com> for the
    report and
    the suggested fix.

    This is the port of the same bugfix from libqmi, see:
    https://bugs.freedesktop.org/show_bug.cgi?id=98283

 src/libmbim-glib/mbim-device.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 878e089d70814dcc5e39566bd0842697ee4b3364
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 25 14:48:32 2016 +0100

    mbimcli: use g_clear_object() to cleanup cancellable after async
    operation

 src/mbimcli/mbimcli.c | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit ceb68e763672f096f8ef33d44db3db1dc2d5222e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 25 14:43:55 2016 +0100

    mbimcli: use g_unix_signal_add() to setup signals

    So that we can safely call GLib/GIO functions from within the signal
    handlers.

 src/mbimcli/mbimcli.c | 32 +++++++++++++++++---------------
 1 file changed, 17 insertions(+), 15 deletions(-)

commit 5d2acdaf9a0064e56bfe6479e153a1c44b0db1dc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 25 14:24:16 2016 +0100

    mbimcli: fix second ctrl+c handling in mbimcli

    A single ctrl+c cancels the GCancellable, and the second ctrl+c should
    have stopped the GMainLoop, but that was never happening.

 src/mbimcli/mbimcli.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5c3935b75fc4dd46bc469e18aabb312e74b5915d
Author: Dan Williams <dcbw@redhat.com>
Date:   Tue Oct 4 09:28:02 2016 -0500

    libmbim-glib: add MBIM_STATUS_ERROR_CONTEXT_NOT_SUPPORTED

    From the MBIM 1.0 specification Errata 1 document.

    http://www.usb.org/developers/docs/devclass_docs/MBIM10Errata1_073013.zip

 src/libmbim-glib/mbim-errors.h | 2 ++
 1 file changed, 2 insertions(+)

commit 4fed3fffe64bec88b5052d30df0257cd65abf5fe
Author: Dan Williams <dcbw@redhat.com>
Date:   Mon Aug 1 13:05:06 2016 -0500

    mbim-codegen: fix message name in generated code doc for parse
    functions

    At the point where the codegen happens, {name} is the name of the last
    function argument, not of the message.  Also fix up the documentation
    to
    say "Parses and returns parameters" instead of "Create a new request"
    since
    parsing doesn't create any requests.

    New: * Parses and returns parameters of the 'Signal State'
    notification command in the 'Basic Connect' service.
    Old: * Create a new request for the 'ErrorRateThreshold' notification
    command in the 'Basic Connect' service.

 build-aux/mbim-codegen/Message.py | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit badcf2a4d6e3462143cd555f05dbe2f3723d7ce6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 22 12:36:52 2016 +0200

    mbim-network: fix bashisms when checking arguments

 utils/mbim-network.in | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 6f87e17cd57bd735711349711ccf30b8746c2fcb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 13 11:36:11 2016 +0200

    libmbim-glib,message: avoid iconv()

    There are systems out there that come with a fake iconv()
    implementation that
    don't support translations to/from UTF-16LE. We can easily avoid
    that by using
    the built-in translations to UTF-16HE provided by GLib itself,
    we just need to
    take care of converting from HE to/from LE.

 src/libmbim-glib/mbim-message.c | 74
 +++++++++++++++++++++++++----------------
 1 file changed, 45 insertions(+), 29 deletions(-)

commit 79bdd9f1e782c27858b9c32f300f4fb4e6b12558
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 5 12:00:34 2016 +0200

    build: post release version bump to 1.15.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 50cddf48823f05ec124afad80c0d948184e19b00
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 5 11:26:18 2016 +0200

    release: bump version to 1.14.0

 configure.ac | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 7804a99d6dbb16967beb67edd3644d56b9972092
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 5 11:19:42 2016 +0200

    build: update NEWS

 NEWS | 41 +++++++++++++++++++++++++++++++++++++++++
 1 file changed, 41 insertions(+)

commit 6cc33e0985428f2b1bc9c87ab59a9792d104cc64
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 6 22:25:42 2016 +0200

    docs: add missing documentation for the qmi-over-mbim service

 docs/reference/libmbim-glib/Makefile.am                  | 3 ++-
 docs/reference/libmbim-glib/libmbim-glib-common.sections | 6 ++++++
 docs/reference/libmbim-glib/libmbim-glib-docs.xml        | 1 +
 3 files changed, 9 insertions(+), 1 deletion(-)

commit 05ba9dc1136bf92bb276f34df315584b6a51bfb4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 6 15:11:06 2016 +0200

    libmbim-glib,message: internal helper to apply padding

 src/libmbim-glib/mbim-message.c | 55
 ++++++++++++++++++++++-------------------
 1 file changed, 30 insertions(+), 25 deletions(-)

commit 809418e9026368acc9d3d5ffd6f2c585b6a3cd59
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 6 14:57:54 2016 +0200

    libmbim-glib,message: minor coding style fix

 src/libmbim-glib/mbim-message.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c86109b6006b851475c53ab8fee1b7b5c76c04b0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 6 14:55:33 2016 +0200

    libmbim-glib,cid: user helpers symbols to define cid capabilities

 src/libmbim-glib/mbim-cid.c | 98
 ++++++++++++++++++++++++---------------------
 1 file changed, 53 insertions(+), 45 deletions(-)

commit b8b36aedfeea3e274f3b8a633e176bb1e8428370
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 6 14:50:37 2016 +0200

    libmbim-glib,uuid: define MBIM_SERVICE_LAST in internal compilation
    only

 src/libmbim-glib/mbim-cid.c  | 12 +++++-------
 src/libmbim-glib/mbim-uuid.c |  8 +++-----
 src/libmbim-glib/mbim-uuid.h |  6 ++++--
 3 files changed, 12 insertions(+), 14 deletions(-)

commit 7f5300b98b8011bb64bbf8b6dd66697ba37dece5
Author: Emil Ljungdahl <emil.ljungdahl@wisi.se>
Date:   Wed Apr 6 19:25:27 2016 +0200

    Avoid affecting the padding behavior for other services than QMI

 build-aux/mbim-codegen/Message.py       |  9 +++++----
 build-aux/mbim-codegen/Struct.py        |  9 +++++----
 data/mbim-service-qmi.json              |  6 ++++--
 src/libmbim-glib/mbim-message-private.h |  4 ++--
 src/libmbim-glib/mbim-message.c         | 10 +++++-----
 5 files changed, 21 insertions(+), 17 deletions(-)

commit 7733044d69ba54906dc26ea98747f1a3c32d7264
Author: Emil Ljungdahl <emil.ljungdahl@wisi.se>
Date:   Wed Apr 6 19:16:47 2016 +0200

    Added json file lost in original qmi-over-mbim patch

 data/mbim-service-qmi.json | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 7bf40d20b8afc071de26c77b9c0b668fcb799b90
Author: Collin McMillan <cmc@nd.edu>
Date:   Mon Apr 4 11:33:46 2016 +0200

    QMI via MBIM

    Signed-off-by: Bjørn Mork <bjorn@mork.no>

 build-aux/mbim-codegen/Message.py       |  8 ++++----
 build-aux/mbim-codegen/Struct.py        |  8 ++++----
 data/Makefile.am                        |  3 ++-
 src/libmbim-glib/generated/Makefile.am  | 18 +++++++++++++++---
 src/libmbim-glib/libmbim-glib.h         |  1 +
 src/libmbim-glib/mbim-cid.c             | 25 +++++++++++++++++++++----
 src/libmbim-glib/mbim-cid.h             | 12 ++++++++++++
 src/libmbim-glib/mbim-message-private.h |  2 ++
 src/libmbim-glib/mbim-message.c         | 25 ++++++++++++++++---------
 src/libmbim-glib/mbim-uuid.c            | 18 ++++++++++++++++--
 src/libmbim-glib/mbim-uuid.h            | 11 +++++++++++
 11 files changed, 104 insertions(+), 27 deletions(-)

commit a0578e5e15228999d1215df1bdadfb8774c5ecc3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 1 10:46:50 2016 +0200

    mbimcli: allow passing empty APN in --connect

 src/mbimcli/mbimcli-basic-connect.c | 38
 +++++++++++++++++--------------------
 1 file changed, 17 insertions(+), 21 deletions(-)

commit 3f4e777e4a2af7fcf8b020accb8949d0bcd91c5b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 1 10:24:00 2016 +0200

    mbimcli: allow querying IP configuration out of the connection attempt

 src/mbimcli/mbimcli-basic-connect.c | 112
 +++++++++++++++++++++++++-----------
 1 file changed, 79 insertions(+), 33 deletions(-)

commit bcf3f09df4e8a765fae9d462dc087f3de619fde4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 30 10:05:53 2016 +0200

    mbim-network: allow using the mbim-proxy setup

 utils/mbim-network.in | 32 ++++++++++++++++++++++----------
 1 file changed, 22 insertions(+), 10 deletions(-)

commit 9eaf56e87ecd715ab9922e17b700dd5804884263
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 30 10:00:40 2016 +0200

    mbim-network: allow specifying APN user/password in profile

 utils/mbim-network.in | 54
 ++++++++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 51 insertions(+), 3 deletions(-)

commit 506052b608c0ee55b27cb69028b7606de3fb5927
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 30 09:38:57 2016 +0200

    mbim-network: use standard checks for empty variables

 utils/mbim-network.in | 28 ++++++++++++++--------------
 1 file changed, 14 insertions(+), 14 deletions(-)

commit c252c998ea5c1516e2c2d30220c265e56a8dcfb7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 30 09:35:16 2016 +0200

    mbim-network: allow loading profile from a different path

    This effectively makes mbim-network work with multiple devices in
    a single system.

 utils/mbim-network.in | 74
 +++++++++++++++++++++++++++++++++++++++++----------
 1 file changed, 60 insertions(+), 14 deletions(-)

commit 202349ce952712cd37415d91b5511491f0769d65
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Apr 11 22:22:33 2016 +0200

    build: add missing GUDEV_CFLAGS and GUDEV_LIBS

    https://bugs.freedesktop.org/show_bug.cgi?id=94881

 src/libmbim-glib/Makefile.am | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 82b7cd5013bcff0c05dd91e6a7f9bbfbf3e53d0d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Apr 10 13:53:53 2016 +0200

    build: really make gudev not mandatory

 configure.ac | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit cbab0ef37331702feb9a9eeca3f33395cba76e57
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Apr 10 13:11:56 2016 +0200

    build: make gudev optional

    There's really not much benefit on a hard build-dependency on gudev
    if we're
    just using it to get the path of the descriptors path, so provide
    an alternate
    implementation for now just using sysfs paths, and make gudev
    selection auto.

 configure.ac                   |  33 ++++++++++++
 src/libmbim-glib/mbim-device.c | 119
 ++++++++++++++++++++++++++++++++++-------
 2 files changed, 133 insertions(+), 19 deletions(-)

commit f1c3a97ab9e6577ec2bfd0aa4572800589b747fb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Apr 10 00:00:47 2016 +0200

    build: update configure report

 configure.ac | 19 +++++++++++++------
 1 file changed, 13 insertions(+), 6 deletions(-)

commit d2a1a7f82ba01114f33113f97fc5a884a4a1a988
Author: Philip Withnall <philip@tecnocode.co.uk>
Date:   Sun Mar 20 17:57:56 2016 +0000

    build: Run configure script from builddir rather than srcdir

    If building from a clean git clone with builddir ≠ srcdir,
    the configure
    script is (correctly) generated in builddir by autoconf. Execute
    it from
    there, rather than from the srcdir, so that all the configure products
    (Makefiles, etc.) are generated in the builddir.

    https://bugs.freedesktop.org/show_bug.cgi?id=94639

 autogen.sh | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit e2b3db1a10ba7dd73eea4e96faeec126629b7c19
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Oct 10 14:56:32 2015 +0200

    mbimcli: avoid shadowing 'dup'

 src/mbimcli/mbimcli-helpers.c | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit bc15bede4aeca0651a5c85fb54d407453e7d5af8
Author: Shih-Yuan Lee (FourDollars) <sylee@canonical.com>
Date:   Thu Sep 24 16:32:41 2015 +0800

    libmbim-glib: Increase the retry interval to 5 seconds.

    Sierra Mobile Broadband EM7455 won't work while the retry interval is
    only one second.

    https://bugs.freedesktop.org/show_bug.cgi?id=91189

    Signed-off-by: Shih-Yuan Lee (FourDollars) <sylee@canonical.com>

 src/libmbim-glib/mbim-device.c | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 6cf74ebfae1dccf807bb34d88f2cd024d4b14da7
Author: David Ward <david.ward@ll.mit.edu>
Date:   Wed Sep 9 18:54:53 2015 -0400

    mbimcli: fix username/password checks with the '--connect' action

    Fixes: 4e58451a744dbc3f086e9c1dd2d7469ff70d50ef ("mbimcli: add
    support for Basic Connect session IDs")
    Signed-off-by: David Ward <david.ward@ll.mit.edu>

 src/mbimcli/mbimcli-basic-connect.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fd222fc1ee05c2c0c2c21bddec65b9b02f0bc718
Author: Dan Williams <dcbw@redhat.com>
Date:   Wed Sep 9 12:12:32 2015 -0500

    mbimcli: fix parsing --query-connection-state and --disconnect args
    after 4e58451

    From f6d10eb69eefeb190c9349fdbd3a23b0e838913e Mon Sep 17 00:00:00 2001
    From: Dan Williams <dcbw@redhat.com>
    Date: Wed, 9 Sep 2015 12:06:00 -0500
    Subject: [PATCH] mbimcli: fix parsing --query-connection-state and
     --disconnect args after 4e58451

    Fixes: 4e58451a744dbc3f086e9c1dd2d7469ff70d50ef ("mbimcli: add
    support for Basic Connect session IDs")
    Reported-by: David Ward

 src/mbimcli/mbimcli-basic-connect.c | 34
 ++++++++++++++++++++++++++++++++--
 1 file changed, 32 insertions(+), 2 deletions(-)

commit 4e58451a744dbc3f086e9c1dd2d7469ff70d50ef
Author: Dan Williams <dcbw@redhat.com>
Date:   Mon Aug 17 12:19:05 2015 -0500

    mbimcli: add support for Basic Connect session IDs

    --query-connection-state=[SessionID]
    --disconnect=[SessionID]
    --connect=["key=value,..."]

    As part of enabling session IDs, we must also convert --connect
    over to a key=value format for all its arguments, but still
    preserve backwards compat with the old format.

 src/mbimcli/mbimcli-basic-connect.c | 284
 ++++++++++++++++++++++++++++--------
 src/mbimcli/mbimcli-helpers.c       | 148 +++++++++++++++++++
 src/mbimcli/mbimcli-helpers.h       |  10 ++
 3 files changed, 385 insertions(+), 57 deletions(-)

commit 8b6316667b438bb2aa99c8029f95542d74ee7136
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 5 12:54:33 2015 +0200

    mbimcli: longer timeout for '--connect' operation

 src/mbimcli/mbimcli-basic-connect.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 44d5aac6044f02241de4ea94df0d57fc4487adb9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 5 12:54:16 2015 +0200

    mbimcli: longer timeout for '--[attach|detach]-packet-service'
    operations

 src/mbimcli/mbimcli-basic-connect.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3affee76e17eca6b51eaa6682f9683e4fb565ee3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 1 08:09:02 2015 +0200

    mbimcli: longer timeout for '--register-automatic' operation

 src/mbimcli/mbimcli-basic-connect.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d939587ef7fff0195a45fb8418d2911dfbb52c99
Author: Dan Williams <dcbw@redhat.com>
Date:   Mon May 4 11:23:00 2015 -0500

    mbimcli: report IP configuration on connect

 src/mbimcli/mbimcli-basic-connect.c |  65 ++++++++++++++++-
 src/mbimcli/mbimcli-dss.c           |  86 ++++++++++++++++++----
 src/mbimcli/mbimcli-helpers.c       | 142
 ++++++++++++++++++++++++++++++++++++
 src/mbimcli/mbimcli-helpers.h       |   4 +
 4 files changed, 280 insertions(+), 17 deletions(-)

commit 0ad5f9ce6269b73e6bc8d0d5821ed7059f17b2ff
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 25 13:18:41 2015 +0100

    libmbim-glib,message: allow building messages of custom services

    Once a service has been registered, we should allow users of the
    library to
    actually build Command messages with the new service.

    https://bugs.freedesktop.org/show_bug.cgi?id=77225

 src/libmbim-glib/mbim-message.c      |  3 +--
 src/libmbim-glib/test/test-message.c | 45
 ++++++++++++++++++++++++++++++------
 2 files changed, 39 insertions(+), 9 deletions(-)

commit 9d2435448912fe9af86369def253f558c49db272
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Feb 25 13:17:42 2015 +0100

    libmbim-glib,uuid: don't assert if service id is neither generic
    nor registered

    Just warn and return NULL.

 src/libmbim-glib/mbim-uuid.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 8b08e300a26d8f596cdd0aabb70dca6d295954fa
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Feb 23 20:01:52 2015 +0100

    mbim-network: improved --help output with more detailed information

 utils/mbim-network.in | 26 +++++++++++++++++++++++---
 1 file changed, 23 insertions(+), 3 deletions(-)

commit 8423c70340fb2a13c0f7824a86aed25a8d12f78c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 25 21:21:27 2015 +0100

    mbimcli: add command completion

    https://bugs.freedesktop.org/show_bug.cgi?id=87901

 src/mbimcli/Makefile.am        | 12 ++++++
 src/mbimcli/mbimcli-completion | 83
 ++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 95 insertions(+)

commit 688b094d3c56408fd6d8d202099ada294839b168
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 17 19:34:01 2015 +0100

    mbim-proxy: block function error signals when checking if device is
    opened or not

 src/libmbim-glib/mbim-proxy.c | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 9d8acbe9e5edbb1fb9bfdbc47d5fda1631578523
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 17 19:12:11 2015 +0100

    mbim-proxy: upon new client, always check if device really open with
    a command

    Never assume that mbim_device_is_open() will return the valid open
    status of the
    real device. If we're in the middle of a suspend/resume cycle,
    the logic will
    think that the session is open, while in reality it may not be.

    To really make sure that we're open, explicitly send a Command
    message to the
    device, and react on the possible NotOpened error by re-opening the
    device right
    away.

 src/libmbim-glib/mbim-proxy.c | 129
 +++++++++++++++++++++++++++++++++---------
 1 file changed, 102 insertions(+), 27 deletions(-)

commit 7ab8135fb2970db32bfd0cfcc170f690e1409a2a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 17 18:32:42 2015 +0100

    mbim-device: trace transaction status within the MbimDevice

 src/libmbim-glib/mbim-device.c | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit 8a8104a9b5952a451b6346b6a188815f3ea0a508
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 17 18:31:53 2015 +0100

    mbim-device: explictly maintain a reference to the MbimDevice in
    the transaction

    We were already doing this as g_simple_async_result_new() was taking
    one itself,
    so this is just to make the code clearer and to ease next changes.

 src/libmbim-glib/mbim-device.c | 3 +++
 1 file changed, 3 insertions(+)

commit 732918344d9994f9e87ec77ff3a052710ec84629
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 17 18:37:18 2015 +0100

    mbim-device: only return transaction if it gets released

    And avoid segfault in weird situations....

    E.g. if we send Open(3) and we get Close-Done(3) (as with a Telit
    LN930 device)
    the logic  was segfaulting. The reason being that
    device_release_transaction()
    was returning a valid Transaction (that with ID 3) but wasn't being
    released
    from the internal HT (as we were asking for Open-Done, not Close-Done
    or Invalid).

        [17 ene 2015, 18:09:23] [Debug] [/dev/cdc-wdm0,3] transaction
        open: store
        [17 ene 2015, 18:09:23] [Debug] [/dev/cdc-wdm0] Sent message...
        <<<<<< RAW:
        <<<<<<   length = 16
        <<<<<<   data   = 01:00:00:00:10:00:00:00:03:00:00:00:00:02:00:00

        [17 ene 2015, 18:09:23] [Debug] [/dev/cdc-wdm0] Sent message
        (translated)...
        <<<<<< Header:
        <<<<<<   length      = 16
        <<<<<<   type        = open (0x00000001)
        <<<<<<   transaction = 3
        <<<<<< Contents:
        <<<<<<   max_control_transfer = 512

        [17 ene 2015, 18:09:23] [Debug] [/dev/cdc-wdm0] Received
        message...
        >>>>>> RAW:
        >>>>>>   length = 16
        >>>>>>   data   = 02:00:00:80:10:00:00:00:03:00:00:00:00:00:00:00

        [17 ene 2015, 18:09:23] [Debug] [/dev/cdc-wdm0,3] transaction
        open: complete: error
        [17 ene 2015, 18:09:23] [Debug] getting open done result failed:
        closed
        [17 ene 2015, 18:09:23] [Debug] Client (6) connection closed...
        [17 ene 2015, 18:09:23] -Warning ** error opening device:
        Unexpected response message type: 0x80000002
        **
        Mbim:ERROR:mbim-device.c:2205:finalize: assertion failed:
        (g_hash_table_size (self->priv->transactions[i]) == 0)

        Program received signal SIGABRT, Aborted.
        0x00007ffff6f56a97 in raise () from /usr/lib/libc.so.6
        (gdb) bt
        #0  0x00007ffff6f56a97 in raise () from /usr/lib/libc.so.6
        #1  0x00007ffff6f57e6a in abort () from /usr/lib/libc.so.6
        #2  0x00007ffff73357f5 in g_assertion_message () from
        /usr/lib/libglib-2.0.so.0
        #3  0x00007ffff733588a in g_assertion_message_expr () from
        /usr/lib/libglib-2.0.so.0
        #4  0x00007ffff7bb44c3 in finalize (object=0x617100) at
        mbim-device.c:2205
        #5  0x00007ffff75e925a in g_object_unref () from
        /usr/lib/libgobject-2.0.so.0
        #6  0x00007ffff7bb4bd7 in client_set_device (client=0x607300,
        device=0x0) at mbim-proxy.c:172
        #7  0x00007ffff7bb4cd8 in client_unref (client=0x607300)
        at mbim-proxy.c:199
        #8  0x00007ffff7bb522f in request_complete_and_free
        (request=0x613350) at mbim-proxy.c:369
        #9  0x00007ffff7bb59d1 in proxy_config_internal_device_open_ready
